angular.module('starter.directives', [])

.directive('twitterDirective', function($rootScope, $http, $timeout){
    //console.log("directive called");
  var directiveDefinitionObject = {
    link: function postLink(scope, iElement, iAttrs) { 
              var playerNickname= $rootScope.overhauledSquadList[$rootScope.player_selected].nickname;
                 console.log(iElement);
                 var screen_name="";
                for(var i=0; i<playerNickname.length; i++){
                    if(playerNickname[i].type=="twitter_screen_name"){
                        screen_name=playerNickname[i].value;
                    }
                 }
                 
                  if(screen_name != ""){
        
                     twttr.widgets.createTimeline(
                      "616997630745387008",
                     iElement[0],
                      {
                        screenName: screen_name
                      }).then(function (el) {
                        console.log("Embedded a timeline.");
                        twttr.widgets.load(iElement[0]);
                        //console.log($("#twitterContent iframe contentDocument"));
                        var links=document.getElementById("twitterContent").getElementsByTagName("iframe")[0].contentDocument.getElementsByTagName("a");
                        for (var i=0;i<links.length;i++){
                            links[i].onclick= function(){return false;};
                        }
                      });
                  }else{
            
                     iElement[0].innerHTML= "<div style='position:absolute;top:45%;font-size:18px;font-weight:bold;text-align:center;width:80%;left:10%;'>No twitter available</div>";
                  }
        
    }
  };
  return directiveDefinitionObject;
           
})

.directive('videosDirective', function($rootScope){
    
    var directiveDefinitionObject = {
    link: function postLink(scope, iElement, iAttrs) {
        var playerId= $rootScope.player_selected;
        if($rootScope.squadVideos == undefined){
            try{
                $rootScope.squadVideos=JSON.parse(window.localStorage.squadVideos)
            }catch(e){
                $rootScope.squadVideos={};
            }
        }
        console.log($rootScope.squadVideos[playerId]);
        if($rootScope.squadVideos[playerId] != undefined){
            
        }else{
            iElement[0].innerHTML="<div style='position:absolute;top:45%;font-size:18px;font-weight:bold;text-align:center;width:80%;left:10%;'>No videos available for this player</div>";
        }
    }
        
    };
    return directiveDefinitionObject;
})

.directive('pollsDirective',function(){
    var directiveDefinitionObject = {
    link: function postLink(scope, iElement, iAttrs) {
        $.ajax({
                url:pollURL,
                type:'GET',
                
                success:function(data){
                   
                    iElement[0].innerHTML= data;
                   
                    $(iElement[0]).find('.wp-polls-loading').remove();
                    $(iElement[0]).find('a[href=#ViewPollResults]').parent().remove();
                    $(iElement[0]).find('#secondary').remove();
                    
                    $(iElement[0]).find("#masthead").remove();
                    $(iElement[0]).find("#colophon").remove();
                    $(iElement[0]).find(".entry-header").remove();
                    $(iElement[0]).fadeIn('slow');
                    //alert("done");
                    //console.log($(iElement[0]).find('#secondary'));
                    
                        
                    $('link[id="twentyfourteen-style-css"]')[0].disabled=true;
                }
        });
      }
    };
    return directiveDefinitionObject;
    
})

.directive('matchstatsDirective', function($rootScope){
    
    var directiveDefinitionObject = {
        link: function postLink(scope, iElement, iAttrs) {
            scope.$watch(function() {
               return $rootScope.MatchList_Statistics;
            }, function() {
                //console.log($rootScope.MatchList_Statistics);
                if(Object.keys($rootScope.MatchList_Statistics).length > 0){
                    
                     iElement[0].style.display="block";
                     scope.matchstats = $rootScope.MatchList_Statistics;
                }else{
                    console.log(iElement);
                   // iElement[0].innerHTML="<div style='position:absolute;top:45%;font-size:18px;font-weight:bold;text-align:center;width:80%;left:10%;'>No statistics availables for this match</div>";
                   iElement[0].style.display="none";
                }
            }, true);
        }
    };
    return directiveDefinitionObject;
});