/*-----------------------------------------------------------------------------------------------------/
  In this file, we can find global functions availables everywhere in the code,
  the variables below are linked to notifications events and are globals
/------------------------------------------------------------------------------------------------------*/

var fromBackground=false;
var onNewsEvent=false;
var onVideoEvent=false;
var onMatchEvent=false;
var onMvpEvent=false;
var onNotificationEvent=false;
var match_notified="";
var videoId="";


function AppAvailability(App){
		if (device.platform.toLowerCase() == "android") {  // ------ Android-----
			if(App == "fb"){  //Facebook availability
				if (typeof window.appAvailability !== 'undefined'){
					// appAvailability.check('fb://',  //iOS   //this one for phonegap 3.X and plugin 0.2.0 and higher(camlecase for higher version)
					appAvailability.check('com.facebook.katana', //Android
						function() { //success callback
							window.open('fb://page/'+fbID,'_system');
						},
						function() {	//failure callback
							window.open('https://facebook.com/'+fbID, '_parent');
						}
					);

				}else{
					window.open('https://facebook.com/'+fbID, '_parent');
				}
			}
			if(App == "tw"){ //Twitter Availability
				if (typeof window.appAvailability !== 'undefined'){
					// appAvailability.check('twitter://', //iOS
					appAvailability.check('com.twitter.android', //Android
						function() { //success callback
							window.open('https://twitter.com/'+twID, '_system');
						},
						function() {	//failure callback
							window.open('https://twitter.com/'+twID, '_parent');

						}
					);
				}else{
					window.open('https://twitter.com/'+twID, '_parent');
				}
			}
			if(App == "in"){ //Twitter Availability
				if (typeof window.appAvailability !== 'undefined'){
					// appAvailability.check('twitter://', //iOS
					appAvailability.check('com.instagram.android', //Android
						function() { //success callback
						 	window.open('instagram://user?username='+instLink, '_system');
						},
						function() {	//failure callback
							window.open('http://instagram.com/'+instLink, '_parent');
						}
					);
				}else{
					window.open('http://instagram.com/'+instLink, '_parent');
				}
			}
		}else{ // if in ---- iOS ----
			if(App == "fb"){  //Facebook availability
				if (typeof window.appAvailability !== 'undefined'){
					appAvailability.check('fb://',  //iOS   //this one for phonegap 3.X and plugin 0.2.0 and higher(camlecase for higher version)
					// appAvailability.check('com.facebook.katana', //Android
						function() { //success callback
							window.open('https://www.facebook.com/'+fbID, '_system');
						},

						function() {	//failure callback
							window.open('https://www.facebook.com/'+fbID, '_parent');
						}
					);
				}else{
					window.open('https://www.facebook.com/'+fbID, '_parent');
				}
			}
			if(App == "tw"){ //Twitter Availability
				if (typeof window.appAvailability !== 'undefined'){
					appAvailability.check('twitter://', //iOS
					// appAvailability.check('com.twitter.android', //Android
						function() { //success callback
							window.open('https://twitter.com/'+twID, '_system');
						},
						function() {	//failure callback
							window.open('https://twitter.com/'+twID, '_system');

						}
					);
				}else{
					window.open('https://twitter.com/'+twID, '_system');
				}
			}

			if(App == "in"){ //Twitter Availability
				if (typeof window.appAvailability !== 'undefined'){
					appAvailability.check('instagram://', //iOS
					// appAvailability.check('com.twitter.android', //Android
						function() { //success callback
							window.open('instagram://user?username='+instLink, '_system');
						},
						function() {	//failure callback
							window.open('http://instagram.com/'+instLink, '_parent');
						}
					);
				}else{
					window.open('http://instagram.com/'+instLink, '_parent');
				}
			}
		}
	}
function openInChildBrowser(url){
	window.open(url,'_parent');
}
	
function checkNavigator(){
				var xhr = new XMLHttpRequest();
				var url = "https://www.youfoot.com/checkNetworkWithHeaders.php";
				
				xhr.open('GET', url, false);
				try {
					xhr.send();
					if (xhr.status >= 200 && xhr.status < 304) {
						 console.log("online");
						 device_online=true;
						return true;
					} else {
					    device_online=false;    
						return false;
					}
				} catch(e) {
				    device_online=false;
					return false;
				}
}

function onNotificationGCM (e){
    //alert("onNotificationGCM");
    //var self = this;
    switch(e.event){
    	
	  case 'registered':
		 if ( e.regid.length > 0 ){
			// Your GCM push server needs to know the regID before it can push to this device
			// here is where you might want to send it the regID for later use.
			window.localStorage.regid = e.regid;
		    sendRegistrationIdToBackEnd();
     	  }
    	break;
    	case 'message':
    		if(!e.coldstart && !e.foreground){
    		    onNotificationEvent=true;
    		    setTimeout("onNotificationEvent=false;",20000);
    		}
				// this is the actual push notification. its format depends on the data model
				// of the intermediary push server which must also be reflected in GCMIntentService.java
				
				if(e.payload.matchId !== undefined && e.payload.matchId.length !==0){ // if matchID IS defined
				   
				  if(e.payload.mvp !== undefined){
				  	if(!e.foreground){
				  		onMvpEvent=true;
				  		setTimeout("onMvpEvent=false;",20000);
				  		var match_id = e.payload.matchId;
				     	match_notified= match_id;
				  		if(! e.coldstart){  //if in background
						  fromBackground =true;
						  var scope=angular.element($("#appBody")).scope();
				          scope.changeLocation("home");
					    }
				  	}
				  }else{
					if (e.foreground){
					  
					}else{ // if not in foreground	
					    onMatchEvent=true;
				        setTimeout("onMatchEvent=false;",20000);
					    var match_id = e.payload.matchId;
				     	match_notified= match_id;
					   if(! e.coldstart){  //if in background
						  fromBackground =true;
						  //alert("going to home");
						  var scope=angular.element($("#appBody")).scope();
				          scope.changeLocation("home");
					   }					
					}
				  }
				  
				}else if(e.message.indexOf('#|# news')!== -1){
				
					if(!e.foreground){
				       onNewsEvent=true;
				       setTimeout("onNewsEvent=false;",20000);
				       if(!e.coldstart){
				       	  fromBackground=true;
                          var scope=angular.element($("#appBody")).scope();
				          scope.changeLocation("home");
				       }
			    	}
				}else if(e.message.indexOf('#|# videos')!== -1){
				    
					if (e.foreground){
					  
					}else{
						 onVideoEvent=true;
				    setTimeout("onVideoEvent=false;",20000);
                    videoId=e.payload.videoId;
						if(!e.coldstart){
						  fromBackground=true;
						  var scope=angular.element($("#appBody")).scope();
				          scope.changeLocation("home");	
						}
					}
				}
			break;

			case 'error':
						//alert('GCM error = '+e.msg);
						break;
			default:
						//alert('An unknown GCM event has occurred');
						break;
   }
}

function onNotificationAPN (event){
	
	    //alert("notifAPN");
		var message = {};
		if(event["foreground"]==0){
          
        }			 
		$.each(event,function(index , value){
			//alert(index);
			message[index] = value;
		});
		
		if( message["matchId"] !== undefined && message["teamId"] !== undefined){// && (message["body"].indexOf('Goal') !== -1 || message["body"].indexOf('kick off') !== -1  || message["body"].indexOf('red card') !== -1 || message["body"].indexOf('final score') !== -1 || message["body"].indexOf('BUT') !== -1  || message["body"].indexOf('penalty') !== -1)){
		    
		    
          
		     if(message["foreground"]==0){	
		       //var scope=angular.element($("#appBody")).scope();
			   //scope.changeLocation("home");
			 }else{
			    onMatchEvent=true;
		        setTimeout("onMatchEvent=false;",20000);
		    	var match_id =  message['matchId'];
		    	match_notified= match_id;  
			 }
		}else{
		    if(message["videoId"]!== undefined){
			   if( message["foreground"]==0){
			        onVideoEvent=true;
				    setTimeout("onVideoEvent=false;",20000);
                    videoId=message['videoId'];
			   }  
			}else if(message["news"] !== undefined){
			   //alert(message["foreground"]);
			   if (message["foreground"]==0){
			      onNewsEvent=true;
				  setTimeout("onNewsEvent=false;",20000);
			    }
			}
		}
	
}

function sendRegistrationIdToBackEnd(){
    
                
					//navigator.notification.alert('hi');
					if(window.localStorage.regid != undefined){ //for android
					   
						$.ajax({
								url : domain+'mobiles/deviceRegistar/device:'+device.uuid+'/regid:'+localStorage.regid+"/teamid:"+parent_venue+'/lang:'+lang,
								type: "GET",
								dataType:"json",
								error: function() {
													//alert('Registration problem...');
								},
								success:function (){
													// navigator.notification.alert(e.alert);
								}
						});
					}
					if(window.localStorage.token != undefined){ // for iOS

						$.ajax({
								url : domain+'/mobiles/tokenRegistar/token:'+localStorage.token+"/teamid:"+parent_venue+'/lang:'+lang,
								type: "GET",
								dataType:"jsonp",
								error: function() {
								},
								success:function (){
													// navigator.notification.alert(e.alert);
								}
						});
					}
					
}

function poll_ajax(url){
        $.ajax({
            url:pollURL+url,
            type:'GET',
            beforeSend:function(){
                $('#booth').html('Loading....');
            },
            success:function(data){
            	
                $('#booth').hide();
                $('#booth').html(data);
                $('#booth').find('.wp-polls-loading').remove();
                $('#booth').find('a[href=#ViewPollResults]').parent().remove();
                $("#booth").find("#secondary").remove();
                $("#booth").find("#masthead").remove();
                $("#booth").find("#colophon").remove();
                $("#booth").find(".entry-header").remove();
                $('#booth').fadeIn('slow');
            }
        });
}

function poll_vote(pollId){
        var pollAnswer = $("input:radio[name=poll_"+pollId+"]:checked").val();
        if(pollAnswer !== undefined && pollId !== undefined){
            poll_ajax('?poll_id='+pollId+'&poll_answer='+pollAnswer);                      
        }        
}

/*var islTeams={
	
	"5432b34c-df2c-4229-913a-25b30a00bcbb": "CFC",
	"5432a92a-5630-4ebb-92ef-36d60a00bcbb": "ADK",
	"5433eeb2-ac6c-4a09-a02a-48ac0a00bc97": "KBFC",
	"5433eed7-9c0c-437a-896d-5b3c0a00bc97":"NEUFC",
    "5432b662-4fcc-469d-b31e-63af0a00bcbb": "DDFC",
    "5434f72b-3b30-4b00-9d88-4c0e0a00bc97":"FCPC",
    "5433eec5-1748-4555-a28f-5b3e0a00bc97":"MCFC",
    "5432b9a9-28bc-4f09-849d-25070a00bcbb":"FCG"
}*/