
angular.module('starter.services', [])
.factory('LoadingService', function($http, $timeout, $rootScope){
        
  
        function LoadingService(){}
        
        LoadingService.prototype= {
        nextPageToken:"",
        initializeRSS: function(scope){
          
          var success=0;
          var patt= /http.*(jpg|png)/i;
		//itemImageLink= patt.exec(v['content']);
           if(! checkNavigator()){
              return ($timeout(function(){
                         scope.$broadcast("notconnected");
                         return false;
              },500));
           }
            if(rssFeed != undefined && rssFeed != ''){
              	var feed = new google.feeds.Feed(rssFeed);
              	feed.setResultFormat(google.feeds.Feed.MIXED_FORMAT);
              	feed.setNumEntries(10);
              	feed.load(function(result) {
                  	if (!result.error) { 
                  	    var items= [];
                  	    for (var i=0; i<result.feed.entries.length; i++){
                  	         var item={};
                  	         //console.log(result.feed.entries[i]);
                  	         item['title']=result.feed.entries[i]['title'];
                  	         item['content']= result.feed.entries[i]['content'];
                  	         item['date']=  result.feed.entries[i]['publishedDate'];
                  	         //item['author']=result.feed.entries[i]['author'];
                  	         item['link']=result.feed.entries[i]['link'];
                  	         if(result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0] != undefined){
                  	           item['imageLink']=result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0].getAttribute('url');
                  	         }else if(patt.exec(item['content']) != null){
              	               item['imageLink']= patt.exec(item['content'])[0];
                  	         }else{
                  	           item['imageLink']= 'img/newsplaceholder.png';
                  	         }
                  	         item['id']= i;
                  	         items[i]=item;
                  	    }
                  	   
                  		window.localStorage[ls_news]= JSON.stringify(items);
                  		success++;
                  		if(success == numberOfFeeds){
                  			scope.$broadcast('rssLoaded');
                  			return true;
                  		}
                  	    
                  	  }else{
                  	  	return false;
                      }
                 });
            }
          
          
          if(numberOfFeeds > 1){
            if(rssFeed2 != undefined && rssFeed2 != ''){
          
              	var feed2= new google.feeds.Feed(rssFeed2);
              	feed2.setResultFormat(google.feeds.Feed.MIXED_FORMAT);
              	feed2.setNumEntries(10);
                feed2.load(function(result) {
              	if (!result.error) { 
              	    var items= [];
              	    for (var i=0; i<result.feed.entries.length; i++){
              	         var item={};
              	         item['title']=result.feed.entries[i]['title'];
              	         item['content']= result.feed.entries[i]['content'];
              	         item['date']=  result.feed.entries[i]['publishedDate'];
              	         //item['author']=result.feed.entries[i]['author'];
              	         item['link']=result.feed.entries[i]['link'];
              	         if(result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0] != undefined){
              	           item['imageLink']=result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0].getAttribute('url');
              	         }else if(patt.exec(item['content']) != null){
              	             item['imageLink']= patt.exec(item['content'])[0];
              	         }else{
                  	       item['imageLink']= 'img/newsplaceholder.png';
                  	     }
              	         items[i]=item;
              	    }
              		window.localStorage[ls_news2]= JSON.stringify(items);
              		success++;
              		if(success== numberOfFeeds){
              			scope.$broadcast('rssLoaded');
              			return true;
              		}
              	}else{
              		return false;
              	}
              });
            }
          }
          
          if(numberOfFeeds > 2){
            if(rssFeed3 != undefined && rssFeed3 != ''){
          
              	var feed3= new google.feeds.Feed(rssFeed3);
              	feed3.setResultFormat(google.feeds.Feed.MIXED_FORMAT);
              	feed3.setNumEntries(10);
                feed3.load(function(result) {
              	if (!result.error) { 
              	    console.log(result.feed.entries);
              	    var items= [];
              	    for (var i=0; i<result.feed.entries.length; i++){
              	         var item={};
              	         item['title']=result.feed.entries[i]['title'];
              	         item['content']= result.feed.entries[i]['content'];
              	         item['date']=  result.feed.entries[i]['publishedDate'];
              	         //item['author']=result.feed.entries[i]['author'];
              	         item['link']=result.feed.entries[i]['link'];
              	         if(result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0] != undefined){
              	           item['imageLink']=result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0].getAttribute('url');
              	         }else if(patt.exec(item['content']) != null){
              	               item['imageLink']= patt.exec(item['content'])[0];
              	         }else{
                  	         item['imageLink']= 'img/newsplaceholder.png';
                  	     }
              	         items[i]=item;
              	    }
              		window.localStorage[ls_news3]= JSON.stringify(items);
              		success++;
              		if(success== numberOfFeeds){
              			scope.$broadcast('rssLoaded');
              			return true;
              		}
              	}else{
              		return false;
              	}
              });
            }
          }
          
           if(numberOfFeeds > 3){
            if(rssFeed4 != undefined && rssFeed4 != ''){
          
              	var feed4= new google.feeds.Feed(rssFeed4);
              	feed4.setResultFormat(google.feeds.Feed.MIXED_FORMAT);
              	feed4.setNumEntries(10);
                feed4.load(function(result) {
              	if (!result.error) { 
              	    var items= [];
              	    for (var i=0; i<result.feed.entries.length; i++){
              	         var item={};
              	         item['title']=result.feed.entries[i]['title'];
              	         item['content']= result.feed.entries[i]['content'];
              	         item['date']=  result.feed.entries[i]['publishedDate'];
              	         //item['author']=result.feed.entries[i]['author'];
              	         item['link']=result.feed.entries[i]['link'];
              	         if(result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0] != undefined){
              	           item['imageLink']=result.feed.entries[i].xmlNode.getElementsByTagName('enclosure')[0].getAttribute('url');
              	         }else if(patt.exec(item['content']) != null){
              	         item['imageLink']= patt.exec(item['content'])[0];
              	         }else{
                  	       item['imageLink']= 'img/newsplaceholder.png';
                  	     }
              	         items[i]=item;
              	    }
              		window.localStorage[ls_news4]= JSON.stringify(items);
              		success++;
              		if(success== numberOfFeeds){
              			scope.$broadcast('rssLoaded');
              			return true;
              		}
              	}else{
              		return false;
              	}
              });
            }
          }
      },
        SaveUserInformation:function(email,phoneNo){
            http({
                method: 'POST',
                url: serverURL+"/users/",
                data: {
                    email_id: email,
                    phone_no: phoneNo,
                    user_id:  $rootScope.Current_user
                }
            })
            .success(function(data, status, headers, config) {
                console.log(data);
                window.localStorage[ls_userdetailSaved]=true;
            });
        },
        getTeamLogoUrl:function(){
            $http({
                method: 'GET',
                url: WebserviceURL+"/team/info/"+tid2, //+tid,
                headers: {
                    'api_key' : api_key
                }
                
            })
            .success(function(data, status, headers, config) {
                console.log(data);
                $rootScope.team_logo= data.media_id;
                window.localStorage[ls_team_logo]= data.media_id;
            });
        },
        
        getTranslation: function(){   // will be used in future to get words from the server
            
            if(checkNavigator()){
            
            $.ajax({
                
                url:"http://dev5.preprod.youfoot.com/mobiles/mobileTranslation/lang:"+lang,
                dataType: "jsonp",
                async:false,
                success:function(data) {
                 setLanguage(data);
                },
                error:function(error){
                   
                    setLanguage(new Language(lang));
                }
                 
             });
            }else{
                setLanguage(new Language(lang));
            }
           
        },
        getPolls: function(){
            
            $.ajax({
                    url:pollURL,
                    type:'GET',
                    beforeSend:function(){
                        $('#booth').html('Loading....');
                    },
                    success:function(data){
                       // console.log(data);
                        //$('#booth').hide();
                        //$('#booth').html(data);
                        document.getElementById('booth').innerHTML= data;
                        
                        $('#booth').find('.wp-polls-loading').remove();
                        $('#booth').find('a[href=#ViewPollResults]').parent().remove();
                        $("#booth").find("#secondary").remove();
                        $("#booth").find("#masthead").remove();
                        $("#booth").find("#colophon").remove();
                        $("#booth").find(".entry-header").remove();
                        $('#booth').fadeIn('slow');
                        //alert("done");
                        
                        
                        $('link[id="twentyfourteen-style-css"]')[0].disabled=true;
                    }
                });
        },
    
        getVideos: function (scope, pageIndex){
       
        if(videoSite.toLowerCase() == "dailymotion"){
           $http.get("https://api.dailymotion.com/user/"+videoChannel+"/videos?limit=10&page="+pageIndex)
              .success(function(data, status, headers, config) {
                  
                  var videos= [];
                  for (var i=0; i<data.list.length;i++){
                    var video={};
                    video['id']=data.list[i]['id'];
                    video['title']=data.list[i]['title'];
                    video['thumbnail'] = "url(https://www.dailymotion.com/thumbnail/video/"+data.list[i]['id']+")";
                    videos[i]= video;
                  }
                  
                  window.localStorage[ls_videos]= JSON.stringify(videos);
                  scope.$broadcast("videosLoaded");
               })
              .error(function(data, status, headers, config) {
                 
              });  
        }else if (videoSite.toLowerCase() == "youtube"){

            $http.get("https://www.googleapis.com/youtube/v3/search?part=snippet&key=AIzaSyCR9Ykzj1oAlopcEA2ZvhOu72SY4RZ67h4&q="+ videoChannel)
            .success(function(data, status, headers, config) {
               
                var channelId= data.items[0].snippet.channelId;
                $http.get("https://www.googleapis.com/youtube/v3/channels?part=contentDetails&key=AIzaSyCR9Ykzj1oAlopcEA2ZvhOu72SY4RZ67h4&q&id="+channelId)
                .success(function(data, status, headers, config) {
                    //console.log(data);
                    var playlistId=window.localStorage[ls_playlistId]= data.items[0].contentDetails.relatedPlaylists.uploads;
                    $http.get("https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&playlistId="+playlistId+"&maxResults=10&key=AIzaSyCR9Ykzj1oAlopcEA2ZvhOu72SY4RZ67h4")
                    .success(function(data, status, headers, config) {
                        LoadingService.prototype.nextPageToken= data.nextPageToken;
                        var videos=[];
                        for (var i=0; i<data.items.length;i++){
                            var video={};
                            video['id']= data.items[i].snippet.resourceId['videoId'];
                            video['title']=data.items[i].snippet['title'];
                            video['thumbnail']="url("+data.items[i].snippet.thumbnails.high['url']+")";
                            video['date'] = data.items[i].snippet['publishedAt'];
                            videos[i]= video;
                        }
                        window.localStorage[ls_videos]= JSON.stringify(videos);
                        scope.$broadcast("videosLoaded");
                    });
                });
                    
            });
          
        }
      },
    
        getMoreVideos:function(scope){
          var playlistId= window.localStorage[ls_playlistId];
          //console.log(LoadingService.prototype.nextPageToken);
         $http.get("https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&playlistId="+playlistId+"&maxResults=10&key=AIzaSyCR9Ykzj1oAlopcEA2ZvhOu72SY4RZ67h4&pageToken="+LoadingService.prototype.nextPageToken)
            .success(function(data, status, headers, config) {
               
                if(data.items.length > 0){
                    var videos=[];
                    for (var i=0; i<data.items.length;i++){
                        var video={}
                        video['id']=data.items[i]['id'];
                        video['title']=data.items[i].snippet['title'];
                        video['thumbnail']= "url("+data.items[i].snippet.thumbnails.high['url']+")";
                        video['date'] = data.items[i].snippet['publishedAt'];
                        videos[i]= video;
                    }
                    //console.log(videos);
                    var previous = JSON.parse(window.localStorage[ls_videos]);
                    videos= previous.concat(videos);
                    window.localStorage[ls_videos]= JSON.stringify(videos);
                    
                }
                if(data.nextPageToken != undefined){
                   LoadingService.prototype.nextPageToken= data.nextPageToken;
                   
                }else{
                    scope.$broadcast("noMoreVideos");
                }
                 scope.$broadcast("moreVideosLoaded");
               
            })
             .error(function(data, status, headers, config) {
                 scope.$broadcast("moreVideosErrors");
             });
            
          
      },
      
        getSquad: function(scope,tid){
        
        // var year= new Date().getFullYear();
        //$httpProvider.defaults.headers.get = { 'api_key' : api_key };
        $http({
        method: 'GET',
        url: WebserviceURL+"/team/squad/"+tid+"/"+year,
        headers: {
         'api_key' : api_key
        }
        })
          .success(function(data, status, headers, config){
            
            window.localStorage[ls_squad]= JSON.stringify(data);
            // console.log(data);
            scope.$broadcast("SquadLoaded");
          })
          .error(function(data, status, headers, config){
            
          })
       },
       
        getSquadVideos:function(scope){
         
         var squad= JSON.parse(window.localStorage[ls_squad]);
         var squadList= squad.team.squad;
         var squadVideos={};
         var playersCount=0;
         for (var role in squadList){
            var obj =  squadList[role];
             for(var i=0;i <obj.length;i++){ 
               playersCount++;
             }
         }
         //console.log("count:" + playersCount);
         var count=0;
         var regex= /id=.*&/;
         for(var role in squadList){
             
             var obj =  squadList[role];
             for(var i=0;i <obj.length;i++){
                 var playerId= obj[i].id;
                //  var year= new Date().getFullYear();
   
                  $http({
                  method: 'GET',
                  url: WebserviceURL+"/media/video?model=player&id="+playerId+"&published="+year ,
                  headers: {
                   'api_key' : api_key
                  }
                  })
                    .success(function(data, status, headers, config){
                      var player= regex.exec(config.url)[0];
                      player= player.substr(3,36);
                      squadVideos[player]=data;
                      count++;
                      if(count== playersCount) {
                        window.localStorage[ls_squadVideos]= JSON.stringify(squadVideos);
                        scope.$broadcast("SquadVideosLoaded");
                      }
                    })
                    .error(function(data, status, headers, config){
                      count++;
                      if(count== playersCount){
                       window.localStorage[ls_squadVideos]= JSON.stringify(squadVideos);
                       scope.$broadcast("SquadVideosLoaded");
                      }
                    })
              }
          }
         
       },
       
        getSquadCareers: function(scope){
          
         var squad= JSON.parse(window.localStorage[ls_squad]);
         var squadList= squad.team.squad;
         var squadCareers={};
         var playersCount=0;
         for (var role in squadList){
            var obj =  squadList[role];
             for(var i=0;i <obj.length;i++){ 
               playersCount++;
            }
         }
         //console.log("count:" + playersCount);
         var count=0;
         for(var role in squadList){
             
             var obj =  squadList[role];
             for(var i=0;i <obj.length;i++){
                 var playerId= obj[i].id;
                //  var year= new Date().getFullYear();
           
           $http({
                  method: 'GET',
                  url: WebserviceURL+"/player/career/"+playerId,
                  headers: {
                    'api_key' : api_key
                  }
            })
             .success(function(data, status, headers, config){
                      var splitArray= config.url.split("/");
                      var player= splitArray[splitArray.length -1];
                     
                      squadCareers[player]=data;
                      count++;
                      if(count== playersCount) {
                        window.localStorage[ls_SquadCareers]= JSON.stringify(squadCareers);
                        scope.$broadcast("SquadCareersLoaded");
                      }
                    })
             .error(function(data, status, headers, config){
               count++;
               if(count== playersCount){
                 window.localStorage[ls_SquadCareers]= JSON.stringify(squadCareers);
                 scope.$broadcast("SquadCareersLoaded");
               }
             })
           }
         }
       },
       
        getTopMatchList:function(scope){
            
            // var year= new Date().getFullYear();
            //console.log(scope);
            $http({
                  method: 'GET',
                  url: WebserviceURL+"/team/calendar/"+tid+"/"+year, //+tid,
                  headers: {
                    'api_key' : api_key
                  }
            })
            .success(function(data, status, headers, config) {
                // console.log(data);
                // console.log(data.team.calendar);
                if(data.team.take_media_id) take_media_id= true;
                var topmatchlist = [];
                var match_list = data.team.calendar;
                var years = Object.keys(data.team.calendar);
                for(var i=0; i < years.length; i++){
                    for(var j=0; j < match_list[years[i]].length; j++){
                        topmatchlist.push(match_list[years[i]][j]);
                    }
                }
                // console.log(topmatchlist);
                window.localStorage[ls_topMatchlist]= JSON.stringify(topmatchlist);
                scope.$broadcast("topMatchListLoaded");
            })
            .error(function(data, status, headers, config) {
                 scope.$broadcast("topMatchListLoaded");
            });
        },
        
        getMatchDetails: function(match,scope){
            //alert(allStrings ? 3 + ((allStrings.length*16)/(8*1024)) + ' KB' : 'Empty (0 KB)');
            //alert(typeof window.localStorage[ls_topMatchlist]); 
            // console.log(match);
            if(checkNavigator()){ 
                if(typeof match == "string"){
                    matchId = match;
                    $http({
                        method: 'GET',
                        // url: "https://www.youfoot.com/mobiles/matchCom/matchId:"+matchId+"/year:"+year+"/teamId:"+tid+"/competitionId:"+compid+"/lang:en/venueId:"+venueId+"/type:iOS/version",
                        url: domain+"/api_ui/v2/match/commentary?mid="+matchId+"&lang="+lang, // Don not add callback
                        headers: {
                            'api_key' : api_key
                        },
                       
                    }).then( function(results){
                        // console.log(results);
                        // .success(function(data, status, headers, config){
                        // alert(results.status);
                        var config = results.config;
                        var key = "mid";
                        var name = key.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
                        var regex = new RegExp("[\\?&]" + name + "=([^&#]*)");
                        var result = regex.exec(config.url);
                        var result = null ? "" : decodeURIComponent(result[1].replace(/\+/g, " "));
                        // console.log(result);
                        if(results.data.match.coverphoto_home != null)
                            $rootScope.covers[result]= domain+'media/images/'+results.data.match.coverphoto_home+'/'+results.data.match.coverphoto_home.replace(/-/g,"")+"crop_h780w320.jpg"; 
                        else if (results.data.venue.coverphoto_home != null)
                            $rootScope.covers[result]= domain+'media/images/'+results.data.venue.coverphoto_home+'/'+results.data.venue.coverphoto_home.replace(/-/g,"")+"crop_h780w320.jpg";
                        else
                            $rootScope.covers[result]=  "http://www.youfoot.com/img/cover/cover-match.png";//domain+"/media/images/52bc35c7-cea4-4dd2-b225-30c4dfbdb49f/52bc35c7cea44dd2b22530c4dfbdb49fcrop_h780w320.jpg";
                        $rootScope.MatchList_Details= results.data; 
                        // $rootScope.MatchList_Statistics= match;
                        $rootScope.arrayMatchList_Details[result]=results.data.commentaries;
                        // MatchDetails[result][1]=matchList[i];
                        //count++;
                        /*if(count == playersCount) {
                            // window.localStorage["MatchDetails"]= JSON.stringify(MatchDetails);*/
                        scope.$broadcast("MatchDetailsLoaded");
                        //}
                       
                    }).catch(function(response) {
                        // alert(response);
                        console.log(response);
                       //count++;
                        $rootScope.MatchList_Details={};
                       //if(count== playersCount){
                        //  window.localStorage["MatchDetails"]= JSON.stringify(MatchDetails);
                         scope.$broadcast("MatchDetailsError");
                      //}
                    }).finally(function() {
                        // console.log("finally finished gists");
                    });
                    
                    // to populate data form youfoot server to MVP server.
                    // Return nothing
                    $http({
                        method: 'POST',
                        data:{
                            match_id: matchId
                        },
                        url: serverURL+"/mvp/players"
                    })
                    .success(function(data, status, headers, config){
                        console.log("Match added to rating server");
                        // console.log(data);
                    })
                    .error(function(data, status, headers, config){
                        // console.log("error"+ status);
                    });
                } else{
                    var matchList= JSON.parse(window.localStorage[ls_topMatchlist]);
                    var matchesCount= matchList.length;
                    var count=0;
                    for(var i=0;i < matchList.length;i++){
                        var matchId= matchList[i].Match.id;
                        var cDate = new Date().getTime();
                        var date1 = new Date(matchList[i].Match.start_time).getTime();
                        if(cDate>date1){
                            if( !$rootScope.arrayMatchList_Details[matchId]){
                                $http({
                                    method: 'GET',
                                    // url: "https://www.youfoot.com/mobiles/matchCom/matchId:"+matchId+"/year:"+year+"/teamId:"+tid+"/competitionId:"+compid+"/lang:en/venueId:"+venueId+"/type:iOS/version",
                                    url: WebserviceURL+"/match/commentary?mid="+matchId+"&lang="+lang, // Don not add callback
                                    headers: {
                                        'api_key' : api_key
                                    },
                                   
                                }).then( function(results){
                                    var config = results.config;
                                    var key = "mid";
                                    var name = key.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
                                    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)");
                                    var result = regex.exec(config.url);
                                    var result = null ? "" : decodeURIComponent(result[1].replace(/\+/g, " "));
                                    // console.log(result);
                                    
                                    $rootScope.arrayMatchList_Details[result]=results.data.commentaries;
                                    count++;
                                    if(count==matchesCount){
                                        scope.$broadcast("AllMatchesDetailsLoaded");    
                                    }
                                    
                                }).catch(function(response) {
                                    // alert(response);
                                    count++;
                                    $rootScope.MatchList_Details={};
                                    if(count== matchesCount){
                                        scope.$broadcast("AllMatchesDetailsLoaded");
                                    }
                                }).finally(function() {
                                    // console.log("finally finished gists");
                                });
                            
                            
                                // to populate data form youfoot server to MVP server.
                                // Return nothing
                                $http({
                                    method: 'POST',
                                    data:{
                                        match_id: matchId
                                    },
                                    url: serverURL+"/mvp/players"
                                })
                                .success(function(data, status, headers, config){
                                    console.log("Match added to rating server");
                                    // console.log(data);
                                })
                                .error(function(data, status, headers, config){
                                    // console.log("error"+ status);
                                });
                            }
                        } else{
                            count++;
                            if(count==matchesCount){
                                scope.$broadcast("AllMatchesDetailsLoaded");    
                            }
                        }
                    }
                }
            }else{
                scope.$broadcast("ConnectionError");
            }
        },
        
        getMatchStatistics: function(match,scope){
            console.log("MATCH: "+ match);
            matchId = match;
            $rootScope.MatchList_Statistics={};
            console.log($rootScope.arrayMatchList_Statistics);
            if($rootScope.arrayMatchList_Statistics[matchId] != undefined && (! $rootScope.match_selected_isLive)){
                $rootScope.MatchList_Statistics= $rootScope.arrayMatchList_Statistics[matchId];
            }else{
                var match={};
                var home={};
                var away={};
                
                try{
                    var _S = new window._S({
                       id:matchId,
                       getContent:true,
                       model:'match',
                       apiKey: api_key   // 
                    });
                }catch(e){
                   
                    return;
                }
        
                /*--------------------------------------------------------------------------------------/
                /          HOME         
                /--------------------------------------------------------------------------------------*/
                
                _S.set({team:"home"});  // important we'll get home team statistics
                
                var goal = _S.goal();
                
                //console.log(_S.content.matches[matchId].tool_version);
                home.team_id= _S.get("match", matchId).home_team_id;
                home.team_name= _S.get('team',home.team_id).name;
                
            // GOALS ----------------------------------------------------------------------------------------
                home.goals= goal.count();
                console.log("HOME GOALS: "+home.goals)
                if(angular.isObject(home.goals) && Object.keys(home.goals).length > 0){
                        if(home.goals.matches != undefined && home.goals.matches[matchId] != undefined){
                            for(var i=0; i< home.goals.matches[matchId].length;i++){
                                var playerName= _S.get("player", home.goals.matches[matchId][i].player_id);
                                home.goals.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                }
                
                if(_S.content.matches[matchId].tool_version != "score"){
                
                   
                    // HOME REDCARD  -----------------------------------------------------------------------------
                    
                    var redcard= _S.redcard();
                    home.redcard= redcard.count();
                    if(angular.isObject(home.redcard) && Object.keys(home.redcard).length > 0){
                        if(home.redcard.matches != undefined && home.redcard.matches[matchId] != undefined){
                            for(var i=0; i< home.redcard.matches[matchId].length;i++){
                                var playerName= _S.get("player", home.redcard.matches[matchId][i].player_id);
                                home.redcard.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                    }
                    
                    // HOME YELLOWCARD  -----------------------------------------------------------------------------
                    var yellowcard= _S.yellowcard();
                    home.yellowcard= yellowcard.count();
                    if(angular.isObject(home.yellowcard) && Object.keys(home.yellowcard).length > 0){
                       if(home.yellowcard.matches != undefined && home.yellowcard.matches[matchId] != undefined){
                            for(var i=0; i < home.yellowcard.matches[matchId].length; i++){
                                var playerName= _S.get("player",  home.yellowcard.matches[matchId][i].player_id);
                                home.yellowcard.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                    }
                    
                    // HOME SUBSTITUTION  -----------------------------------------------------------------------------
                    var substitution = _S.substitution();
                    home.substitution= substitution.count();
                    if(angular.isObject(home.substitution) && Object.keys(home.substitution).length > 0){
                        if(home.substitution.matches != undefined && home.substitution.matches[matchId] != undefined){
                            for(var i=0; i < home.substitution.matches[matchId].length; i++){
                               var playerInName= _S.get("player", home.substitution.matches[matchId][i].player_in_id);
                                var playerOutName= _S.get("player", home.substitution.matches[matchId][i].player_out_id);
                                home.substitution.matches[matchId][i].player_in_name= playerInName ? playerInName.name : "";
                                home.substitution.matches[matchId][i].player_out_name= playerOutName ? playerOutName.name : "";
                            }
                        } 
                    }
                
                }
            // HOME PLAYCOM  DATA -------------------------------------------------------------------------------------
            
                if(_S.content.matches[matchId].tool_version == "playcom_silo"){
                   var shot= _S.shot();
                   var offside= _S.offside();
                   var freekick= _S.freekick();
                   var corner= _S.corner();
                   var penaltykick= _S.penaltykick();
                
                // HOME GOALS SHOOTING POSITIONS  -------------------------------------------------------------------------
                
                   home.goals.shooting_positions= goal.shootingPosition();
                   if(angular.isObject(home.goals.shooting_positions) && Object.keys(home.goals.shooting_positions).length > 0){
                       $.each(home.goals.shooting_positions, function(key,value){
                         if(value.matches != undefined && value.matches[matchId] != undefined) 
                          for(var i=0; i < value.matches[matchId].length;i++){
                            var playerName= _S.get("player" ,home.goals.shooting_positions[key].matches[matchId][i].player_id);
                             home.goals.shooting_positions[key].matches[matchId][i].player_name=  playerName ? playerName.name : "";
                          } 
                       });
                   }
                   
                //  HOME GOALS SCORING ZONES  -------------------------------------------------------------------------------
                
                   home.goals.scoring_zones= goal.scoringZone();
                   console.log("SCORING: "+ JSON.stringify(goal.scoringZone()));
                   
                // HOME SHOTS  ----------------------------------------------------------------------------------------------
                
                    home.shots=shot.count();
                    if(angular.isObject(home.shots) && home.shots.matches[matchId] != undefined){
                        console.log(home.shots.matches[matchId]);
                        for(var i=0;i < home.shots.matches[matchId].length; i++){
                            var playerName= _S.get("player",home.shots.matches[matchId][i].player_id);
                            home.shots.matches[matchId][i].player_name=  playerName ? playerName.name : "";
                        }
                     
                    }
                   
                //  HOME SHOTS SHOOTING POSITIONS  ----------------------------------------------------------------------------
                
                   home.shots.shooting_positions= shot.shootingPosition();
                   if(angular.isObject(home.shots.shooting_positions) && Object.keys(home.shots.shooting_positions).length > 0){
                      $.each(home.shots.shooting_positions, function(key,value){
                         if(value.matches != undefined && value.matches[matchId] != undefined) {
                           for(var i=0; i < value.matches[matchId].length;i++){
                             var playerName= _S.get("player",home.shots.shooting_positions[key].matches[matchId][i].player_id);
                             home.shots.shooting_positions[key].matches[matchId][i].player_name=  playerName ? playerName.name : "";
                           } 
                         }
                       });
                   }
                   
                //  HOME SHOTS ON TARGET  ---------------------------------------------------------------------------------------
                
                   home.shots.on_target= shot.onTarget();
                   if(angular.isObject(home.shots.on_target) && Object.keys(home.shots.on_target).length > 0){
                     if(home.shots.on_target.matches != undefined && home.shots.on_target.matches[matchId] != undefined) {
                       for(var i=0; i < home.shots.on_target.matches[matchId].length;i++){ 
                          var playerName =  _S.get("player",home.shots.on_target.matches[matchId][i].player_id);
                          home.shots.on_target.matches[matchId][i].player_name=  playerName ? playerName.name : "";
                       }    
                     }
                     //home.shots.on_target.total =  home.shots.on_target.total + (goal.count(false) - goal.others({type:'own',info:false}));
                     home.shots.wide_of= home.shots.total - home.shots.on_target.total;
                   }
                   
                    console.log(home.shots.wide_of);
                //  HOME SHOTS SAVED  -------------------------------------------------------------------------------------------
                
                   home.shots.saved= shot.save();
                   
                //  HOME OFFSIDE ------------------------------------------------------------------------------------------------
                
                   home.offside= offside.count();
                   if(angular.isObject(home.offside) && Object.keys(home.offside).length > 0){
                       if(home.offside.matches != undefined && home.offside.matches[matchId] != undefined){
                            for(var i=0; i < home.offside.matches[matchId].length; i++){
                                var playerName= _S.get("player",  home.offside.matches[matchId][i].player_id);
                                home.offside.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                   }
                   
                //  HOME FREEKICK  -----------------------------------------------------------------------------------------------
                
                   home.freekick=freekick.count();
                   if(angular.isObject(home.freekick) && Object.keys(home.freekick).length > 0){
                      if(home.freekick.matches != undefined && home.freekick.matches[matchId] != undefined){
                            for(var i=0; i < home.freekick.matches[matchId].length; i++){
                                var playerName= _S.get("player",  home.freekick.matches[matchId][i].player_id);
                                home.freekick.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                      } 
                   }
                   
                //  HOME CORNER  ---------------------------------------------------------------------------------------------------
                
                   home.corner=corner.count();
                   if(angular.isObject(home.corner) && Object.keys(home.corner).length > 0){
                       if(home.corner.matches != undefined && home.corner.matches[matchId] != undefined){
                            for(var i=0; i < home.corner.matches[matchId].length; i++){
                                var playerName= _S.get("player",  home.corner.matches[matchId][i].player_id);
                                home.corner.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                   }
                   
                //  HOME PENALTY KICKS  --------------------------------------------------------------------------------------------
                
                   home.penaltykicks= penaltykick.count();
                   if(angular.isObject(home.penaltykicks) && Object.keys(home.penaltykicks).length > 0){
                       if(home.penaltykicks.matches != undefined && home.penaltykicks.matches[matchId] != undefined){
                            for(var i=0; i < home.penaltykicks.matches[matchId].length; i++){
                                var playerName= _S.get("player",  home.penaltykicks.matches[matchId][i].player_id);
                                home.penaltykicks.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                   }
                }
                
            /*--------------------------------------------------------------------------------------/
            /          AWAY         
            /--------------------------------------------------------------------------------------*/
            
                _S.set({team:"away"});  // important we'll get away team statistics
                
                var goal = _S.goal();
                
                //console.log(_S.content.matches[matchId].tool_version);
                away.team_id= _S.get("match", matchId).away_team_id;
                away.team_name= _S.get('team',away.team_id).name;
                
            // GOALS ----------------------------------------------------------------------------------------
                away.goals= goal.count();
                 if(angular.isObject(away.goals) && Object.keys(away.goals).length > 0){
                        if(away.goals.matches != undefined && away.goals.matches[matchId] != undefined){
                            for(var i=0; i< away.goals.matches[matchId].length;i++){
                                var playerName= _S.get("player", away.goals.matches[matchId][i].player_id);
                                away.goals.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                    }
                
                if(_S.content.matches[matchId].tool_version != "score"){
                    
                    // away REDCARD  -----------------------------------------------------------------------------
                   
                    var redcard= _S.redcard();
                    away.redcard= redcard.count();
                    if(angular.isObject(away.redcard) && Object.keys(away.redcard).length > 0){
                        if(away.redcard.matches != undefined && away.redcard.matches[matchId] != undefined){
                            for(var i=0; i< away.redcard.matches[matchId].length;i++){
                                var playerName= _S.get("player", away.redcard.matches[matchId][i].player_id);
                                away.redcard.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                    }
                    
                    // away YELLOWCARD  -----------------------------------------------------------------------------
                    var yellowcard= _S.yellowcard();
                    away.yellowcard= yellowcard.count();
                    if(angular.isObject(away.yellowcard) && Object.keys(away.yellowcard).length > 0){
                       if(away.yellowcard.matches != undefined && away.yellowcard.matches[matchId] != undefined){
                            for(var i=0; i < away.yellowcard.matches[matchId].length; i++){
                                var playerName= _S.get("player",  away.yellowcard.matches[matchId][i].player_id);
                                away.yellowcard.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                    }
                    
                    // away SUBSTITUTION  -----------------------------------------------------------------------------
                    var substitution = _S.substitution();
                    away.substitution= substitution.count();
                    if(angular.isObject(away.substitution) && Object.keys(away.substitution).length > 0){
                        if(away.substitution.matches != undefined && away.substitution.matches[matchId] != undefined){
                            for(var i=0; i < away.substitution.matches[matchId].length; i++){
                               var playerInName= _S.get("player", away.substitution.matches[matchId][i].player_in_id);
                                var playerOutName= _S.get("player", away.substitution.matches[matchId][i].player_out_id);
                                away.substitution.matches[matchId][i].player_in_name= playerInName ? playerInName.name : "";
                                away.substitution.matches[matchId][i].player_out_name= playerOutName ? playerOutName.name : "";
                            }
                        } 
                    }
                
                }
            // away PLAYCOM  DATA -------------------------------------------------------------------------------------
            
                if(_S.content.matches[matchId].tool_version == "playcom_silo"){
                   var shot= _S.shot();
                   var offside= _S.offside();
                   var freekick= _S.freekick();
                   var corner= _S.corner();
                   var penaltykick= _S.penaltykick();
                
                // away GOALS SHOOTING POSITIONS  -------------------------------------------------------------------------
                
                   away.goals.shooting_positions= goal.shootingPosition();
                   if(angular.isObject(away.goals.shooting_positions) && Object.keys(away.goals.shooting_positions).length > 0){
                       $.each(away.goals.shooting_positions, function(key,value){
                         if(value.matches != undefined && value.matches[matchId] != undefined) 
                          for(var i=0; i < value.matches[matchId].length;i++){
                            var playerName= _S.get("player" ,away.goals.shooting_positions[key].matches[matchId][i].player_id);
                             away.goals.shooting_positions[key].matches[matchId][i].player_name=  playerName ? playerName.name : "";
                          } 
                       });
                   }
                   
                //  away GOALS SCORING ZONES  -------------------------------------------------------------------------------
                
                   away.goals.scoring_zones= goal.scoringZone();
                   
                // away SHOTS  ----------------------------------------------------------------------------------------------
                
                   away.shots=shot.count();
                   if(angular.isObject(away.shots) && away.shots.matches[matchId] != undefined){
                        console.log(away.shots.matches[matchId]);
                        for(var i=0;i < away.shots.matches[matchId].length; i++){
                            var playerName= _S.get("player",away.shots.matches[matchId][i].player_id);
                            away.shots.matches[matchId][i].player_name=  playerName ? playerName.name : "";
                        }
                    }
                   
                //  away SHOTS SHOOTING POSITIONS  ----------------------------------------------------------------------------
                
                   away.shots.shooting_positions= shot.shootingPosition();
                   if(angular.isObject(away.shots.shooting_positions) && Object.keys(away.shots.shooting_positions).length > 0){
                      $.each(away.shots.shooting_positions, function(key,value){
                         if(value.matches != undefined && value.matches[matchId] != undefined) {
                           for(var i=0; i < value.matches[matchId].length;i++){
                             var playerName= _S.get("player",away.shots.shooting_positions[key].matches[matchId][i].player_id);
                             away.shots.shooting_positions[key].matches[matchId][i].player_name=  playerName ? playerName.name : "";
                           } 
                         }
                       });
                   }
                   
                //  away SHOTS ON TARGET  ---------------------------------------------------------------------------------------
                
                   away.shots.on_target= shot.onTarget();
                   if(angular.isObject(away.shots.on_target) && Object.keys(away.shots.on_target).length > 0){
                     if(away.shots.on_target.matches != undefined && away.shots.on_target.matches[matchId] != undefined) {
                       for(var i=0; i < away.shots.on_target.matches[matchId].length;i++){ 
                          var playerName =  _S.get("player",away.shots.on_target.matches[matchId][i].player_id);
                          away.shots.on_target.matches[matchId][i].player_name=  playerName ? playerName.name : "";
                       }    
                     }
                     //away.shots.on_target.total =  away.shots.on_target.total + (goal.count(false) - goal.others({type:'own',info:false}));
                     away.shots.wide_of= away.shots.total - away.shots.on_target.total;
                     console.log(away.shots.wide_of);
                   }
                   
                   
                //  away SHOTS SAVED  -------------------------------------------------------------------------------------------
                
                   away.shots.saved= shot.save();
                   
                //  away OFFSIDE ------------------------------------------------------------------------------------------------
                
                   away.offside= offside.count();
                   if(angular.isObject(away.offside) && Object.keys(away.offside).length > 0){
                       if(away.offside.matches != undefined && away.offside.matches[matchId] != undefined){
                            for(var i=0; i < away.offside.matches[matchId].length; i++){
                                var playerName= _S.get("player",  away.offside.matches[matchId][i].player_id);
                                away.offside.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                   }
                   
                //  away FREEKICK  -----------------------------------------------------------------------------------------------
                
                   away.freekick=freekick.count();
                   if(angular.isObject(away.freekick) && Object.keys(away.freekick).length > 0){
                      if(away.freekick.matches != undefined && away.freekick.matches[matchId] != undefined){
                            for(var i=0; i < away.freekick.matches[matchId].length; i++){
                                var playerName= _S.get("player",  away.freekick.matches[matchId][i].player_id);
                                away.freekick.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                      } 
                   }
                   
                //  away CORNER  ---------------------------------------------------------------------------------------------------
                
                   away.corner=corner.count();
                   if(angular.isObject(away.corner) && Object.keys(away.corner).length > 0){
                       if(away.corner.matches != undefined && away.corner.matches[matchId] != undefined){
                            for(var i=0; i < away.corner.matches[matchId].length; i++){
                                var playerName= _S.get("player",  away.corner.matches[matchId][i].player_id);
                                away.corner.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                   }
                   
                //  away PENALTY KICKS  --------------------------------------------------------------------------------------------
                
                   away.penaltykicks= penaltykick.count();
                   if(angular.isObject(away.penaltykicks) && Object.keys(away.penaltykicks).length > 0){
                       if(away.penaltykicks.matches != undefined && away.penaltykicks.matches[matchId] != undefined){
                            for(var i=0; i < away.penaltykicks.matches[matchId].length; i++){
                                var playerName= _S.get("player",  away.penaltykicks.matches[matchId][i].player_id);
                                away.penaltykicks.matches[matchId][i].player_name= playerName ? playerName.name : "";
                            }
                        } 
                   }
                }
                //console.log("TEST: " +JSON.stringify(home));
                //console.log("TEST: " +JSON.stringify(away));
                match.home= home;
                match.away= away;
                match.attendance = 50;
                $rootScope.MatchList_Statistics= match;
                $rootScope.arrayMatchList_Statistics[matchId]=match;
                scope.$broadcast("MatchStatisticsLoaded");
            }
        },
        
        // getChampionship: function(scope){
        //     // var year= new Date().getFullYear();
        //     $http({
        //           method: 'JSONP',
        //           url: "https://www.youfoot.com/urban_mobiles/competitionRanking/competitionId:"+ISL_id+"/year:"+year+"/lang:"+lang+"/type:native?callback=JSON_CALLBACK", //+tid,
        //           headers: {
        //             'api_key' : api_key
        //           }
        //     })
        //     .success(function(data, status, headers, config) {
        //         // console.log(data);
                
        //         var Competitions = data.stages;
        //         // var StageRound = [];
        //         // console.log( Competitions);
        //         for(var i=0; i < Competitions.length; i++){
        //             // console.log(Competitions[i].StageRound);
        //             for(var j=0;j<Competitions[i].StageRound.length; j++){
        //                 var match_details = Competitions[i].StageRound[j]; 
        //                 // console.log(match_details);
        //                 for(var k=0;k<match_details.Match.length; k++){
        //                     // console.log(match_details.Match[k].Match.id);
        //                     //console.log(match_details.Match[k]);
        //                     match_details.Match[k].SecondLeg = [];
        //                     window.localStorage["Championship_match:"+k+":"+match_details.id] = JSON.stringify(match_details.Match[k]);
        //                 }
        //                 Competitions[i].StageRound[j].Match = [];
        //             }
        //         }
        //         // console.log(Competitions);
        //         window.localStorage['Championship'] = JSON.stringify(Competitions);
        //         scope.$broadcast("ChampionshipLoaded");
        //     })
        //     .error(function(data, status, headers, config) {
        //         scope.$broadcast("ChampionshipLoaded");
        //     });
        // },
        
        getCompetitionCalendar:function(scope, from){
            
            $http({
                  method: 'GET',
                  url: WebserviceURL+'/competition/calendar/'+cid, 
                  headers: {
                    'api_key' : api_key
                  }
            })
            .success(function(data, status, headers, config) {
                console.log(data);
                
                // var match_list = data;
                // console.log(data);
                if(competition[CurrentCom].hasGroups == 1){
                    data.Calendar['championship'] = data.Calendar['group'];
                    data.Calendar['group']=[];
                    if(data.Calendar['group-1']){
                        data.Calendar['championship'].StageRound = data.Calendar['championship'].StageRound.concat( data.Calendar['group-1'].StageRound);
                    }
                    if(data.Calendar['group-2']){
                        data.Calendar['championship'].StageRound = data.Calendar['championship'].StageRound.concat( data.Calendar['group-2'].StageRound);
                    }
                    if(data.Calendar['group-3']){
                        data.Calendar['championship'].StageRound = data.Calendar['championship'].StageRound.concat( data.Calendar['group-3'].StageRound);
                    }
                    if(data.Calendar['group-4']){
                        data.Calendar['championship'].StageRound = data.Calendar['championship'].StageRound.concat( data.Calendar['group-4'].StageRound);
                    }
                }
                window.localStorage[ls_calendar]= JSON.stringify(data);
                if(from == "start"){
                    var count=0;
                    for(var team in data.team_logos){
                        var obj={};
                        obj.id= team;
                        $rootScope.teamsList[count]=obj;
                        count++;
                        // console.log(count);
                    }
                }
                console.log($rootScope.teamsList);
                scope.$broadcast("CalendarLoaded");
            })
            .error(function(data, status, headers, config) {
                scope.$broadcast("CalendarError");
            });
        },
        
        getTeams:function(scope){
           
            var teams_count= $rootScope.teamsList.length;
             
            if(teams_count > 0){
                var count = 0;
                var ids=$rootScope.teamsList;
                for(var i=0;i< ids.length;i++){
                    $http({
                         method: 'GET',
                         url: WebserviceURL+'/team/info/'+ids[i].id, 
                         headers: {
                          'api_key' : api_key
                        }
                        
                    })
                    .success(function(data, status, headers, config){
                        // console.log(config);
                        var splitted=config.url.split("/");
                        $rootScope.teamsList[count]=data;
                        $rootScope.teamsList[count].id= splitted[splitted.length -1];
                        count++;
                        if(count == teams_count){
                            $rootScope.teamsList.sort(function(a,b){if(a.name < b.name)return -1;else return 1});
                            scope.$broadcast("TeamsLoaded");
                            console.log($rootScope.teamsList);
                        }
                    })
                    .error(function(data, status, headers, config){
                        count++;
                        if(count == teams_count){
                            scope.$broadcast("TeamsLoaded");
                        }
                    });
                }
            }
        },
        
        getIslRanking: function(scope){
            // var year= new Date().getFullYear();
            // console.log('https://www.youfoot.com//api_ui/v1/competition/table/'+champ_slug+'/'+tid);
            if(competition[CurrentCom].hasGroups == 0){
                $http({
                    method: 'GET',
                    //   url: "http://www.youfoot.com/urban_mobiles/competitionRanking/competitionId:"+cid+"/from:competitionList/year:2015/lang:en/type:native", 
                    url: WebserviceURL+'/competition/table/'+champ_slug,
                    headers: {
                        'api_key' : api_key
                    }
                })
                .success(function(data, status, headers, config) {
                    // console.log(data);
                    $rootScope.compRanking = data;
                    scope.$broadcast("IslRankingLoaded");
                })
                .error(function(data, status, headers, config) {
                    scope.$broadcast("IslRankingLoaded");
                });
            } else{
                $http({
                    method: 'GET',
                    url: "http://www.youfoot.com/urban_mobiles/competitionRanking/competitionId:"+cid+"/from:competitionList/year:2015/lang:en/type:native", 
                })
                .success(function(data, status, headers, config) {
                    console.log("http://www.youfoot.com/urban_mobiles/competitionRanking/competitionId:"+cid+"/from:competitionList/year:2015/lang:en/type:native");
                    $rootScope.compRanking = data.roundStats;
                    $rootScope.rounds =[];
                    for(var i=0; i<data.stages.length; i++){
                        // $rootScope.rounds=data.stages[i].StageRound;
                        $rootScope.rounds = $rootScope.rounds.concat( data.stages[i].StageRound);
                        // console.log($rootScope.rounds);
                    }
                    // console.log($rootScope.rounds);
                    scope.$broadcast("IslRankingLoaded");
                })
                .error(function(data, status, headers, config) {
                    scope.$broadcast("IslRankingLoaded");
                });
            }
        },
        
        getIslScorer_Assist: function(scope){
            // var year= new Date().getFullYear();
            // console.log('https://www.youfoot.com//api_ui/v1/competition/table/'+champ_slug+'/'+tid);
            $http({
                  method: 'GET',
                  url: WebserviceURL+'/competition/top/'+champ_slug, 
                  headers: {
                    'api_key' : api_key
                  }
            })
            .success(function(data, status, headers, config) {
                console.log(data);
                // console.log(data.player.top_assists);
                window.localStorage[ls_IslScorer] = JSON.stringify(data.player.top_scorers);
                window.localStorage[ls_IslAssist] = JSON.stringify(data.player.top_assists);
                window.localStorage[ls_IslPlayerDetails] = JSON.stringify(data.player.details);
                scope.$broadcast("IslScorer_AssistLoaded");
            })
            .error(function(data, status, headers, config) {
                 window.localStorage[ls_IslScorer] = {};
                window.localStorage[ls_IslAssist] = {};
                window.localStorage[ls_IslPlayerDetails] = {};
                scope.$broadcast("IslScorer_AssistLoaded");
            });
        }
    };
    loadingService= new LoadingService();
    console.log(loadingService);
    return loadingService;
        
  })

.factory('socketConnect', function (socketFactory) {
    var myIoSocket = io.connect(serverURL);
    mySocket = socketFactory({
        ioSocket: myIoSocket
    });
    console.log(mySocket);
    return mySocket;
})
  
.factory("DatabaseService", function(){
    
    function DatabaseService(){};
    
    DatabaseService.prototype={
        
     initDatabase:function() {
    	try {
    	    if (!window.openDatabase) {
    	       // alert('Databases are not supported in this browser.');
    	    } else {
    	        var shortName = 'APPDB';
    	        var version = '1.0';
    	        var displayName = 'APP Database';
    	        var maxSize = 10000000; //  bytes
    	        database = openDatabase(shortName, version, displayName, maxSize);
    			//console.log(database);
    	    }
    	 } catch(e) {
     
    	    if (e == 2) {
    	        // Version number mismatch.
    	        console.log("Invalid database version.");
    	    } else {
    	        console.log("Unknown error "+e+".");
    	    }
    	    return;
    	 }
     }
    };
    dataBaseService= new DatabaseService();
    return dataBaseService;
    
})

.factory("RegisterService", function($http,$timeout, $rootScope){
    
    function RegisterService(){}
    
        RegisterService.prototype={
        
        updatePreferences: function(news, videos,mvp, matches,teams){
           if(window.localStorage[ls_regid] != undefined) {  // ANDROID
              //alert("ok");
            //   alert(domain+"mobiles/updatepreference/teamId:"+parent_venue+"/app_id:"+window.localStorage[ls_regid]+"/news:"+news+"/videos:"+videos+"/mvp:"+mvp+"/matches:"+matches+'/team_ids:'+teams);
              //localStorage.regid= "APA91bEsezHN80PS1-KcQNoE40Xp6pnWBdrkKZMdEQ9l5xL7KkG8AulqI70UQDHdon1w5haaoYqrvyIli_2xd2OMdWLBCDWivqovzogpvbv7JlyhAXgc30U"
               $http({
                  method: 'GET',
                  url: domain+"mobiles/updatepreference/teamId:"+parent_venue+"/app_id:"+window.localStorage[ls_regid]+"/news:"+news+"/videos:"+videos+"/mvp:"+mvp+"/matches:"+matches+'/team_ids:'+teams,
               })
               .success(function(data, status, headers, config){
                
                console.log("updatepreference Success");
               })
               .error(function(data, status, headers, config){
                    console.log("updatepreference error");
               });
           }
           
            if(window.localStorage[ls_token] != undefined) {  // IOS
                // alert(domain+"mobiles/updatepreference/teamId:"+parent_venue+"/app_id:"+window.localStorage[ls_token]+"/news:"+news+"/videos:"+videos+"/matches:"+matches+"/mvp:"+mvp+'/team_ids:'+teams);
               $http({
                  method: 'GET',
                  url: domain+"mobiles/updatepreference/teamId:"+parent_venue+"/app_id:"+window.localStorage[ls_token]+"/news:"+news+"/videos:"+videos+"/matches:"+matches+"/mvp:"+mvp+'/team_ids:'+teams,
                  
               })
               .success(function(data, status, headers, config){
                    console.log("updatepreference Success");
               })
               .error(function(data, status, headers, config){
                    console.log("updatepreference error");
               });
           }
            
            
        },
        successHandler: function(result){
            // alert(result);
        //   window.localStorage[ls_regid] = result;
        
            if(window.localStorage[ls_regid] != undefined){ // for Android
                // alert(window.localStorage[ls_regid]);
                $http({
                  method: 'GET',
                  url : domain+'mobiles/deviceRegistar/device:'+device.uuid+'/regid:'+window.localStorage[ls_regid]+"/teamid:"+parent_venue+'/lang:'+lang,
                  dataType:"jsonp",
               })
               .success(function(data, status, headers, config){
                   console.log("Android device registered");
                    $rootScope.$broadcast("deviceRegistered");
               })
               .error(function(data, status, headers, config){
                    console.log("Android device not registered");
               });
			} else{
			    $rootScope.$broadcast("AndroidDeviceRegistration");
			}
            // $rootScope.$broadcast("deviceRegistered");
        },
        errorHandler: function(error){
            console.log(error);
        },
        tokenHandler:function(msg){
            //alert(msg);
            window.localStorage[ls_token] = msg;
            if(window.localStorage[ls_token] != undefined){ // for iOS

                $http({
                  method: 'GET',
                  url : domain+'/mobiles/tokenRegistar/token:'+window.localStorage[ls_token]+"/teamid:"+parent_venue+'/lang:'+lang,
                  dataType:"jsonp",
               })
               .success(function(data, status, headers, config){
                   console.log("iOS device registered");
                    $rootScope.$broadcast("deviceRegistered");
               })
               .error(function(data, status, headers, config){
                    console.log("iOS device not registered");
               });
			}
        }
       
    }
    
    var registerService= new RegisterService();
    return registerService;
});
  
    
	
	