// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers','starter.filters','starter.services','starter.directives', 'ngRoute','ionic.contrib.ui.tinderCards','btford.socket-io'])

.run(function($ionicPlatform, $rootScope,RegisterService,$location, LoadingService,$ionicSlideBoxDelegate,$ionicHistory,$timeout) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    /*if(navigator.splashscreen != undefined){
        navigator.splashscreen.hide();
    }*/
    /*if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }*/
           
    
  // console.log(navigator.language);
    var navigatorLanguage= navigator.language;
    // console.log(moment.lang());
    moment.lang(navigatorLanguage);
    
    $rootScope.orientationChange=function(event){
     $timeout(function(){
        var currentState= $ionicHistory.currentStateName();
        if(currentState=="app.news"){
            var windowH= window.innerHeight;
            var windowW= window.innerWidth;
            //alert("height:"+windowH);
          if(windowW < windowH){
             //if(windowH > 800){
                //var slideH=document.getElementById("slideHome").style.height= Math.round(windowH/2.7)+"px";
             //}else{
              var slideH= Math.round(windowW *0.5);
              document.getElementById("slideHome").style.height=slideH +"px";// Math.round(windowH/3.2)+"px";
                 //document.getElementById("slideHomeVideos").style.height=slideH +"px";
                 //$("#slideHome div").not(".slider-pager").css("height", (slideH-20));
                // $("#slideHomeVideos div").not(".slider-pager").css("height", (slideH -20));
            // }
              var newsHeight= windowH - slideH -134;    //
              document.getElementById("newsScroll").style.height=newsHeight+"px";
          } else{
            if(windowH < 600){
              var slideH= Math.round(windowH/1.5);
              document.getElementById("slideHome").style.height= slideH+"px";
              //document.getElementById("slideHomeVideos").style.height= slideH+"px";
            }else{
              var slideH=document.getElementById("slideHome").style.height= Math.round(windowH/1.8)+"px"; 
            }
            document.getElementById("newsScroll").style.height= Math.round(windowH/2)+"px";
          }
        }
        // else if(currentState=="app.newsDesc"){
          
        // }
        // alert("orientation change");
        $ionicSlideBoxDelegate.update();
        $ionicScrollDelegate.scrollTop();
       },300);
    }
    window.addEventListener("orientationchange", $rootScope.orientationChange);
    
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    $rootScope.notify_teams={
      "56160fa7-fe20-4fc4-98ad-7db40a00bc97": "56710f97-3c68-4cf0-a98a-1b740a00bcbb,566a76af-4cb0-4009-94b0-66ba0a00bcbb,56712c9a-f2a8-48a4-94d6-2a9c0a00bcbb,566a75fd-ad24-4db8-83c9-66ae0a00bcbb,5486d98d-2718-4208-bec5-2ef20a00bcbb,5486e605-d4cc-4371-9178-37e90a00bcbb,561b80cd-9434-44d3-92d6-66a10a00bc97,534d391d-fe98-4ec6-b5bf-7f9edfbdb49f,5486e1ba-b1ec-4546-9382-33150a00bcbb,56167987-4b34-420e-a7c5-33b70a00bc97,5486da81-f78c-4a5a-b177-2ef20a00bcbb,5486e295-a3b0-48b2-8f86-34b80a00bcbb,56167006-6450-403c-b18d-2aa80a00bc97,5486dc81-b1fc-458d-bcf2-30c60a00bcbb,5486dcc5-ac7c-4661-902d-30c60a00bcbb,530b74f3-a690-4650-9315-3590dfbdb49f,561678f8-b078-475f-a52c-2b970a00bc97,56167a89-2b54-4ddf-9b09-2e340a00bc97,561675c8-6ce0-4d48-ac8e-31760a00bc97,561679f0-52a0-4d5c-94b7-34240a00bc97,56164710-5ec4-49f0-a1b0-18680a00bc97,553e068a-4588-4122-95d3-41820a00bcbf,5616785d-db2c-4f5b-bcf6-31750a00bc97,5616746b-7784-4f3c-b102-2b960a00bc97,5486eb88-a16c-45be-bffe-3c330a00bcbb,5486e214-7f48-4609-b44d-34b80a00bcbb,561679b8-b3f8-4e05-bde5-34210a00bc97,566021a8-5b18-4eab-a500-282b0a00bc97,54c8b9fa-eae0-4b19-aea4-1ca20a00bc97,566027cd-f67c-4cb0-8ef4-2e840a00bc97",
      "530f1b4d-900c-4eee-bcce-3eb3dfbdb49f": "54f57b02-b69c-40e5-8789-67290a00bc97,565ff7de-78f0-41fb-9693-78d70a00bc51,52e659ce-0194-4688-832a-716cdfbdb49f,52e21d4d-7f88-4525-a7c8-13c5dfbdb49f,54927adb-6acc-44d2-b8d1-5ff50a00bc97,4cd048b6-d664-4e7a-8ba7-4775c1eee52b,4e609370-8f38-47c7-9f51-7e610a010001,52e65c52-98a4-4555-9545-716edfbdb49f,52e65cd4-15f0-4f5d-9086-7627dfbdb49f,54927932-7fec-420e-a1c8-5e6e0a00bc97,52e65ddf-8860-4636-a313-7168dfbdb49f,52e65e41-32dc-4d5b-ac7e-7206dfbdb49f,52e6573f-b89c-4062-9cd0-716cdfbdb49f",
      "5644cfc1-9038-414b-a04e-42240a00bcbb": "52e21d4d-7f88-4525-a7c8-13c5dfbdb49f,563a45ba-8da4-4052-8c7f-68fd0a00bcdd,563a4295-dbb8-452f-8f4c-68fd0a00bcdd,563a3f72-d530-4859-a859-68fc0a00bcdd,54f57e09-246c-435a-b36a-6b350a00bc97,54f57f16-219c-4636-a91e-6b230a00bc97,563a5393-5cbc-43d1-9e12-66520a00bc97,54f57a6a-9c48-43b0-8a24-6b350a00bc97,563a2c81-629c-4dd8-8063-5e220a00bcdd,54f57d69-f944-49cf-b8df-67220a00bc97",
      "562f1eed-2908-4bca-b9bb-0cc70a00bcbb": "5698b094-a6b0-4fd2-bccc-326a0a00bcbf,5698b183-3890-44fd-930e-32ec0a00bcbf,56b1a46a-305c-4391-b0a5-4d3f0a00bcbb,5698b46d-7814-44d7-83a5-34b60a00bcbf,56b1a9ef-dfcc-4d58-84ab-4f540a00bcbb,5698b5aa-aab4-4ca3-b8da-33c20a00bcbf,5698af92-b510-4f8e-9676-31130a00bcbf,56b1a548-5c7c-44b4-9593-4d5b0a00bcbb,5698b37e-d7f4-4b70-af2a-33b60a00bcbf,56b1a0a0-dad4-4990-beaa-4b670a00bcbb,5698b51b-5c98-4039-a18a-35000a00bcbf,56b1a36c-cc24-4d42-99ae-4ce40a00bcbb,5698b0fc-cf44-4394-972d-31120a00bcbf,5698afff-a89c-4458-81a2-31140a00bcbf,5698b3e0-dd34-46a4-96d0-34b70a00bcbf,56b1ab04-18ec-4e09-a964-4f6b0a00bcbb,56b1a6d0-656c-40ba-9b78-4e4e0a00bcbb,5637219e-19dc-41b0-990e-4d410a00bc97,56387744-4e48-4a51-ae37-52640a00bcbb,562f22b2-87d0-4c42-8c51-03e80a00bcdd,56409f0d-ea78-4660-b86c-10a40a00bcbb,56409fff-89d0-41d9-a1f7-0dd30a00bcbb,5636f8e1-a254-4af5-bbb4-6c3e0a00bcdd,562f2342-3480-42d8-97ff-03ee0a00bcdd,562f21e7-e410-4922-9ef4-01a40a00bcdd,56371144-4134-45df-9705-3de00a00bc97,563725c5-0a74-49da-9224-4de20a00bc97,546eae46-60c0-4311-98b7-28c20a00bcdd,56409e01-c1d8-47a5-856a-08170a00bcbb,56409d73-97b4-4631-8326-0dd30a00bcbb,56387816-6f5c-4cae-9a3f-4f790a00bcbb,562f247f-3e58-4897-af5c-03ea0a00bcdd,56409e65-fe40-4362-93a7-10a40a00bcbb,563865f4-9304-4ede-b39e-4c3f0a00bcbb,56409ca0-2e64-4f4e-a295-0dd50a00bcbb,5638667c-a610-483f-82da-4c3f0a00bcbb,563727f6-1910-4f72-9906-50ba0a00bc97,562f24da-d808-4dc3-9c26-03ee0a00bcdd,562f23bd-6e70-4fff-be62-04340a00bcdd",
     // "568e5ffb-5980-4dc6-bc51-40920a00bcba": "568e673a-5a58-4341-bb9e-45930a00bcba,568e67cc-7540-4af9-a408-45960a00bcba"
      
    }
    var teamsToSend ="";
    for (var key in $rootScope.notify_teams){
      teamsToSend += $rootScope.notify_teams[key];
    }
    console.log($rootScope.notify_teams);
    if(window.localStorage.new_notify_teams1 == undefined){
      window.localStorage[ls_newsActivated]="on";
      window.localStorage[ls_videosActivated]= "on";
      window.localStorage[ls_matchesPreferences]= "highlights";
      window.localStorage[ls_mvpActivated]="on";
      window.localStorage.new_notify_teams1=JSON.stringify($rootScope.notify_teams);     
    }
    
    
    $rootScope.$on('deviceRegistered', function(){
      if(window.localStorage.new_notify_teams1 != undefined){
        try{
          $rootScope.notify_teams= JSON.parse(window.localStorage.new_notify_teams1);
          RegisterService.updatePreferences(window.localStorage[ls_newsActivated],window.localStorage[ls_videosActivated],window.localStorage[ls_mvpActivated],window.localStorage[ls_matchesPreferences],teamsToSend);
            // updatePreferences: function(news, videos,mvp, matches,teams){
          // }
          // ,10000);  
        }catch(e){
           $rootScope.notify_teams={};
        }
      }else{
        RegisterService.updatePreferences(window.localStorage[ls_newsActivated],window.localStorage[ls_videosActivated],window.localStorage[ls_mvpActivated],window.localStorage[ls_matchesPreferences],teamsToSend);
      }
    });
    
    $rootScope.$on('AndroidDeviceRegistration', function() {
       pushNotification.register(RegisterService.successHandler,RegisterService.errorHandler,{"senderID":"1083438687615","ecb":"onNotificationGCM"}); 
    });
    if (! (navigator.userAgent.indexOf("Windows") >= 0  || navigator.userAgent.indexOf("Macintosh") >= 0)) { 
		  var pushNotification = window.plugins.pushNotification;
		  
		  // var d = new Date();
      $rootScope.Current_user = window.localStorage[ls_device_id] || device.uuid;
      window.localStorage[ls_device_id] = $rootScope.Current_user;
      // alert('Hello, ' + $rootScope.Current_user);
        
		  // alert(device);
		  if(ionic.Platform.isAndroid()) {
		    
		    //here you can do  
		    //alert('Hello, ' + $rootScope.Current_user);
		    // if(!window.localStorage[ls_userdetailSaved]){
  		  //   var deviceInfo = cordova.require("cordova/plugin/DeviceInformation");
  		  //   var regex = /\d+/g;
  		  //   var email=[];
  		  //   var phoneNo="";
      //     deviceInfo.get(function(result) {
      //       //alert(result);
      //       $.each(result, function(key, value){
      //         if(value== "com.google"){
      //           var number = key.match(regex);
      //           var keyName = "account"+number+"Name";
      //           email.push(result[keyName]);
      //           // alert(email);
      //         }
      //         if(key== "phoneNo" && value!="TM.ERROR"){
      //           phoneNo = value;
      //           // alert(email);
      //         }
      //       });
      //     }, function() {
      //       //alert("error");
      //     });
      //     if(email.length > 0 || phoneNo != ""){
      //       //---do something to send it to the server
      //       console.log(email + phoneNo+ " - bhumika");
      //       LoadingService.SaveUserInformation(email, phoneNo);
      //     }
		    // }
			  pushNotification.register(RegisterService.successHandler,RegisterService.errorHandler,{"senderID":"1083438687615","ecb":"onNotificationGCM"});
		  }	else {
		    pushNotification.register(RegisterService.tokenHandler,RegisterService.errorHandler,{"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});
	    }
		} else{  // for Desktop we are adding datetime as unique ID
        var d = new Date();
        $rootScope.Current_user = window.localStorage[ls_device_id] || d.getTime();
        window.localStorage[ls_device_id] = $rootScope.Current_user;
        console.log('Hello, ' + $rootScope.Current_user);
        
        window.localStorage[ls_regid] = "a26c8ca87e6237f72a0196c846c57942608c6922da299dff2173b9fa8fae8c2a";
        // if(window.localStorage.new_notify_teams1 != undefined){
          try{
            $rootScope.notify_teams= JSON.parse(window.localStorage.new_notify_teams1);
          }catch(e){
             $rootScope.notify_teams={};
          }
        // }else{
          
          // $timeout(function(){
            //alert(teamsToSend);
            RegisterService.updatePreferences("on","on","on","highlights",teamsToSend);
          // },10000);
        // }
		}
		
  });
  
  /*if(window.localStorage.team_logo != undefined && window.localStorage.team_logo.length > 0){
    $rootScope.team_logo= window.localStorage.team_logo;
  }else{
    LoadingService.getTeamLogoUrl();
  }*/
  console.log(competition);
  $rootScope.hasGroups=competition[CurrentCom].hasGroups;
  $rootScope.team_logo="img/"+clogo;
  //LoadingService.getTranslation();
  window.localStorage.currentid=CurrentCom;
  $rootScope.back_Word= back_Word;
  $rootScope.authenticated = false;
  $rootScope.team_type = false
  $rootScope.team_home_goals = 0;
  $rootScope.team_away_goals = 0;
  $rootScope.players = []
  $rootScope.total_player = 0
  
  
  $rootScope.cardsLoaded = false;
  $rootScope.VotingDONE = false;
  $rootScope.allVoted = false;
  
  
 
})



// this code effetcs to all the webservice and create issue
// .config(['$httpProvider', function($httpProvider) {
//     $httpProvider.defaults.useXDomain = true;
//     $httpProvider.defaults.headers.common = 'Content-Type: application/json';
//     delete $httpProvider.defaults.headers.common['X-Requested-With'];
// }])

.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider) {
  
  $ionicConfigProvider.tabs.position('bottom');  // solve android bug for tabs
  $ionicConfigProvider.backButton.text('');
  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })

  .state('app.videos', {
    url: "/videos",
    views: {
      'menuContent': {
        templateUrl: "templates/videos.html",
        controller: "VideosCtrl"
      }
    },
    
  })
  
  .state('app.live', {
    url:'/live',
    cache:false,
    views:{
      'menuContent':{
        templateUrl: "templates/live.html",
        controller: "LiveCtrl"
      }
    }
  })
  
  .state('app.teams', {
    url:'/teams',
    cache:false,
     views:{
      'menuContent':{
        templateUrl: "templates/teams.html",
        controller: "TeamsCtrl"
      }
    }
  })
  
   /*.state('app.gallery', {
    url: "/gallery",
    views: {
      'menuContent': {
        templateUrl: "templates/gallery.html",
        controller: "GalleryCtrl"
      }
    }
   })*/
   
   .state('app.polls', {
    url: "/polls",
    cache:false,
    views: {
      'menuContent': {
        templateUrl: "templates/polls.html",
        controller: "PollsCtrl"
      }
    }
    })
   .state('app.videosDesc', {
    url: "/videos/:videoId",
    views: {
      'menuContent': {
        templateUrl: "templates/videosDesc.html",
        controller:"VideosDescCtrl"
      }
     
    }
    
  })
   
   .state('app.playerVideosDesc', {
    url: "/playerVideos/:videoId",
    views: {
      'menuContent': {
        templateUrl: "templates/playerVideosDesc.html",
        controller:"PlayerVideosDescCtrl"
      }
    }
    
  })
  
   .state('app.news', {
    url: "/news",
    cache:false,
    views: {
      'menuContent': {
        templateUrl: "templates/news.html",
        controller:"NewsCtrl"
      }
    },
    onEnter: function($ionicSlideBoxDelegate,$ionicScrollDelegate, $timeout){
     
       $timeout(function(){
        $ionicSlideBoxDelegate.$getByHandle("slideHome").update();
        $ionicSlideBoxDelegate.$getByHandle("slideHome").start();
       // $ionicScrollDelegate.$getByHandle('scrollHome').resize();
       },200);
    }
  })
  
  .state('app.newsDesc', {
    url: "/news/:rss/:newsId",
    views: {
      'menuContent': {
        templateUrl: "templates/newsDesc.html",
        controller:"NewsDescCtrl"
      }
    }
  }) 

  .state('app.team', {
    url: "/team",
    cache:false,
    views: {
      'menuContent': {
        templateUrl: "templates/squad.html",
        controller: "SquadCtrl"
      }
    }
  })
  
  .state('app.player', {
    url: "/player",
    abstract:true,
    views: {
      'menuContent': {
        templateUrl: "templates/player.html",
        controller: "PlayerCtrl"
      }
    }
  })
  
  .state('app.playerIOS', {
    url: "/playerIOS",
    abstract:true,
    views: {
      'menuContent': {
        templateUrl: "templates/playerIOS.html",
        controller: "PlayerCtrl"
      }
    }
  })
  
  .state('app.player.infos', {
    url: "/infos/:playerId",
    cache:false,
    views: {
      'player-infos': {
        templateUrl: "templates/playerInfos.html",
        controller:"PlayerInfosCtrl"
      }
    }
  })
  
  .state('app.playerIOS.infos', {
    url: "/infos/:playerId",
    cache:false,
    views: {
      'player-infos': {
        templateUrl: "templates/playerInfos.html",
        controller:"PlayerInfosCtrl"
      }
    }
  })
  
   .state('app.player.videos', {
    url: "/videos/:playerId",
    cache:false,
    views: {
      'player-videos': {
        templateUrl: "templates/playerVideos.html",
        controller:"PlayerVideosCtrl"
      }
    }
  })
  
  .state('app.playerIOS.videos', {
    url: "/videos/:playerId",
    cache:false,
    views: {
      'player-videos': {
        templateUrl: "templates/playerVideos.html",
        controller:"PlayerVideosCtrl"
      }
    }
  })
  
   .state('app.player.twitter', {
    url: "/twitter/:playerId",
    cache:false,
    views: {
      'player-twitter': {
        templateUrl: "templates/playerTwitter.html",
        controller:"PlayerTwitterCtrl"
      }
    }
  })
  
  .state("app.isl_standing",{
    url:"/isl_standing",
    // abstract:true,
    cache:false,
    views:{
      'menuContent':{
        templateUrl:"templates/isl_standing.html",
        controller: "islStandingCtrl"
      }
    }
  })
  
  .state('app.isl_standing.ranking', {
    url: "/ranking",
    cache:false,
    views: {
      'isl-ranking': {
        templateUrl: "templates/islRanking.html",
        controller:"islRankingCtrl"
      }
    }
  })
  
  .state('app.isl_standing.scorers', {
    url: "/scorers",
    cache:false,
    views: {
      'isl-scorers': {
        templateUrl: "templates/islScorers.html",
        controller:"islScorersCtrl"
      }
    }
  })
  
  .state('app.isl_standing.assists', {
    url: "/assists",
    cache:false,
    views: {
      'isl-assists': {
        templateUrl: "templates/islAssists.html",
        controller:"islAssistsCtrl"
      }
    }
  })
  
  .state("app.features",{
    url: "/features",
    views:{
      'menuContent':{
        templateUrl: "templates/features.html",
        controller: "FeaturesCtrl"
      }
    }
  })
  
  .state("app.interviews",{
    url: "/interviews",
    views:{
      'menuContent':{
        templateUrl: "templates/interviews.html",
        controller: "InterviewsCtrl"
      }
    }
  })
  
  .state("app.rssVideos",{
    url: "/rssVideos",
    views:{
      'menuContent':{
        templateUrl: "templates/rssVideos.html",
        controller: "RssVideosCtrl"
      }
    }
  })
  
  // .state('app.matches1', {
  //   url: "/1",
  //   cache:false,
  //   // abstract:true,
  //   views: {
  //     'menuContent': {
  //       templateUrl: "templates/matches1.html",
  //       controller: 'MatchListCtrl'
  //     }
  //   }
  // })
  
  .state('app.matches', {
    url: "/matches",
    cache:false,
    // abstract:true,
    views: {
      'menuContent': {
        templateUrl: "templates/matches.html",
        controller: 'MatchListCtrl'
      }
    }
  })

  .state("app.match",{
    url:"/match",
    // abstract:true,
    cache:false,
    views:{
      'menuContent':{
        templateUrl:"templates/matchTabbars.html",
        controller: "matchCtrl"
      }
    },
    onExit:function(){
      //$("#refreshLive").remove();
      //$("#finishedMatch").remove();
      //$("#matchDescContent").remove();
    }
         
  })
  
  .state('app.match.matchDesc', {
    url: "/commentaires/:matchId",
    
    views: {
      'matchDesc': {
        templateUrl: "templates/matchDesc.html",
        controller:"MatchDescCtrl"
      }
    }
  })
  
  .state('app.match.matchStats', {
    url: "/stats/:matchId",
    cache:false,
    views: {
      'matchStats': {
        templateUrl: "templates/matchStats.html",
        controller:"MatchStatsCtrl"
      }
    },
    onExit:function(){
      // $("#attendence_graph").remove();
    }
  })
  
  .state('app.match.matchFanZone', { // match team selection page
    url: "/fanzone/:matchId",
    cache:false,
    views: {
      'matchFanZone': {
        templateUrl: "templates/matchFanZone.html",
        controller:"MatchFanzoneCtrl"
      }
    },
    onExit:function(){
      // $rootScope.review_detail_msg = "";
      // console.log("tttt"+$Scope.review_detail_msg);
    }
  })
  .state('app.match.matchFanZoneTeam', { // Rating page
    url: "/teamfanzone/:matchId/:teamId",
    cache:false,
    views: {
      'matchFanZone': {
        templateUrl: "templates/matchFanZoneTeam.html",
        controller:"MatchFanzoneTeamCtrl"
      }
    },
    onExit:function(){
      // $rootScope.review_detail_msg = "";
      // console.log("tttt"+$Scope.review_detail_msg);
    }
  })
  
  .state('app.match.matchReviewDetails', {
    url: "/reviewdetails/:matchId",
    cache:false,
    views: {
      'matchReviewDetails': {
        templateUrl: "templates/matchReviewDetails.html",
        controller:"MatchReviewDetailCtrl"
      }
    }
  })

  .state('app.sponsors', {
    url: "/sponsors",
    views: {
      'menuContent': {
        templateUrl: "templates/sponsors.html",
        controller:"SponsorsCtrl"
      }
    }
  })
  
  .state('app.contact', {
    url: "/contact",
    views: {
      'menuContent': {
        templateUrl: "templates/contact.html",
        controller:"ContactCtrl"
      }
    }
  })
  
  
  
  .state('app.notification', {
    url: "/notifi_settings",
    views: {
      'menuContent': {
        templateUrl: "templates/notifi_settings.html",
        controller:"Notifi_SettingsCtrl"
      }
    },
    onEnter:function($timeout,$rootScope,$ionicScrollDelegate){
      $timeout(function(){
        if(window.localStorage[ls_newsActivated] != undefined){
          if(window.localStorage[ls_newsActivated] == "off"){
            $("#newsInput:checked").prop('checked',false);
          }
             
        }
        if(window.localStorage[ls_videosActivated] != undefined){
          if(window.localStorage[ls_videosActivated] == "off"){
            $("#videosInput:checked").prop('checked',false);
          }
        }
        if(window.localStorage[ls_mvpActivated] != undefined){
          if(window.localStorage[ls_mvpActivated] == "off"){
            $("#mvpInput:checked").prop('checked',false);
          }
        }
        if(window.localStorage[ls_matchesPreferences] != undefined){
          
          if(window.localStorage[ls_matchesPreferences] == "highlights"){
            $("#noneInput:checked").prop('checked',false);
            $("#goalsInput:checked").prop('checked',false);
            $("#highlightsInput:checked").prop('checked',true);
          }else if(window.localStorage[ls_matchesPreferences] == "none"){
            $("#goalsInput:checked").prop('checked',false);
            $("#highlightsInput:checked").prop('checked',false);
            $("#noneInput:checked").prop('checked',true);
          }else{
           
            $("#highlightsInput:checked").prop('checked',false);
            $("#noneInput:checked").prop('checked',false);
            $("#goalsInput:checked").prop('checked',true);
          }
          
       }
       if($rootScope.notify_teams){
         for(var key in $rootScope.notify_teams){
           if(key == cid){
             var teams=$rootScope.notify_teams[key].split(",");
             $("#teamsList input").prop("checked",false);
             for (var i=0;i < teams.length;i++){
                $("#"+teams[i]).prop('checked',true);
             }
           }
         }
       }
       $ionicScrollDelegate.scrollTop();
       /*if(window.localStorage[ls_notify_teams] != undefined){
         var teams= window.localStorage[ls_notify_teams].split(",");
         $("#teamsList input").prop("checked",false);
         for (var i=0;i < teams.length;i++){
           $("#"+teams[i]).prop('checked',true);
         }
       }*/
     },300);
    },
    onExit: function(RegisterService,$rootScope){
      var newsActivated= window.localStorage[ls_newsActivated]= document.getElementById("newsInput").checked? "on":"off";
      var videosActivated= window.localStorage[ls_videosActivated]= document.getElementById("videosInput").checked?"on":"off";
      var matchesPreferences= window.localStorage[ls_matchesPreferences]= document.getElementById("highlightsInput").checked ? "highlights": document.getElementById("goalsInput").checked ? "goals": "none";
      var mvpActivated= window.localStorage[ls_mvpActivated]= document.getElementById("mvpInput").checked ? "on":"off";
      var teams="";
      var teamList=$(".teams-notif input");
      //console.log(teamList);
      for (var i=0;i<$rootScope.teamsList.length;i++){
        console.log($("#"+$rootScope.teamsList[i].id))
        if($("#"+$rootScope.teamsList[i].id).prop("checked")==true){
          teams+= $rootScope.teamsList[i].id;
          teams+=",";
        }
      }
      if(teams.length > 0){
        teams=teams.substr(0,teams.length -1);
      }
      // console.log(cid);
      // console.log(teams);
      $rootScope.notify_teams[cid]=teams;
      // console.log($rootScope.notify_teams);
      window.localStorage.new_notify_teams1=JSON.stringify($rootScope.notify_teams);
      //console.log(teams);
      var teamsToSend="";
      for(var key in $rootScope.notify_teams){
        teamsToSend += $rootScope.notify_teams[key];
      }
      console.log(JSON.stringify($rootScope.notify_teams));
      // alert(matchesPreferences);
      RegisterService.updatePreferences(newsActivated,videosActivated,mvpActivated,matchesPreferences,teamsToSend);
      //console.log(newsActivated +" "+videosActivated+" "+matchesPreferences);
    }
  })
  
  .state('app.home', {
    url: "/home",
    views: {
      'menuContent': {
        templateUrl: "templates/home.html",
        controller: 'LoadingCtrl'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
});