angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $timeout,$location,$ionicHistory, $rootScope,$ionicLoading,$route,$ionicSideMenuDelegate, LoadingService) {
  
    $rootScope.squadViewOk= false;
    $rootScope.inAndroid= ionic.Platform.isAndroid();
    $rootScope.player_selected="";
    $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
         //console.log(toState.name);
        if(onVideoEvent || onNewsEvent)       //for notifications
           $ionicLoading.hide();
           
        if(toState.name !="app.match.matchFanZone" && toState.name != "app.match.matchDesc"){$ionicSideMenuDelegate.canDragContent(true);}
        else $ionicSideMenuDelegate.canDragContent(false);
    });
   
    
    $rootScope.redirectTo = function() {
        // console.log("Current Stat name - "+$ionicHistory.currentStateName());
        // console.log($rootScope.review_detail_msg);
        var currentState= $ionicHistory.currentStateName();
        // console.log(currentState);
        if(currentState== "app.player.infos" ||  currentState== "app.player.videos" || currentState== "app.player.twitter"){
           $location.path("app/team");
        }
        else if(currentState== "app.playerIOS.infos" ||  currentState== "app.playerIOS.videos"){
           $location.path("app/team");
        }
        else if(currentState== "app.match.matchDesc" ||  currentState== "app.match.matchStats" ||  currentState== "app.match.matchFanZone" || currentState=="app.match.matchReviewDetails"){
            if($rootScope.matchFromLive){
                $rootScope.matchFromLive=false;
                $location.path("app/live");
            }else if($rootScope.matchFromHome){
                $rootScope.matchFromHome=false;
               $location.path("app/news");
            }else{
                $location.path("app/matches");
            }
        }
        else if(currentState == "app.match.matchFanZoneTeam"){
            $location.path("app/match/fanzone/"+$rootScope.match_selected);
        }else if (currentState=="app.team"){
            $ionicHistory.nextViewOptions({
            disableBack: true
           });
           $location.path("app/teams");
        }else if (currentState=="app.newsDesc"){
          $ionicHistory.nextViewOptions({
            disableBack: true
           });
           $location.path("app/news");
        }else if (currentState=="app.videosDesc"){
            
            $ionicHistory.nextViewOptions({
            disableBack: true
           });
           if($rootScope.videosFromMatch){
             $ionicHistory.goBack();
           }else{
              $location.path("app/videos");
           }
        }else if (currentState=="app.playerVideosDesc"){
           if($rootScope.inAndroid){
              $location.path("app/player/videos/"+$rootScope.player_selected);
           }else{
               $location.path("app/playerIOS/videos/"+$rootScope.player_selected);
           }
        }else{
           $ionicHistory.goBack();
        }
    };
    $rootScope.changePlayer=function (playerId){
        $rootScope.player_selected= playerId;
        if($rootScope.inAndroid){
            $location.path("app/player/infos/"+playerId)
        }else{
            $location.path("app/playerIOS/infos/"+playerId)
        }
    };
   
   
    
    $rootScope.players_img= function(img_id, width, height){
        //console.log(img_id);
        if (img_id === null){
            var default_url ="img/squad_placeholder.jpg";
            return default_url;
        }else{
            var stripped_img_id= img_id.replace(/-/g,'');
            var domain="https://www.youfoot.com";
            var uri= "/media/images/";
            // var img_url=domain + uri + img_id + "/"+stripped_img_id+"crop_h200w200.png"
             var img_url=domain + uri + img_id + "/"+stripped_img_id+"crop_h"+height+"w"+width+".png";
            return img_url;
        }
    };
    
    $rootScope.selectMenuItem= function(item){
        $(".menuItem").removeClass("active");
        $(".menuItem").css("border-right", "none");
        
        $("#"+item).css("border-right","5px solid #003462");
        // console.log(item);
    };
    $rootScope.animHamburger= function(){
        if($('.appMenu').hasClass("rotate")){
            $('.appMenu').removeClass("rotate");
            $('.appMenu').addClass("rotate2");
        }else if($('.appMenu').hasClass("rotate2")){
            $('.appMenu').removeClass("rotate2");
            $('.appMenu').addClass("rotate");
        }else{
             $('.appMenu').addClass("rotate");
        }
        
    };
    
    $rootScope.OpenSocialPage = function(App){
       // alert(App);
        AppAvailability(App);
    };
      $rootScope.covers={};
  $scope.toggleGroup = function(group) {
    if ($scope.isGroupShown(group)) {
      $scope.shownGroup = null;
    } else {
      $scope.shownGroup = group;
    }
  };
  $scope.isGroupShown = function(group) {
    return $scope.shownGroup === group;
  };
  
    $rootScope.ajaxNews=function(feed,number,scope){
        if (! (navigator.userAgent.indexOf("Windows") >= 0  || navigator.userAgent.indexOf("Macintosh") >= 0)) { 
            if(feed ==null){
                $scope.loadNews(null,number,scope);
            }else{
                $.ajax(feed,
                   { 
                    success:function(data){$scope.loadNews(data,number,scope)},
                    error: function(error){console.log(error)}
                   }
                );
            }
        } else{
            $scope.loadNews(null,number,scope);
        }
    }
    $rootScope.loadNews= function(data,number,scope){
        // console.log(data);
        if(data== null){
           var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function() {
                if (xhttp.readyState == 4 && xhttp.status == 200) {
                //console.log(xhttp);
                myFunction(xhttp);
                }
            }
            xhttp.open("GET", "test.xml", true);
            xhttp.send();

            function myFunction(xml) {
                // console.log(xml);
                 var xmlDoc=xml.responseXML;
                //var  xmlString = new XMLSerializer().serializeToString(xmlDoc);
                //var xmlObj= $.parseXML(xmlString);
               // console.log(xmlObj);
            //   console.log(xmlDoc);
              var  json = $.xml2json(xmlDoc);
               if(number == 1){
                  $rootScope.rss1=json['#document']['rss']["channel"]["item"];
                  $rootScope.setNewsProperly($rootScope.rss1,1,scope);
               }  
               else if(number == 2){
                  $rootScope.rss2=json['#document']['rss']["channel"]["item"];
                  $rootScope.setNewsProperly($rootScope.rss2,2,scope);
               }else if(number == 3){
               $rootScope.rss3=json['#document']['rss']["channel"]["item"];
               $rootScope.setNewsProperly($rootScope.rss3,3,scope); 
            }else if(number == 4){
               $rootScope.rss4=json['#document']['rss']["channel"]["item"];
               $rootScope.setNewsProperly($rootScope.rss4,4,scope); 
            }
              // $rootScope.albums=json['#document']['albums'];
               //console.log($rootScope.albums['#document']['albums']);
            //   console.log($rootScope.rss1);
            //   for(var key in $rootScope.rss1){
                //   console.log(key);
            //   }
            /*var albums=xmlDoc.getElementsByTagName("album");
            for(var i=0;i< albums.length;i++){
                $rootScope.albums[i]={};
                $rootScope.albums[i].title= albums[i].getElementsByTagName("title");
                $rootScope.albums[i].sources=[];
                var sources= albums[i].getElementsByTagName("src");
                for(var j=0;j< sources.length;j++){
                    $rootScope.albums[i].sources[j]=sources.childNodes[0].nodeValue;
                }
            }*/
            //console.log($rootScope.albums);
            }
        }else{
            var xmlDoc=data;
            //$rootScope.albums=xml2array(xmlDoc);
            var  json = $.xml2json(xmlDoc);
            // console.log(JSON.stringify(json));
            if(number == 1){
               $rootScope.rss1=json['#document']['rss']["channel"]["item"];
               $rootScope.setNewsProperly($rootScope.rss1,1,scope);
            }  
            else if(number == 2){
               $rootScope.rss2=json['#document']['rss']["channel"]["item"];
               $rootScope.setNewsProperly($rootScope.rss2,2,scope);
            }else if(number == 3){
               $rootScope.rss3=json['#document']['rss']["channel"]["item"];
               $rootScope.setNewsProperly($rootScope.rss3,3,scope); 
            }else if(number == 4){
               $rootScope.rss4=json['#document']['rss']["channel"]["item"];
               $rootScope.setNewsProperly($rootScope.rss4,4,scope); 
            }
            //var albums=xmlDoc.getElementsByTagName("album");
            
            /*var sources=xmlDoc.getElementsByTagName("src");//.childNodes[0].nodeValue;
            for (var i=0; i< sources.length;i++){
                var source= sources[i].childNodes[0].nodeValue;
                //console.log(source);
                $rootScope.sources[i]=source;
            }*/
        }
    };
    $rootScope.setNewsProperly= function(newsObject,number,scope){
        var items=[];
        var patt= /http[^>]*.{1}(jpg|png)/i;
        for(var i=0; i< newsObject.length;i++){
             var item={};
  	         //console.log(newsObject[i]);
  	         item['title']=newsObject[i]['title'];
  	         item['content']= newsObject[i]['description'];
  	         item['date']=  newsObject[i]['pubDate'];
  	         //item['author']=newsObject[i]['author'];
  	         item['link']=newsObject[i]['link'];
  	         if(newsObject[i]['enclosure'] != undefined){
  	           item['imageLink']=newsObject[i].xmlNode.getElementsByTagName('enclosure')[0].getAttribute('url');
  	         }else if(patt.exec(item['content']) != null){
                 item['imageLink']= patt.exec(item['content'])[0];
  	         }else{
  	           item['imageLink']= 'img/newsplaceholder.png';
  	         }
  	         item['id']= i;
  	         items[i]=item;
        }
        // console.log(items);
        if(number ==1){
        	window.localStorage[ls_news]= JSON.stringify(items);
        } else if(number == 2){
            window.localStorage[ls_news2]= JSON.stringify(items);
        } else if(number == 3){
            window.localStorage[ls_news3]= JSON.stringify(items);
        } else if(number == 4){
            window.localStorage[ls_news4]= JSON.stringify(items);
        }
        if(number == numberOfFeeds){
            scope.$broadcast("rssLoaded");
        }else{
            //$rootScope.ajaxNews(null, number+1,scope);
            $rootScope.ajaxNews(rssFeed[number], number+1,scope);
        }
            
        
    };
  
  
  $scope.changeCompetition = function(com_id){
      var currentState= $ionicHistory.currentStateName();
        if(currentState == "app.notification"){
            setTimeout(function(){
                if(com_id != CurrentCom){
                    $scope.Curr_Com= com_id;
                    CurrentCom = com_id;
                    $rootScope.selectMenuItem("newsMenuItem");
                    window.localStorage.currentid=com_id;	 	 
                	cid  = competition[CurrentCom].cid;
                	cname = competition[CurrentCom].name;
                	champ_slug = competition[CurrentCom].slug;
                	clogo = competition[CurrentCom].logo;
                	csname = competition[CurrentCom].short_name;
                	rssFeed[0]= competition[CurrentCom].rss;
                	hasGroups=competition[CurrentCom].hasGroups;
                	$rootScope.hasGroups=competition[CurrentCom].hasGroups;
                	$rootScope.team_logo="img/"+clogo;
                    $location.path("app/home");
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $rootScope.compRanking=[];
                    $rootScope.rounds = [];
                    $rootScope.teamsList=[];
                    // LoadingService.getIslRanking($scope);
                    // 	LoadingService.initializeRSS($scope);
                    $rootScope.ajaxNews(rssFeed[0],1,$scope);
                    //$rootScope.ajaxNews(null,1,$scope);
                	//LoadingService.getCompetitionCalendar($scope,"start");
                }
            },1000);
        } else {
            if(com_id != CurrentCom){
                $scope.Curr_Com= com_id;
                CurrentCom = com_id;
                $rootScope.selectMenuItem("newsMenuItem");
                window.localStorage.currentid=com_id;	 	 
            	cid  = competition[CurrentCom].cid;
            	cname = competition[CurrentCom].name;
            	champ_slug = competition[CurrentCom].slug;
            	clogo = competition[CurrentCom].logo;
            	csname = competition[CurrentCom].short_name;
            	rssFeed[0]= competition[CurrentCom].rss;
            	hasGroups=competition[CurrentCom].hasGroups;
            	$rootScope.hasGroups=competition[CurrentCom].hasGroups;
            	$rootScope.team_logo="img/"+clogo;
                $location.path("app/home");
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
                $rootScope.compRanking=[];
                $rootScope.rounds = [];
                $rootScope.teamsList=[];
                // LoadingService.getIslRanking($scope);
                // 	LoadingService.initializeRSS($scope);
                $rootScope.ajaxNews(rssFeed[0],1,$scope);
                //$rootScope.ajaxNews(null,1,$scope);
            	//LoadingService.getCompetitionCalendar($scope,"start");
            }
        }
    }
    
    $scope.$on('rssLoaded', function(){
        LoadingService.getIslRanking($scope);
    });
    
    // $scope.$on('CalendarLoaded', function(){
    //     LoadingService.getIslRanking($scope);
    // });
    
    $scope.$on('IslRankingLoaded', function(){
        LoadingService.getIslScorer_Assist($scope);
    });
    
    $scope.$on('IslScorer_AssistLoaded', function(){
        // 	$location.path("app/news");
    });
    
    
  $scope.Curr_Com= CurrentCom;
  $scope.competition=competition;
  
  // accordian menu code en
  
  //$rootScope.chartNumber=0;
  $rootScope.connectionError= connectionErrorWord;
  $rootScope.top_away_players= {};
  $rootScope.top_home_players= {};
  $rootScope.back_Word = back_Word;
  $rootScope.matchDetailTitle = matchDetailTitle;
  $rootScope.matchStatsTitle = matchStatsTitle;
  $rootScope.matchFanZoneTitle = matchFanZoneTitle;
  $scope.menuItems= menuItems;
  $scope.menuWord= menuWord;
  $rootScope.match_selected="";
  $rootScope.MatchList_Details = {};
  $rootScope.MatchList_Statistics = {};
  $rootScope.arrayMatchList_Statistics={};
  $rootScope.arrayMatchList_Details={};
  $rootScope.teamsList=[];
  $rootScope.compRanking={};
  $rootScope.matchFromLive=false;
  
})

.controller('LoadingCtrl' ,function( $scope, $ionicLoading, LoadingService,DatabaseService, $location, $timeout,$ionicHistory, $rootScope ) {
   
   $scope.$on('$ionicView.beforeEnter', function(){
     if($rootScope.inAndroid && fromBackground){
        // LoadingService.initializeRSS($scope);
        $rootScope.ajaxNews(rssFeed[0],1,$scope);
        //$rootScope.ajaxNews(null,1,$scope);
     }
   });
  $scope.showLoading = function() {
    $ionicLoading.show({
      template: "<ion-spinner></ion-spinner><br />Loading"
    });
  };
  
  $scope.showError = function() {
    $ionicLoading.show({
      template: notConnectedWord
    });
  };
    $scope.hide = function(){
        $ionicLoading.hide();
    };
    //DatabaseService.initDatabase();
    $scope.title= homeTitle;
   // $scope.showLoading();
    if(numberOfFeeds > 0){
        // LoadingService.initializeRSS($scope);
        $rootScope.ajaxNews(rssFeed[0],1,$scope);
        //$rootScope.ajaxNews(null,1,$scope);
    }
  
    $scope.$on('rssLoaded', function(){
        //alert("rss loaded");
        LoadingService.getCompetitionCalendar($scope,"start");
    });
  
    $scope.$on("notconnected",function(){
        $scope.showError();
        $ionicHistory.nextViewOptions({
          disableBack: true
        });
        $location.path('app/news');
        $timeout(function(){
            $scope.hide();
        }, 5000);
    });
  
    $scope.$on('CalendarLoaded', function(){
            //change page to news page 
        //LoadingService.getMatchDetails("543d14d4-b5a4-4fee-894c-32650a00bcdd",$scope);
      //alert(onNewsEvent);
        LoadingService.getTeams($scope);
        
    });
  
   $scope.$on('videosLoaded', function(){
        //alert("videos loaded");
        if(! onNewsEvent && ! onVideoEvent && ! onMatchEvent && ! onMvpEvent){
            $ionicHistory.nextViewOptions({
              disableBack: true
            });
            $location.path('app/news');
        }else if(onNewsEvent){
            $location.path('/app/news/first/0'); 
        }else if(onMatchEvent){
            $rootScope.match_selected= match_notified;
            $rootScope.match_selected_isLive= true;
            LoadingService.getMatchDetails(match_notified,$scope);
        }else if(onMvpEvent){
            $rootScope.match_selected= match_notified;
            $rootScope.match_selected_isLive= false;
            LoadingService.getMatchDetails(match_notified,$scope);
        }else if(onVideoEvent)$location.path('/app/videos/'+videoId); 
        LoadingService.getIslRanking($scope);
    });
  
    /*$scope.$on('squadLoaded', function(){
     //alert("squad loaded");
        //LoadingService.getSquadVideos($scope);
    });*/
  
    /*$scope.$on('squadVideosLoaded', function(){
        LoadingService.getSquadCareers($scope);
    });*/
    
    /*$scope.$on('squadCareersLoaded', function(){
        LoadingService.getIslRanking($scope);
    });*/
    $scope.$on("TeamsLoaded",function(){
        if(app_has_videos){
           LoadingService.getVideos($scope, 1);
        }else{
             LoadingService.getSquad($scope);
        }
        
    })
    
    $scope.$on('IslRankingLoaded', function(){
        LoadingService.getIslScorer_Assist($scope);
    });
    
    $scope.$on('IslScorer_AssistLoaded', function(){
        // alert("match detail load");
        //var matchList= JSON.parse(window.localStorage[ls_topMatchlist]);
        //LoadingService.getMatchDetails(matchList, $scope);
        // LoadingService.getMatchStatistics(matchList, $scope);
    });
    
    $scope.$on('MatchDetailsLoaded', function(){
      if(onMatchEvent){
         $location.path("/app/match/commentaires/"+match_notified);
      }else if(onMvpEvent){
         $location.path("/app/match/fanzone/"+match_notified);
      }
      LoadingService.getMatchStatistics(match_notified ,$scope);
    });
   

 })
 
.controller("PollsCtrl", function($scope,$rootScope,LoadingService){
    $scope.title= pollsTitle;
    $scope.$on('$ionicView.beforeEnter',function(event, viewData){
        LoadingService.getPolls($scope);
    });
})
      
.controller('PlayerCtrl',function($scope, $location, $rootScope){
    var urlSplit= $location.url().split('/');
    $scope.playerId=urlSplit[urlSplit.length -1];
    for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           //$scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
   }
   $scope.title= playerInfoTitle;
})

.controller("PlayerVideosCtrl", function($scope, $location,$rootScope){
    var urlSplit= $location.url().split('/');
    $scope.playerId=$rootScope.player_selected;//urlSplit[urlSplit.length -1];
    //console.log($scope.playerId);
    for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           //$scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
    }
    $scope.media_id= $rootScope.overhauledSquadList[$rootScope.player_selected].media_id;
    $scope.title= playerInfoTitle;
     $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
    });
    $scope.watchWord= watchWord;
    $scope.playerVideos=[];
    try{
     $rootScope.squadVideos= JSON.parse(window.localStorage[ls_squadVideos]);
    }catch (e){
        console.log(e);
    }
    //console.log($scope.squadVideos);
    if(Object.keys($scope.squadVideos).length > 0 && $scope.squadVideos[$scope.playerId] != undefined){
        $scope.playerVideos= $rootScope.squadVideos[$rootScope.player_selected];//[$rootScope.player_selected];
    }
    for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           $scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
    }
    
})

.controller("PlayerTwitterCtrl", function($scope, $location, $rootScope){
    //console.log("hello");
    //var urlSplit= $location.url().split('/');
    //$scope.playerId=urlSplit[urlSplit.length -1];
    $scope.title= playerInfoTitle;
     $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
    });
     for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           //$scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
   }
    
})

.controller('PlayerInfosCtrl', function($scope, $location, $rootScope) {
    
    var urlSplit= $location.url().split('/');
    $scope.playerId=urlSplit[urlSplit.length -1];
    
     for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           //$scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
   }
   // $scope.playerId= "4c02757f-531c-456b-b71a-7c7cc1eee52b";
   $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
    });
    $scope.title= playerInfoTitle;
    $scope.playerWord= playerWord;
    $scope.videosWord= videosWord;
    $scope.playerInfosWord= playerInfosWord;
    $scope.careerWord= careerWord;
    $scope.birthdate= birthdateWord;
    $scope.weight= weightWord;
    $scope.height= heightWord;
    $scope.matches= matchesPlayedWord;
    $scope.minutes= minutesPlayedWord;
    $scope.goals= goalsScoredWord;
    $scope.assists = assistsWord;
    
    try{
        $scope.squadData=JSON.parse(window.localStorage[ls_squad]);
        $scope.squadList= $scope.squadData.team.squad;
        $rootScope.squadCareer= JSON.parse(window.localStorage[ls_SquadCareers]);
        //console.log($scope.squadCareer);
        
    }catch(e){
      console.log(e);
    }
    $scope.playerCareerPro=[];
    $scope.playerCareerAmateur=[];
    $scope.showPro=false;
    $scope.showAmateur=false;
    if( $scope.squadCareer[$scope.playerId] != undefined){
       if( $scope.squadCareer[$scope.playerId].player.transfers.pro != undefined){
           $scope.playerCareerPro= $scope.squadCareer[$scope.playerId].player.transfers.pro;
           $scope.showPro=true;
       }
       if( $scope.squadCareer[$scope.playerId].player.transfers.amateur != undefined){
           $scope.playerCareerAmateur= $scope.squadCareer[$scope.playerId].player.transfers.amateur;
           $scope.showAmateur=true;
       }
    }
    $scope.overhauledSquadList= $rootScope.overhauledSquadList;
  //  console.log( $scope.overhauledSquadList);
})

.controller('SquadCtrl', function($scope, $ionicSlideBoxDelegate, $ionicScrollDelegate, $timeout, $rootScope) {
    
    $scope.objectToArray= function (object){
         var arrayToReturn= [];
         var count=0;
         if(object.Goalkeeper != undefined){
             arrayToReturn[count]=object.Goalkeeper;
             count++;
         }
         if(object.Defense != undefined){
             arrayToReturn[count]=object.Defense;
             count++;
         }
         if(object.Midfield != undefined){
             arrayToReturn[count]=object.Midfield;
             count++;
         }
         if(object.Offense != undefined){
             arrayToReturn[count]=object.Offense;
             count++;
         }
         if(object.StaffMembers != undefined){
             arrayToReturn[count]=object.StaffMembers;
             count++;
         }
         if(object.Unknown != undefined){
             arrayToReturn[count]=object.Unknown;
         }
         return arrayToReturn;
   };
   
   for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           $scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
   }
   //$scope.title= $rootScope.teamsList[$rootScope.squad_selected].name;
   //$scope.team_image= $rootScope.teamsList[$rootScope.squad_selected].media_id;
   //alert(typeof window.localStorage[ls_squad]);
   try{
      $scope.squadData= JSON.parse(window.localStorage[ls_squad]);
   }catch(e){
      $scope.squadData={};
   }
   $scope.squadList= $scope.squadData.team.squad;
   try{
   $scope.squadVideos= JSON.parse(window.localStorage[ls_squadVideos]);
   }catch (e){
       //alert(e);
        $scope.squadVideos={};
   }
   $scope.blockSetMenuFunction= false;
   $scope.isViewOk= false;
   $scope.isScrollingMenu=false;
   
   //if($rootScope.overhauledSquadList == undefined){
        $scope.overhauledSquadList= {};
        
        if($scope.squadList.Goalkeeper != undefined){
            for(var i=0; i < $scope.squadList.Goalkeeper.length; i++){
                 $scope.overhauledSquadList[$scope.squadList.Goalkeeper[i].id]= $scope.squadList.Goalkeeper[i];
                 $scope.overhauledSquadList[$scope.squadList.Goalkeeper[i].id].position= goalKeeperWord;
            }
        }
        if($scope.squadList.Defense != undefined){
            for(var i=0; i < $scope.squadList.Defense.length; i++){
                 $scope.overhauledSquadList[$scope.squadList.Defense[i].id]= $scope.squadList.Defense[i];
                 $scope.overhauledSquadList[$scope.squadList.Defense[i].id].position= defenderWord;
            }
        }
        if($scope.squadList.Midfield != undefined){
            for(var i=0; i < $scope.squadList.Midfield.length; i++){
                 $scope.overhauledSquadList[$scope.squadList.Midfield[i].id]= $scope.squadList.Midfield[i];
                  $scope.overhauledSquadList[$scope.squadList.Midfield[i].id].position= midfieldWord;
            }
        }
        if($scope.squadList.Offense != undefined){
            for(var i=0; i < $scope.squadList.Offense.length; i++){
                 $scope.overhauledSquadList[$scope.squadList.Offense[i].id]= $scope.squadList.Offense[i];
                 $scope.overhauledSquadList[$scope.squadList.Offense[i].id].position= offenseWord;
            }
        }
        if($scope.squadList.StaffMembers != undefined){
          for(var i=0; i < $scope.squadList.StaffMembers.length; i++){
             $scope.overhauledSquadList[$scope.squadList.StaffMembers[i].id]= $scope.squadList.StaffMembers[i];
             $scope.overhauledSquadList[$scope.squadList.StaffMembers[i].id].position= staffWord;
          }
        }
        if($scope.squadList.Unknown != undefined){
          for(var i=0; i < $scope.squadList.Unknown.length; i++){
             $scope.overhauledSquadList[$scope.squadList.Unknown[i].id]= $scope.squadList.Unknown[i];
             $scope.overhauledSquadList[$scope.squadList.Unknown[i].id].position= unknownPositionWord;
          }
        }
         
        // console.log($scope.overhauledSquadList);
        $rootScope.overhauledSquadList= $scope.overhauledSquadList;
   /* }else{
        $scope.overhauledSquadList= $rootScope.overhauledSquadList;
    }*/
   
   //----building the top scrollable menu------------
   
   if($scope.squadList.Unknown != undefined){
      $scope.squadList= $scope.objectToArray($scope.squadList);
      $scope.unknownPositions= true;
      $scope.numberOfMenuItems= 8;
      $scope.squadMenu="";
      $scope.squadMenu+='<table id="squadMenuTable" class="squadMenuTableFull"><tr>';
      $scope.squadMenu+='<td class="squadCellFull" id="firstSquadButton"></td>';
      $scope.squadMenu+='<td class="squadCellFull" id="goalkeepersButton">'+goalKeepersWord+'</td>';
      $scope.squadMenu+='<td class="squadCellFull" id="defendersButton">'+defendersWord+'</td>';
      $scope.squadMenu+='<td class="squadCellFull" id="midfieldsButton">'+midfieldsWord+'</td>';
      $scope.squadMenu+='<td class="squadCellFull" id="offenseButton">'+offensesWord+'</td>';
      $scope.squadMenu+='<td class="squadCellFull" id="staffButton">'+staffWord+'</td>';
      $scope.squadMenu+='<td class="squadCellFull" id="unknownButton">'+unknownPositionWord+'</td>';
      $scope.squadMenu+='<td class="squadCellFull" id="lastSquadButton"></td><tr></table>';
          
   }else{
      $scope.squadList= $scope.objectToArray($scope.squadList);
      $scope.unknownPositions= false;
      $scope.numberOfMenuItems= 7;
      $scope.squadMenu="";
      $scope.squadMenu+='<table id="squadMenuTable" class="squadMenuTable"><tr>';
      $scope.squadMenu+= '<td class="squadCell" id="firstSquadButton"></td>';
      $scope.squadMenu+= '<td class="squadCell" id="goalkeepersButton">'+goalKeepersWord+'</td>';
      $scope.squadMenu+= '<td class="squadCell" id="defendersButton">'+defendersWord+'</td>';
      $scope.squadMenu+= '<td class="squadCell" id="midfieldsButton">'+midfieldsWord+'</td>';
      $scope.squadMenu+= '<td class="squadCell" id="offenseButton">'+offensesWord+'</td>';
      $scope.squadMenu+= '<td class="squadCell" id="staffButton">'+staffWord+'</td>';
      $scope.squadMenu+= '<td class="squadCell" id="lastSquadButton"></td></tr></table>';
   }
  
   
   $scope.slider= $ionicSlideBoxDelegate.$getByHandle('squadSlider');
   $scope.selectSlide= function(index){
       //console.log("select slide");
       $scope.blockSetMenuFunction= true;
       $timeout(function(){
           $scope.blockSetMenuFunction= false;
       }, 200);
       $scope.slider.slide(index, 100);
   }
   
    document.getElementById("squadMenu").innerHTML= $scope.squadMenu; 
    $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
        document.getElementById("squadSlider").style.minHeight= (window.innerHeight -90) +'px';
    });
    //$scope.scrollMenuWidth=  document.getElementById("squadMenuTable").clientWidth;
    
     if(! $rootScope.squadViewOk){
       
            if(document.getElementById("unknownButton")!= null){
               document.getElementById("firstSquadButton").style.width= "13.5%";
               document.getElementById("goalkeepersButton").style.width= "11.5%";
               document.getElementById("defendersButton").style.width= "8%";
               document.getElementById("midfieldsButton").style.width= "8%";
               document.getElementById("lastSquadButton").style.width= "21.5%";
             }else{
               document.getElementById("firstSquadButton").style.width= "15.28%";
               document.getElementById("goalkeepersButton").style.width= "13.28%";
               document.getElementById("defendersButton").style.width= "9.78%";
               document.getElementById("midfieldsButton").style.width= "9.78%";
               document.getElementById("lastSquadButton").style.width= "23.28%";
             }
             document.getElementById("goalkeepersButton").style.color= "white";
            
       }
    
    $scope.adjustMenuView= function(index){
       
        var scrollingWidth= document.getElementById("squadMenuTable").clientWidth;
        
        if(index !=0)
         var distance= index * (Math.round(scrollingWidth/ $scope.numberOfMenuItems)) ;
        else distance=0;
       
       //--reset text color to black
       document.getElementById("goalkeepersButton").style.color= subheaderFontColor;
       document.getElementById("defendersButton").style.color= subheaderFontColor;
       document.getElementById("midfieldsButton").style.color= subheaderFontColor;
       document.getElementById("offenseButton").style.color= subheaderFontColor;
       document.getElementById("staffButton").style.color= subheaderFontColor;
       if($scope.unknownPositions){
         document.getElementById("unknownButton").style.color= subheaderFontColor;
       }
       
       //---set the selected item to white font color---
       switch (index){
           case 0: document.getElementById("goalkeepersButton").style.color="white";break;
           case 1: document.getElementById("defendersButton").style.color="white";break;
           case 2: document.getElementById("midfieldsButton").style.color="white";break;
           case 3: document.getElementById("offenseButton").style.color="white";break;
           case 4: document.getElementById("staffButton").style.color="white";break;
           case 5: document.getElementById("unknownButton").style.color="white";break;
       }
         //console.log("adjust menu");
          $scope.blockSetMenuFunction= true;
          $timeout(function(){
            $scope.blockSetMenuFunction= false;
          }, 200);
         $ionicScrollDelegate.scrollTo(distance,0, false);
    }
    
    $scope.adjustView= function(index){
       
       var slides= document.getElementsByName("slideSquad");
       var height= slides[index].children[0].firstChild.scrollHeight;
       height+= 50;    // just to give a little bit of space
       document.getElementById("squadSlider").style.height= height+'px';
       console.log("adjust VIew");
       //---here we set back the dimensions of the menu to the good values because of changes made in "onEnter" function in app.js
       if(! $scope.isViewOk){
            $scope.setMenuWidth();
            $scope.isViewOk=true;
            $rootScope.squadViewOk= true;
       }
      
        $timeout(function(){
           $scope.adjustMenuView(index);
           $ionicSlideBoxDelegate.$getByHandle("squadSlider").update();
        }, 150);
           
    };
    
    $scope.setMenuWidth =function(){
         if($scope.unknownPositions){
                document.getElementById("goalkeepersButton").style.width= "12.5%";
                document.getElementById("firstSquadButton").style.width= "12.5%";
                document.getElementById("defendersButton").style.width= "12.5%";
                document.getElementById("midfieldsButton").style.width= "12.5%";
                document.getElementById("lastSquadButton").style.width= "12.5%";
            }else{
                document.getElementById("firstSquadButton").style.width= "14.28%";
                document.getElementById("goalkeepersButton").style.width= "14.28%";
                document.getElementById("defendersButton").style.width= "14.28%";
                document.getElementById("midfieldsButton").style.width= "14.28%";
                document.getElementById("lastSquadButton").style.width= "14.28%";
                
            }
    };
    
     $scope.setMenu = function(event){
         if(! $scope.isViewOk){
            $scope.setMenuWidth();
            $scope.isViewOk=true;
            $rootScope.squadViewOk= true;
         }
         //console.log("setMenu");
         if(! $scope.blockSetMenuFunction){
             if(! $scope.isScrollingMenu){
                $scope.isScrollingMenu=true;
             }else{
                $timeout.cancel($scope.promise);
             }
             $scope.event=event;
             $scope.promise= $timeout(function(){
                  $scope.isScrollingMenu= false;
                  $scope.moveSlider(event);
             },50);
         }
     };
     
     $scope.moveSlider =function (event){
         var position= $scope.event.detail.scrollLeft;
        // console.log("move slider");
         if(window.innerWidth < 900){
            var scrollingWidth= document.getElementById("squadMenuTable").clientWidth - window.innerWidth;
         }else{
            var scrollingWidth= document.getElementById("squadMenuTable").clientWidth - window.innerWidth+ 275;  // 250 is the width of the menu which is always visible on tablets devices
         }
        // console.log(scrollingWidth);
         var cellWidth = scrollingWidth / ($scope.numberOfMenuItems - 2);
         
         var count=1;
         while(count <= ($scope.numberOfMenuItems - 2)){
             if(position <=cellWidth * count){
                $scope.blockSetMenuFunction= true;
                $scope.adjustMenuView(count -1);
                $scope.selectSlide(count -1);
                $timeout(function(){
                     $scope.blockSetMenuFunction= false;
                }, 500);
                break;
             }
             count++;
         }
     }
    //-----adding listeners--------
    document.getElementById("goalkeepersButton").addEventListener("click", function(event){
        $scope.selectSlide(0);
    });
    document.getElementById("defendersButton").addEventListener("click", function(event){
        $scope.selectSlide(1);
    });
    document.getElementById("midfieldsButton").addEventListener("click", function(event){
        $scope.selectSlide(2);
    });
    document.getElementById("offenseButton").addEventListener("click", function(event){
        $scope.selectSlide(3);
    });
    document.getElementById("staffButton").addEventListener("click", function(event){
        $scope.selectSlide(4);
    });
    if(document.getElementById("unknownButton")!= null){
        document.getElementById("unknownButton").addEventListener("click", function(event){
         $scope.selectSlide(5);
        });
    }
    
})

.controller('VideosDescCtrl', function($scope, $location, $sce, $rootScope) {
   
  $scope.title= videoPlayerTitle;
  var urlSplit= $location.url().split('/');
  $scope.videoId=urlSplit[urlSplit.length -1];  
  
  //$scope.back= videosTitle;
  if(videoSite.toLowerCase() == "dailymotion"){
    $scope.urlVideo= "https://www.dailymotion.com/embed/video/"+$scope.videoId+"?logo=0&info=0&fullscreen=1";
  }else{
     $scope.urlVideo="https://www.youtube.com/embed/"+$scope.videoId+"?showinfo=0&frameborder=0" ;
  }
  $scope.urlVideoTrusted= $sce.trustAsResourceUrl($scope.urlVideo);
  $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
  });
  $scope.$on('$ionicView.leave', function (event, viewData) {
      $rootScope.videosFromMatch=false;
  });
  
})

.controller('PlayerVideosDescCtrl', function($scope, $location, $sce, $rootScope) {
   
  $scope.title= videoPlayerTitle;
  var urlSplit= $location.url().split('/');
  $scope.index=urlSplit[urlSplit.length -1];
  $scope.playerId=$rootScope.player_selected;
    
     for (var i=0; i< $rootScope.teamsList.length;i++){
       if($rootScope.squad_selected==$rootScope.teamsList[i].id){
         
           //$scope.title=$rootScope.teamsList[i].name;
           $scope.team_image=$rootScope.teamsList[i].media_id;
       }
   }
  $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
  });
   
  if($rootScope.squadVideos[$rootScope.player_selected][$scope.index].media_type == "dailymotion"){
      var splitted= $rootScope.squadVideos[$rootScope.player_selected][$scope.index].url.split("/");
      $scope.videoId=  splitted[splitted.length - 1];
      $scope.urlVideo= "https://www.dailymotion.com/embed/video/"+$scope.videoId+"?logo=0&info=0&fullscreen=1";
  }else{
      var start="";
      var end="";
      var url= $rootScope.squadVideos[$rootScope.player_selected][$scope.index].url;
      if($rootScope.squadVideos[$rootScope.player_selected][$scope.index].start_time != undefined)
         start= $rootScope.squadVideos[$rootScope.player_selected][$scope.index].start_time;
      if($rootScope.squadVideos[$rootScope.player_selected][$scope.index].end_time != undefined)
         end=  $rootScope.squadVideos[$rootScope.player_selected][$scope.index].end_time;
      var regExp = /^.*(youtu.be\/|v\/|u\/\w\/|embed\/|watch\?v=|\&v=)([^#\&\?]*).*/;
      var match = url.match(regExp);
            if (match && match[2].length == 11) {
               $scope.videoId=match[2];
            } else {
               $scope.videoId="";
            }
     
      $scope.urlVideo="https://www.youtube.com/embed/"+$scope.videoId+"?showinfo=0&frameborder=0&start="+start+"&end="+end;
      $scope.urlVideoTrusted= $sce.trustAsResourceUrl($scope.urlVideo);
  }
  $scope.urlVideoTrusted= $sce.trustAsResourceUrl($scope.urlVideo);
})

.controller('VideosCtrl', function($scope, $timeout, LoadingService, $rootScope) {
  $scope.title= videosTitle;
  try{
    $scope.videosList= JSON.parse(window.localStorage[ls_videos]);
  }catch (e){
      $scope.videosList={};
  }
  $scope.refreshText= pullToRefreshText;
  $scope.moreVideos=true;
 
  
  $scope.firstVideo=$scope.videosList[0];
  $scope.videosList=$scope.videosList.slice(1);
  
  $scope.doRefresh = function() {
      LoadingService.getVideos($scope);
      $scope.moreVideos=true;
  };
  
   $scope.loadMore = function() {
       //console.log(LoadingService.nextPageToken);
       //console.log($scope.moreVideos);
       if($scope.moreVideos){
            //console.log("loading more"); 
            LoadingService.getMoreVideos($scope);
       } else{
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }
   }; 
  
  $scope.$on('videosLoaded', function(){
        
        $scope.videosList= JSON.parse(window.localStorage[ls_videos]);
        $scope.firstVideo=$scope.videosList[0];
        $scope.videosList=$scope.videosList.slice(1);
        $scope.pageNumber=2; 
        $scope.$broadcast("scroll.refreshComplete");
  });
//   $rootScope.inAndroid = true;
    $scope.playYouTubeVideo = function(videoId){
        if($rootScope.inAndroid){
            VideoPlayer.play("https://www.youtube.com/watch?v="+videoId);
            // openInChildBrowser("https://www.youtube.com/watch?v="+videoId);
            // VideoPlayer.play("file:///android_asset/www/movie.mp4");
            
            // VideoPlayer.play("file:///android_asset/www/movie.mp4");
            // VideoPlayer.play("https://www.youtube.com/embed/"+videoId);
            // YoutubeVideoPlayer.openVideo("https://www.youtube.com/watch?v="+videoId);    
        } else{
            YoutubeVideoPlayer.openVideo(videoId);    
        }
    }
    
  $scope.$on('moreVideosLoaded', function(){
       // console.log("more videosLoaded");
        $scope.videosList= JSON.parse(window.localStorage[ls_videos]);
        $scope.firstVideo=$scope.videosList[0];
        $scope.videosList=$scope.videosList.slice(1);
        $scope.$broadcast('scroll.infiniteScrollComplete');
  });
   $scope.$on('moreVideosErrors', function(){
        $scope.$broadcast('scroll.infiniteScrollComplete');
   });
  
  $scope.$on("noMoreVideos", function(){
      //alert("no more");
      $scope.moreVideos=false;
  })
})

.controller('GalleryCtrl', function($scope, $rootScope){
    $scope.title= galleryTitle;
})

.controller("FeaturesCtrl", function($scope, LoadingService, $location,$rootScope){
    $scope.featureslist= JSON.parse(window.localStorage[ls_news2]);
    $scope.title= featuresTitle;
     $scope.refreshText= pullToRefreshText;
    
    $scope.showInfo =function(event, rss){
    
     var currentNewsId= angular.element(event.currentTarget).attr('index');
     $location.path('/app/news/'+rss+'/'+currentNewsId);
    };
    
    $scope.doRefresh = function() {
        //   LoadingService.initializeRSS($scope);
        $rootScope.ajaxNews(rssFeed[0],1,$scope);
        //$rootScope.ajaxNews(null,1,$scope);
    };
    
    $scope.$on('rssLoaded', function(){
        $scope.featureslist= JSON.parse(window.localStorage[ls_news2]);
        $scope.$broadcast("scroll.refreshComplete");
    });
})

.controller("InterviewsCtrl", function($scope, LoadingService, $location,$rootScope){
    $scope.interviewslist= JSON.parse(window.localStorage[ls_news3]);
    $scope.title= interviewsTitle;
    $scope.refreshText= pullToRefreshText;
  //  console.log($scope.interviewslist);
    $scope.showInfo =function(event, rss){
    
       var currentNewsId= angular.element(event.currentTarget).attr('index');
       $location.path('/app/news/'+rss+'/'+currentNewsId);
    };
    
    $scope.doRefresh = function() {
        // LoadingService.initializeRSS($scope);
        $rootScope.ajaxNews(rssFeed[0],1,$scope);
        //$rootScope.ajaxNews(null,1,$scope);
    };
    
    $scope.$on('rssLoaded', function(){
        $scope.interviewslist= JSON.parse(window.localStorage[ls_news3]);
        $scope.$broadcast("scroll.refreshComplete");
    });
    
})

.controller("RssVideosCtrl", function($scope, LoadingService, $location,$rootScope){
    $scope.videoslist= JSON.parse(window.localStorage[ls_news4]);
    $scope.title= rssVideosTitle;
    $scope.refreshText= pullToRefreshText;
})

.controller("LiveCtrl", function($scope, LoadingService, $location,$rootScope){
    
    $scope.title= "Today's Matches";
     $scope.refreshText= pullToRefreshText;
    try{
      $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
    }catch(e){
      $scope.calendar={};
    }
    $scope.matchNotCommented = matchNotCommentedWord;
    $scope.vsWord = vsWord;
    $scope.connectionError= connectionErrorWord;
    $scope.letters=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
    
    $scope.isMatchToday=function(time){
        //console.log(time);
        //var match_date= new Date(time);
        // var now = new Date();
        // var matchMonth= time.substr(5,2);
        // matchMonth= parseInt(matchMonth) -1;
        // var matchDay= time.substr(8,2);
        
        var a = moment();
        var b = moment(time);
        var t = b.diff(a, 'days'); // positive values for upcoming
        
       // console.log(t);
        //console.log(now.getMonth()+"--"+match_date.getMonth());
        // if(now.getMonth()== matchMonth && now.getDate()== matchDay){
        if(t==0 && a.date() == b.date()){
            return true;
        }else{
            return false;
        }
    }
    $scope.matchesLive= false;
    $scope.upcomingMatches=false;
    
	$scope.createList= function(){
	    var data=$scope.calendar;
	  //  console.log(data);
	    //console.log(year);
	    var todayYear= new Date().getFullYear();
	    //todayYear =todayYear -1;
        var todayMonth= new Date().getMonth();
		var nextMatchDay='';
		var nextMatchMonth='';
		var nextMatchYear='';
		todayMonth++;
		var todayDay= new Date().getDate();
	    var matchesLive=[];
	    var upcomingMatches=[];
	    if(data.Calendar.championship != undefined && data.Calendar.championship.StageRound != undefined){
	       
		//console.log(data.team_logos);
		upcomingMatches=[];
		$.each(data.Calendar.championship.StageRound, function(j2,v2){ //going through each round of the championship
		// $.each(data.Calendar['knockout-no-brackets'].StageRound, function(j2,v2){ //going through each round of the knockout no brackets competition
			//if (debugThisDamnFunction) console.log('	Round: '+ (j2+1));							
			 
			// var parsed = JSON.stringify(v2.matches[0].Match.start_time);
		//	m = 0;
			if(v2.matches !== undefined && v2.matches.length > 0){	
			    
    			$.each(v2.matches, function(j3,v3){ // the individual matches		
                    var thisMatch={};							
    				//m++; //match number in this round
    				thisMatch= v3;
    				//thisMatch.matchId = v3["Match"]['id'];
    				var matchTimeUTC = v3['Match']['start_time_utc'];
    				 //thisMatch.matchTimeUTC=v3['Match']['start_time_utc'];
    				 //thisMatch.matchTime = v3['Match']['start_time'];
    				 var venue=v3['Venue']['name'];
    				 var matchYear= parseInt(matchTimeUTC.substr(0,4));
    				 var matchMonth= parseInt(matchTimeUTC.substr(5,2));
    				 var matchDay= parseInt(matchTimeUTC.substr(8,2));
    				 
    				if(matchDay == todayDay && matchMonth == todayMonth && matchYear == todayYear){
    				    $scope.matchesLive=true;
                        matchesLive.push(thisMatch);
    					//count++;
                    }else if((matchDay > todayDay && matchMonth >= todayMonth && matchYear== todayYear) || (matchDay <= todayDay && matchMonth > todayMonth && matchYear== todayYear) || (todayYear < matchYear)){
    				    $scope.upcomingMatches= true;
                        if(nextMatchDay	== ''){
                           nextMatchDay= matchDay;
                           nextMatchMonth= matchMonth;
                           nextMatchYear= matchYear;
                        //   console.log(thisMatch);
    					   upcomingMatches[0]=thisMatch;
                        }else if((matchDay < nextMatchDay && matchMonth <= nextMatchMonth) || (matchDay >= nextMatchDay && matchMonth < nextMatchMonth) || (matchYear < nextMatchYear)){
    					   // upcomingMatches=[];
    					   // console.log(thisMatch);
    					   // console.log(thisMatch.Match.start_time);
    					   // console.log(upcomingMatches);
    					    
    					    if(upcomingMatches.length!=0){
        					    var a = moment(upcomingMatches[0].Match.start_time);
                                var b = moment(thisMatch.Match.start_time);
                                var t = a.diff(b, 'days') // 1
        					   // console.log(t+" - "+upcomingMatches[0].Match.start_time+" - "+thisMatch.Match.start_time);
                                if(t>=0){
        					        upcomingMatches[0]=thisMatch;
                                }
    					    } else{
    					        upcomingMatches[0]=thisMatch;
    					    }
                            
                        }else if(matchDay == nextMatchDay && matchMonth == nextMatchMonth && matchYear == nextMatchYear){
    				// 	  console.log(thisMatch);
                           upcomingMatches.push(thisMatch);
                        }	
                    }									
                });	
			}								
			});
			 //  console.log($scope.match_list);
	    }
	    if(data.Calendar['knockout-brackets'] != undefined && data.Calendar['knockout-brackets'].StageRound != undefined && matchesLive.length==0 && upcomingMatches.length == 0){
	        $.each(data.Calendar['knockout-brackets'].StageRound, function(j2,v2){ //going through each round of the championship
		    // $.each(data.Calendar['knockout-no-brackets'].StageRound, function(j2,v2){ //going through each round of the knockout no brackets competition
			//if (debugThisDamnFunction) console.log('	Round: '+ (j2+1));							
			 
			// var parsed = JSON.stringify(v2.matches[0].Match.start_time);
		    //	m = 0;
			if(v2.matches !== undefined && v2.matches.length > 0){							
			$.each(v2.matches, function(j3,v3){ // the individual matches		
                var thisMatch={};							
				//m++; //match number in this round
				thisMatch=v3;
				//thisMatch.matchId = v3["Match"]['id'];
				var matchTimeUTC = v3['Match']['start_time_utc'];
				 //thisMatch.matchTimeUTC=v3['Match']['start_time_utc'];
				 //thisMatch.matchTime = v3['Match']['start_time'];
				 var venue=v3['Venue']['name'];
				 var matchYear= parseInt(matchTimeUTC.substr(0,4));
				 var matchMonth= parseInt(matchTimeUTC.substr(5,2));
				 var matchDay= parseInt(matchTimeUTC.substr(8,2));
				 if(matchDay == todayDay && matchMonth == todayMonth && matchYear == todayYear){
				    $scope.matchesLive=true;
                    matchesLive.push(thisMatch);
					//count++;
                }else if((matchDay > todayDay && matchMonth >= todayMonth && matchYear== todayYear) || (matchDay <= todayDay && matchMonth > todayMonth && matchYear== todayYear) || (todayYear < matchYear)){
				    $scope.upcomingMatches= true;
                    if(nextMatchDay	== ''){
                       nextMatchDay= matchDay;
                       nextMatchMonth= matchMonth;
                       nextMatchYear= matchYear;
                    //   console.log(thisMatch);
					   upcomingMatches[0]=thisMatch;
                    }else if((matchDay < nextMatchDay && matchMonth <= nextMatchMonth) || (matchDay >= nextMatchDay && matchMonth < nextMatchMonth) || (matchYear < nextMatchYear)){
					   
					   upcomingMatches=[];
					   //console.log(thisMatch);
					   upcomingMatches[0]=thisMatch;
                    }else if(matchDay == nextMatchDay && matchMonth == nextMatchMonth && matchYear == nextMatchYear){
                        // console.log(thisMatch);
                       upcomingMatches.push(thisMatch);
                    }	
                 }									
                });	
				}								
			});
	    }
       if(matchesLive.length == 0)
          $scope.match_list=upcomingMatches;
       else
          $scope.match_list= matchesLive;
          
        console.log($scope.match_list);
	  };
    $scope.createList();
   
    
    $scope.doRefresh=function(){
        LoadingService.getCompetitionCalendar($scope);
    }
    
    $scope.$on("CalendarLoaded",function(){
       try{
          $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
       }catch(e){
          $scope.calendar={};
       }
       $scope.createList();
       $scope.$broadcast("scroll.refreshComplete");
    });
    
    $scope.$on("CalendarError",function(){
       $scope.$broadcast("scroll.refreshComplete");
    });
    
     $scope.getMatchDetails=function(item){
        // alert(index);
           
         $(".matchLoader").css("display","block");
        $("#spinMatchLoad").show();
        
        $rootScope.match_selected= item.Match.id;
        $rootScope.Match=item;
       // console.log($rootScope.Match);
        //console.log($scope.matchList[index].Match.start_time_utc);
        //console.log($scope.matchList[index].Match.start_time);
        
        var d = new Date()
        var n = d.getTimezoneOffset();
        //console.log(n);
        var match_date= moment(item.Match.start_time_utc).valueOf() - (n*60*1000);
        var now= moment().valueOf();
        
        if(match_date - 60 * 1000 * 30 < now  && match_date + 60 * 1000 * 60 * 2.4 > now ){
            $rootScope.match_selected_isLive= true;
            $rootScope.match_selected_isUpcoming=false;
            LoadingService.getCompetitionCalendar($scope);   // need to call this function to update the score in the header of match description
            LoadingService.getMatchDetails($rootScope.match_selected, $scope);
            LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
        }else{
            $rootScope.match_selected_isLive= false;
            if(match_date - 60 * 1000 * 30 > now ){
                $rootScope.match_selected_isUpcoming=true;
            }else{
                $rootScope.match_selected_isUpcoming=false;
            }
        }
        
        
        
        //console.log('loadded and navigate to commentries');
        //$("#spinMatchLoad").hide();
       
        if($rootScope.match_selected_isUpcoming == true){
            $(".matchLoader").css("display","none");
            $("#matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
            $(".matchLoader").css("display","none");
        }else{
            if(!$rootScope.arrayMatchList_Details[$rootScope.match_selected] && !$rootScope.match_selected_isLive){
            // $rootScope.match_selected = 
             // console.log($rootScope.arrayMatchList_Details);
              LoadingService.getMatchDetails($rootScope.match_selected, $scope);
              LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
            }else{
                $(".matchLoader").css("display","none");
                $rootScope.matchFromLive=true;
                $location.path("/app/match/commentaires/"+$rootScope.match_selected);
                /*if(!$rootScope.arrayMatchList_Statistics[$rootScope.match_selected]){
                    LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
                }*/
           }
        }
    };
    
    $scope.$on('MatchDetailsLoaded', function(){
        console.log($rootScope.match_selected);
        $(".matchLoader").css("display","none");
        $("#spinMatchLoad").hide();       
        if($rootScope.match_selected!=""){
            if($rootScope.match_selected_isUpcoming == true|| !$rootScope.arrayMatchList_Details[$rootScope.match_selected]){
                 $(".matchLoader").css("display","none");
                //$("#spinMatchLoad").hide();
                $("#matchesView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
            } else{
                if($rootScope.match_selected_isLive){
                    $rootScope.MatchList_Details= $rootScope.MatchList_Details.reverse();
                }
                $(".matchLoader").css("display","none");
                $("#spinMatchLoad").hide();
                $rootScope.matchFromLive=true;
                $location.path("/app/match/commentaires/"+$rootScope.match_selected);
            }
        }
    });
     
     $scope.$on('MatchDetailsError', function(){
         $(".matchLoader").css("display","none");
         //$("#spinMatchLoad").hide();
         $("#liveView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
    });
})

.controller("TeamsCtrl", function($scope, LoadingService, $location,$rootScope){
    
    $scope.title= "Teams";
    // console.log($rootScope.teamsList);
    $scope.getSquad= function(id){
        //alert(id);
        $(".matchLoader").css("display","block");
        $("#spinMatchLoad").show();
        $rootScope.squad_selected= id;
        LoadingService.getSquad($scope,id);
    }
    //console.log($rootScope.teamsList);
    $scope.$on('SquadLoaded', function(){
        //alert("squad loaded");
        LoadingService.getSquadVideos($scope);
    });
    $scope.$on('SquadVideosLoaded', function(){
        $(".matchLoader").css("display","none");
        $("#spinMatchLoad").hide();
        $location.path('/app/team');
        LoadingService.getSquadCareers($scope);
    });
    $scope.$on('SquadCareersLoaded', function(){
    })
})

.controller("NewsCtrl", function($scope, $filter, $timeout, $location,$ionicSlideBoxDelegate,LoadingService,$rootScope){
  
    if(window.localStorage[ls_news] != undefined ){
        try{
            $scope.newslist= JSON.parse(window.localStorage[ls_news]);
        }catch(e){
            // $scope.newslist=[];
            // LoadingService.initializeRSS($scope);
            $rootScope.ajaxNews(rssFeed[0],1,$scope);
            //$rootScope.ajaxNews(null,1,$scope);
        }
    }
  
        try{
            $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
        }catch(e){
            $scope.calendar={};
        }
    console.log($scope.calendar);
    $scope.getMedia=function(id){
        for (var i=0; i < $rootScope.teamsList.length;i++){
            if (id == $rootScope.teamsList[i].id){
                return $rootScope.teamsList[i].media_id;
            }
        }
        return undefined;
    };
    $scope.getWeekNumber= function(d) {
			// Copy date so don't modify original
			d = new Date(+d);
			d.setHours(0,0,0);
			// Set to nearest Thursday: current date + 4 - current day number
			// Make Sunday's day number 7
			d.setDate(d.getDate() + 4 - (d.getDay()||7));
			// Get first day of year
			var yearStart = new Date(d.getFullYear(),0,1);
			// Calculate full weeks to nearest Thursday
			var weekNo = Math.ceil(( ( (d - yearStart) / 86400000) + 1)/7)
			// Return array of year and week number
			// return [d.getFullYear(), weekNo];
			return weekNo;
	};
	
	$scope.is_match_upcoming = function(matchTime){
        var d = new Date()
        var n = d.getTimezoneOffset();
        //console.log(n);
        var match_date= moment(matchTime).valueOf() - (n*60*1000);
        var now= moment().valueOf();
        
        if(match_date - 60 * 1000 * 30 > now ){
            return true;
        }else{
            return false;
        }
    }
    
    $scope.is_match_live = function(matchTime){
        var d = new Date()
        var n = d.getTimezoneOffset();
        //console.log(input);
        //console.log(timeUTC);
        var match_date= moment(matchTime).valueOf() - (n*60*1000);
        var now= moment().valueOf();
        if(match_date - 60 * 1000 * 30 < now  && match_date + 60 * 1000 * 60 * 2.4 > now){
            return true; //live
        }else{
            // var mydate="";
            //var date=new Date(input);
    //  		var secondPart= moment(input).format("H:mm - dddd D MMM gggg");
    // 		mydate+= secondPart;
            return false; // notlive
        }
        
    }
    $scope.isMatchToday=function(time){
        //console.log(time);
        //var match_date= new Date(time);
        // var now = new Date();
        // var matchMonth= time.substr(5,2);
        // matchMonth= parseInt(matchMonth) -1;
        // var matchDay= time.substr(8,2);
        
        var a = moment();
        var b = moment(time);
        var t = b.diff(a, 'days'); // positive values for upcoming
        
       // console.log(t);
        //console.log(now.getMonth()+"--"+match_date.getMonth());
        // if(now.getMonth()== matchMonth && now.getDate()== matchDay){
        if(t==0 && a.date() == b.date()){
            return true;
        }else{
            return false;
        }
    }
    
    console.log($scope.calendar);
    $scope.getCurrentRound= function(){
        var data=$scope.calendar;
        var today = new Date();
  		var yyyy = today.getFullYear();
  		var MM = today.getMonth()+1;
  		var dd = today.getDate();
  		//var hh = today.getHours();
  		//var mm = today.getMinutes();
  		//var ss = today.getSeconds();
  		var todaysDate = yyyy+'-'+MM+'-'+dd; //+' '+hh+'-'+mm+'-'+ss;
  		//var currentRoundNum = '';
  		//var matchInfoBoxNewsHTML = '';
  		//var j =1;
  		// today = new Date('February 25, 2015 11:13:00'); //used to fake today's date for testing.
  		// console.log(today);
  		if($rootScope.hasGroups==0){
        var minWeek=-1;
  		var totalMatches = 0;
  		var currentRoundNum=0;		
  	    var countStages=0;
  	    var noMoreRounds=true;
  	   var gotlivematch= false;
  		$.each(data.Calendar['championship'].StageRound, function(stgIdx, stgVal) {
  		    if(gotlivematch == false){
      			var numberOfMatchesComing=0;
      			totalMatches = stgVal.matches.length;
      			// console.log("totalMatches: "+totalMatches);							
      			$.each(stgVal.matches, function(mtchIdx, mtchVal) {
      			        
      					if ($rootScope.inAndroid) {
      						var startTime = new Date(mtchVal.Match.start_time); //.substring(0,11);
      					} else {
      						var startDate = mtchVal.Match.start_time.substr(0,11);
      						startDate = startDate.replace(/-/g,"/");
      						var startTime = new Date(startDate);
      					}
      					var sWeek = $scope.getWeekNumber(startTime);
      					var tWeek = $scope.getWeekNumber(today);
                           // console.log("today: "+ tWeek);
      					 // console.log("next round: "+ sWeek);
      					if (sWeek >= tWeek){
      					     numberOfMatchesComing++; 
      					}
      					
      						var a = moment(mtchVal.Match.start_time);
                            var b = moment();
                            var t = a.diff(b, 'days') //
                            // console.log(t);
        					if($scope.is_match_live(startTime) || t == 0){ // pass start_time_utc
        					    noMoreRounds = false;
        					    currentRoundNum = stgIdx;
        					    gotlivematch= true;
        					} else if($scope.is_match_upcoming(startTime) && noMoreRounds == true){
    					    noMoreRounds = false;
    					    currentRoundNum = stgIdx;
    					}
    					
      					 // console.log("numberOfMatchesComing: "+numberOfMatchesComing);
      					if(numberOfMatchesComing == totalMatches){
      					    noMoreRounds=false;
      						if(minWeek == -1){
      						   minWeek = sWeek;
      						   currentRoundNum = stgIdx;
      						 }
      						if(sWeek < minWeek){ 
      						 minWeek= sWeek;
      							currentRoundNum = stgIdx;
      						 }
      					}
      					// console.log("	startTime: "+startTime+'  todaysDate: '+todaysDate);
      			});
      			countStages++;
  		    }
  		});
  		console.log(countStages);
  		    if(gotlivematch ==true){
		        currentRoundNum = currentRoundNum; 
		    } else if (currentRoundNum ==0 && noMoreRounds && data.Calendar['knockout-brackets'] == undefined) {
    		    if($scope.is_match_upcoming(data.Calendar['championship'].StageRound[0].matches[0].Match.start_time)){
                    currentRoundNum = 0;    		        
    		    }else{
    		        currentRoundNum= countStages -1;
    		    }
    		  //  console.log("currentRoundNum"+currentRoundNum);
    		} else if(currentRoundNum !=0){
		    currentRoundNum= currentRoundNum -1;
		    }
  		// if (currentRoundNum ==0 && noMoreRounds) currentRoundNum= countStages -1;
  		    $scope.match_list= $scope.calendar.Calendar.championship.StageRound[currentRoundNum].matches;
  		}else{
  		    
  					
  				    var d = new Date()
                      var n = d.getTimezoneOffset();
                      //console.log(n);
          			
      				 var now= moment().valueOf();
  		// 			console.log(now);
  					var minTimeStamp= 0;
  					
  					var sliderMatches= [];
  					$.each(data.Calendar.championship.StageRound,function (key,value){
  						// console.log(value);
  						for (var i=0; i < value.matches.length;i++){
  							var match_date= moment(value.matches[i].Match.start_time_utc).valueOf() - (n*60*1000);
  							if(minTimeStamp==0){
  								minTimeStamp= match_date;
  							}
  							
  							if(match_date < now ){
  						// 		console.log("hello");
  								
  								if(sliderMatches.length < 5){
  									if(match_date < minTimeStamp){
  										minTimeStamp= match_date;
  									}
  									sliderMatches.push(value.matches[i]);
  									
  								}else if(match_date > minTimeStamp){
  									sliderMatches.push(value.matches[i]);	
  									sliderMatches.sort(function(a,b){
  										if(moment(a.Match.start_time_utc).valueOf() < moment(b.Match.start_time_utc).valueOf()){
  											return 1;
  										}else{
  											return -1;
  										}
  									})
  									sliderMatches=sliderMatches.slice(0, 5);
  								}
  							}
  						}
  					});
  					if(data.Calendar['knockout-brackets']!=undefined && data.Calendar['knockout-brackets'].StageRound != undefined){
  					$.each(data.Calendar['knockout-brackets'].StageRound,function (key,value){
  					    	// console.log(value);
  						for (var i=0; i < value.matches.length;i++){
  							var match_date= moment(value.matches[i].Match.start_time_utc).valueOf() - (n*60*1000);
  							if(minTimeStamp==0){
  								minTimeStamp= match_date;
  							}
  							
  							if(match_date < now ){
  						// 		console.log("hello");
  								
  								if(sliderMatches.length < 5){
  									if(match_date < minTimeStamp){
  										minTimeStamp= match_date;
  									}
  									sliderMatches.push(value.matches[i]);
  									
  								}else if(match_date > minTimeStamp){
  									sliderMatches.push(value.matches[i]);	
  									sliderMatches.sort(function(a,b){
  										if(moment(a.Match.start_time_utc).valueOf() < moment(b.Match.start_time_utc).valueOf()){
  											return 1;
  										}else{
  											return -1;
  										}
  									})
  									sliderMatches=sliderMatches.slice(0, 5);
  								}
  							}
  						}
  					});
  					}
  		// 			console.log(sliderMatches);
  		            $scope.match_list= sliderMatches;
    		}
    		//var delayedMatch = false // this bool is set to see if this round has a delayed match.
    		//var matchWeek = ''; // number of the week of the match. Used to check if there's a delayed match.
    		// $('.roundNum').html('Round #'+(currentRoundNum+1));	
    	
        }
    
    $scope.createList= function(){
	    var data=$scope.calendar;
	  //  console.log(data);
	    //console.log(year);
	    var todayYear= new Date().getFullYear();
	    //todayYear =todayYear -1;
        var todayMonth= new Date().getMonth();
		var nextMatchDay='';
		var nextMatchMonth='';
		var nextMatchYear='';
		todayMonth++;
		var todayDay= new Date().getDate();
	    var matchesLive=[];
	    var upcomingMatches=[];
	    if(data.Calendar.championship != undefined && data.Calendar.championship.StageRound != undefined){
	       
		//console.log(data.team_logos);
		upcomingMatches=[];
		$.each(data.Calendar.championship.StageRound, function(j2,v2){ //going through each round of the championship
		// $.each(data.Calendar['knockout-no-brackets'].StageRound, function(j2,v2){ //going through each round of the knockout no brackets competition
			//if (debugThisDamnFunction) console.log('	Round: '+ (j2+1));							
			 
			// var parsed = JSON.stringify(v2.matches[0].Match.start_time);
		//	m = 0;
			if(v2.matches !== undefined && v2.matches.length > 0){	
			    
    			$.each(v2.matches, function(j3,v3){ // the individual matches		
                    var thisMatch={};							
    				//m++; //match number in this round
    				thisMatch= v3;
    				//thisMatch.matchId = v3["Match"]['id'];
    				var matchTimeUTC = v3['Match']['start_time_utc'];
    				 //thisMatch.matchTimeUTC=v3['Match']['start_time_utc'];
    				 //thisMatch.matchTime = v3['Match']['start_time'];
    				 var venue=v3['Venue']['name'];
    				 var matchYear= parseInt(matchTimeUTC.substr(0,4));
    				 var matchMonth= parseInt(matchTimeUTC.substr(5,2));
    				 var matchDay= parseInt(matchTimeUTC.substr(8,2));
    				 
    				if(matchDay == todayDay && matchMonth == todayMonth && matchYear == todayYear){
    				    $scope.matchesLive=true;
                        matchesLive.push(thisMatch);
    					//count++;
                    }else if((matchDay > todayDay && matchMonth >= todayMonth && matchYear== todayYear) || (matchDay <= todayDay && matchMonth > todayMonth && matchYear== todayYear) || (todayYear < matchYear)){
    				    $scope.upcomingMatches= true;
                        if(nextMatchDay	== ''){
                           nextMatchDay= matchDay;
                           nextMatchMonth= matchMonth;
                           nextMatchYear= matchYear;
                        //   console.log(thisMatch);
    					   upcomingMatches[0]=thisMatch;
                        }else if((matchDay < nextMatchDay && matchMonth <= nextMatchMonth) || (matchDay >= nextMatchDay && matchMonth < nextMatchMonth) || (matchYear < nextMatchYear)){
    					   // upcomingMatches=[];
    					   // console.log(thisMatch);
    					   // console.log(thisMatch.Match.start_time);
    					   // console.log(upcomingMatches);
    					    
    					    if(upcomingMatches.length!=0){
        					    var a = moment(upcomingMatches[0].Match.start_time);
                                var b = moment(thisMatch.Match.start_time);
                                var t = a.diff(b, 'days') // 1
        					   // console.log(t+" - "+upcomingMatches[0].Match.start_time+" - "+thisMatch.Match.start_time);
                                if(t>=0){
        					        upcomingMatches[0]=thisMatch;
                                }
    					    } else{
    					        upcomingMatches[0]=thisMatch;
    					    }
                            
                        }else if(matchDay == nextMatchDay && matchMonth == nextMatchMonth && matchYear == nextMatchYear){
    				// 	  console.log(thisMatch);
                           upcomingMatches.push(thisMatch);
                        }	
                    }									
                });	
			}								
			});
			 //  console.log($scope.match_list);
	    }
	    if(data.Calendar['knockout-brackets'] != undefined && data.Calendar['knockout-brackets'].StageRound != undefined && matchesLive.length==0 && upcomingMatches.length == 0){
	        $.each(data.Calendar['knockout-brackets'].StageRound, function(j2,v2){ //going through each round of the championship
		    // $.each(data.Calendar['knockout-no-brackets'].StageRound, function(j2,v2){ //going through each round of the knockout no brackets competition
			//if (debugThisDamnFunction) console.log('	Round: '+ (j2+1));							
			 
			// var parsed = JSON.stringify(v2.matches[0].Match.start_time);
		    //	m = 0;
			if(v2.matches !== undefined && v2.matches.length > 0){							
			$.each(v2.matches, function(j3,v3){ // the individual matches		
                var thisMatch={};							
				//m++; //match number in this round
				thisMatch=v3;
				//thisMatch.matchId = v3["Match"]['id'];
				var matchTimeUTC = v3['Match']['start_time_utc'];
				 //thisMatch.matchTimeUTC=v3['Match']['start_time_utc'];
				 //thisMatch.matchTime = v3['Match']['start_time'];
				 var venue=v3['Venue']['name'];
				 var matchYear= parseInt(matchTimeUTC.substr(0,4));
				 var matchMonth= parseInt(matchTimeUTC.substr(5,2));
				 var matchDay= parseInt(matchTimeUTC.substr(8,2));
				 if(matchDay == todayDay && matchMonth == todayMonth && matchYear == todayYear){
				    $scope.matchesLive=true;
                    matchesLive.push(thisMatch);
					//count++;
                }else if((matchDay > todayDay && matchMonth >= todayMonth && matchYear== todayYear) || (matchDay <= todayDay && matchMonth > todayMonth && matchYear== todayYear) || (todayYear < matchYear)){
				    $scope.upcomingMatches= true;
                    if(nextMatchDay	== ''){
                       nextMatchDay= matchDay;
                       nextMatchMonth= matchMonth;
                       nextMatchYear= matchYear;
                    //   console.log(thisMatch);
					   upcomingMatches[0]=thisMatch;
                    }else if((matchDay < nextMatchDay && matchMonth <= nextMatchMonth) || (matchDay >= nextMatchDay && matchMonth < nextMatchMonth) || (matchYear < nextMatchYear)){
					   
					   upcomingMatches=[];
					   //console.log(thisMatch);
					   upcomingMatches[0]=thisMatch;
                    }else if(matchDay == nextMatchDay && matchMonth == nextMatchMonth && matchYear == nextMatchYear){
                        // console.log(thisMatch);
                       upcomingMatches.push(thisMatch);
                    }	
                 }									
                });	
				}								
			});
	    }
       if(matchesLive.length == 0)
          $scope.Upmatch_list=upcomingMatches;
       else
          $scope.Upmatch_list= matchesLive;
          
        console.log($scope.Upmatch_list);
	  };
    
    $scope.getCurrentRound();
    console.log($scope.match_list);
    $scope.Upmatch_list = [];
    $scope.createList();
    console.log($scope.Upmatch_list);
    // console.log($scope.match_list);
    
    
    
    if($scope.Upmatch_list.length !=0){ // && CurrentCom !=0
        for(var i=0; i<$scope.Upmatch_list.length ;i++){
            $scope.match_list[i] = $scope.Upmatch_list[i]; 
        }
    }
    console.log($scope.match_list);
    
    if($scope.newslist.length > 0){
        $scope.newslistTop= $scope.newslist.slice(0,3);
        $scope.newslistBottom=  $scope.newslist.slice(3);
    }
    $scope.title= homeTitle;
    $scope.vsWord = vsWord;
    $scope.refreshText= pullToRefreshText;
    $scope.matchNotCommented = matchNotCommentedWord;
   
    $scope.setRedirection= function(){
       $rootScope.videosFromHome =true;
    }
    $scope.$on('$ionicView.beforeEnter', function(){
      var windowH= window.innerHeight;
      var windowW= window.innerWidth;
      if(windowW < windowH){
         //if(windowH > 800){
            //var slideH=document.getElementById("slideHome").style.height= Math.round(windowH/2.7)+"px";
         //}else{
            var slideH= Math.round(windowW *0.50);
            document.getElementById("slideHome").style.height=slideH +"px";// Math.round(windowH/3.2)+"px";
            //document.getElementById("slideHomeVideos").style.height=slideH +"px";
            //$("#slideHome div").not(".slider-pager").css("height", (slideH-20));
            //$("#slideHomeVideos div").not(".slider-pager").css("height", (slideH -20));
        // }
        var newsHeight= windowH - slideH -134;    //
        document.getElementById("newsScroll").style.height=newsHeight+"px";
     } else {
        if(windowH < 600){
           var slideH= Math.round(windowH/1.5);
            document.getElementById("slideHome").style.height= slideH+"px";
           // document.getElementById("slideHomeVideos").style.height= slideH+"px";
        }else{
            var slideH=document.getElementById("slideHome").style.height= Math.round(windowH/1.8)+"px"; 
        }
        document.getElementById("newsScroll").style.height= Math.round(windowH/2)+"px";
     }
     $(document).scrollTop(0);
   });
   $scope.$on('$ionicView.afterEnter', function(){
      //alert(window.orientation);
     $ionicSlideBoxDelegate.slide(0);
     $ionicSlideBoxDelegate.update();
   
   });
     //console.log(document.getElementById("newsScroll").style.height);
    $scope.getMatchDetails=function(id,index){
    
        $(".matchLoader").css("display","block");
        $("#spinMatchLoad").show();
        $rootScope.match_selected= id;
        var d = new Date()
        var n = d.getTimezoneOffset();
        
        var match_date= moment( $scope.match_list[index].Match.start_time_utc).valueOf() - (n*60*1000);
        
        var now= moment().valueOf();//.valueOf();
        if(match_date - 60 * 1000 * 30 < now  && match_date + 60 * 1000 * 60 * 2.4 > now ){
            $rootScope.match_selected_isLive= true;
             LoadingService.getMatchDetails(id, $scope);
            LoadingService.getCompetitionCalendar($scope);
        }else{
            $rootScope.match_selected_isLive= false;
            if(match_date - 60 * 1000 * 30 > now ){
                $rootScope.match_selected_isUpcoming=true;
                $scope.$broadcast("MatchDetailsError");
            }else{
                $rootScope.match_selected_isUpcoming=false;
                 LoadingService.getMatchDetails(id, $scope);
            }
        }
        //LoadingService.getMatchDetails(id, $scope);
    };
    
    $scope.doRefresh = function() {
        //   LoadingService.initializeRSS($scope);
        $rootScope.ajaxNews(rssFeed[0],1,$scope);
        //$rootScope.ajaxNews(null,1,$scope);
    };
        
    $scope.$on('rssLoaded', function(){
        try{
          $scope.newslist= JSON.parse(window.localStorage[ls_news]);
        }catch(e){
             $scope.newslist=[];
        }
        if($scope.newslist.length > 0){
          $scope.newslistTop= $scope.newslist.slice(0,3);
          $scope.newslistBottom=  $scope.newslist.slice(3);
        }
        
        //$scope.newslist2= JSON.parse(window.localStorage[ls_news2]);
        LoadingService.getCompetitionCalendar($scope);
    });
    
    $scope.$on('MatchDetailsLoaded', function(){
        console.log($rootScope.match_selected);
        $(".matchLoader").css("display","none");
        $("#spinMatchLoad").hide();
        console.log($rootScope.arrayMatchList_Details[$rootScope.match_selected]);
        if($rootScope.match_selected_isUpcoming == true|| !$rootScope.arrayMatchList_Details[$rootScope.match_selected]){
            $(".matchLoader").css("display","none");
            //$("#spinMatchLoad").hide();
            $("#matchesView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
        } else{
            // if($rootScope.match_selected_isLive){
            //         $rootScope.MatchList_Details= $rootScope.MatchList_Details.reverse();
            //     }
            $rootScope.matchFromHome=true;
            $location.path("/app/match/commentaires/"+$rootScope.match_selected);
            LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
        }
    });
    
    $scope.$on('MatchDetailsError', function(){
         
         $(".matchLoader").css("display","none");
         $("#newsView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
    });
    
    $scope.$on('ConnectionError', function(){
         $("#newsView #connectionError").fadeIn('fast').delay(3000).fadeOut('medium');
    });
    
    $scope.$on('CalendarLoaded', function(){
      try{
        $scope.topmatchlist= JSON.parse(window.localStorage[ls_calendar]).Calendar;
      }catch(e){
          $scope.topmatchlist={};
      }
      try{
          $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
      }catch(e){
          $scope.calendar={};
      }
    //   $scope.currentRound= $scope.getCurrentRound();
    $scope.getCurrentRound();
    //   console.log($scope.calendar.Calendar.championship.StageRound.length+ " - "+ $scope.currentRound);
    //   if($scope.currentRound==undefined){
    //       $scope.currentRound = $scope.calendar.Calendar.championship.StageRound.length-1;
    //   }
    //   $scope.match_list= $scope.calendar.Calendar.championship.StageRound[$scope.currentRound].matches;
       $scope.$broadcast("scroll.refreshComplete");
         $timeout(function(){
             $ionicSlideBoxDelegate.$getByHandle("slideHome").update();
             $ionicSlideBoxDelegate.$getByHandle("slideHome").start();
             $ionicSlideBoxDelegate.$getByHandle("slideHomematch").update();
            //$ionicSlideBoxDelegate.$getByHandle("slideHome").start();
        }, 200);
        //LoadingService.getVideos($scope);
    });
    
    $scope.showInfo =function(index, rss){
    
     //var currentNewsId= angular.element(event.currentTarget).attr('index');
     $location.path('/app/news/'+rss+'/'+index);
  };
  
  $scope.showMatchInfo = function(event,match_index) {
      console.log(match_index);
      $location.path('/app/match/commentaires/'+match_index);
  };
  
})

.controller('NewsDescCtrl', function ($scope, $location, $ionicScrollDelegate,$ionicSlideBoxDelegate, $timeout,$rootScope){
    var urlSplit= $location.url().split('/');
    $scope.rss=urlSplit[urlSplit.length -2];    // to know if we need first rss feed or second
    $scope.index= urlSplit[urlSplit.length -1];
        // to get the index of the news in the list
     $scope.back= homeTitle;
     $scope.sharenewsword = sharenewsword;
     document.getElementById("newsDescSlider").style.minHeight= (window.innerHeight - 45)+'px';
     
     if($scope.rss == 'first'){
       $scope.newslist= JSON.parse(window.localStorage[ls_news]);
       $scope.title= newsDesc1Title;
     }else if ($scope.rss == 'second'){
        $scope.newslist= JSON.parse(window.localStorage[ls_news2]);
        $scope.title= featuresTitle;
     }else if ($scope.rss == 'third'){
        $scope.newslist= JSON.parse(window.localStorage[ls_news3]);
        $scope.title= interviewsTitle;
     }
     
     
     $scope.adjustHeight= function(index){
       $scope.newsindex = index;
       var slides= document.getElementsByName("slideNews");
       var children= slides[index].children;
       var height=0;
       for(var i=0;i< children.length;i++){
           height+= children[i].scrollHeight;
       }
       height+= 80;    // just to give a little bit of space
       document.getElementById("newsDescSlider").style.height= height+'px';
       //$ionicSlideboxDelegate.update();
        $timeout( function() {
            $ionicScrollDelegate.resize();
        }, 50);
       $ionicScrollDelegate.scrollTop();
       
     }
     
     
    $scope.share_article = function(icon, title, link){
        console.log(icon+" - "+ title+ " - "+link);
        var msg = title;
        if(icon != false){
            window.plugins.socialsharing.share(msg, title, icon ,link);
        } else{
            window.plugins.socialsharing.share(msg, title, "www/" +$scope.team_logo ,link);
        }
    }
    
    $scope.share_open_article = function(){
        console.log($scope.newsindex+ " - "+$scope.index);
        var news = $scope.newslist[$scope.newsindex];
        // console.log(news);
        //console.log(news.imageLink+" - "+ news.title+" - by "+news.author + " - " + news.link);
        $scope.share_article(news.imageLink, news.title, news.link);
    }
    
    // $scope.$on('$ionicView.afterEnter', function() {
    //     $ionicSlideBoxDelegate.update();
    //     $timeout(function(){$scope.adjustHeight($scope.index)},200);
    // });
    
    

    //console.log($scope.index);
    $timeout(function(){$scope.adjustHeight($scope.index)},1000);  // to adjust the height of the first slide we land to
        
    $timeout(function(){$ionicSlideBoxDelegate.$getByHandle("newsDescSlide").slide($scope.index);},200);
})

.controller('MatchListCtrl', function ($scope, $rootScope, $timeout,$interval, $location,$ionicSlideBoxDelegate,LoadingService,$ionicModal) {
    
    $scope.matchNotCommented = matchNotCommentedWord;
    $scope.vsWord = vsWord;
    $scope.connectionError= connectionErrorWord;
    $scope.letters=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];

    if(window.localStorage[ls_calendar]){
        try{
            $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
        }catch(e){
            $scope.calendar={};
        }
        if($scope.calendar.Calendar.championship != undefined && $scope.calendar.Calendar.championship.StageRound != undefined){
            $scope.StageRounds=$scope.calendar.Calendar.championship.StageRound;
        }
        $scope.title= matchTitle;
        $scope.refreshText= pullToRefreshText;
      
        //$scope.matchList={};
        console.log($scope.calendar);
        //console.log($rootScope.teamsList);
        
    } else{
        LoadingService.getCompetitionCalendar($scope);   
    }
    
    if($scope.calendar.Calendar['knockout-brackets'] != undefined && $scope.calendar.Calendar['knockout-brackets'].StageRound != undefined){
        $scope.positions= ['Finals', 'Semi-finals',"Quarter-finales",'Round of 16',"Round of 32", "Round of 64", "Round of 128"];
        $scope.knockouts=$scope.calendar.Calendar['knockout-brackets'].StageRound;
        var length= $scope.knockouts.length;
        $scope.knockouts=$scope.knockouts.sort(function(a,b){
            return a.position -b.position;
            console.log(b.position - a.position);
        });
        $scope.positions= $scope.positions.splice("0",length);
        $scope.positions.reverse();
        //$scope.StageRounds= $scope.StageRounds.concat($scope.calendar.Calendar['knockout-brackets'].StageRound);
    }
       
     console.log($scope.knockouts);
    // $scope.roundTitles=[];
    // $scope.roundTitles[0]="Semi-finals";
    // $scope.roundTitles[1]="Final";
    // $scope.matchPos=[];
    // $scope.matchPos[0]="top";
    // $scope.matchPos[1]="bottom";
    $scope.thirdPlaceMatch=false;
    if($scope.calendar.Calendar['knockout-brackets'] != undefined && $scope.calendar.Calendar['knockout-brackets'].StageRound.length==2 && $scope.calendar.Calendar['knockout-brackets'].StageRound[1].length == 2){
         $scope.thirdPlaceMatch=true;
    }
    $scope.$on('$ionicView.beforeEnter', function(){
        
        $rootScope.match_selected = "";
    });
    $scope.$on('$ionicView.afterEnter', function(){
        $("#spinMatchLoad").hide();
    });
    
    $scope.getWeekNumber= function(d) {
			// Copy date so don't modify original
			d = new Date(+d);
			d.setHours(0,0,0);
			// Set to nearest Thursday: current date + 4 - current day number
			// Make Sunday's day number 7
			d.setDate(d.getDate() + 4 - (d.getDay()||7));
			// Get first day of year
			var yearStart = new Date(d.getFullYear(),0,1);
			// Calculate full weeks to nearest Thursday
			var weekNo = Math.ceil(( ( (d - yearStart) / 86400000) + 1)/7)
			// Return array of year and week number
			// return [d.getFullYear(), weekNo];
			return weekNo;
	};
    console.log($scope.calendar);
    
    $scope.is_match_upcoming = function(matchTime){
        var d = new Date()
        var n = d.getTimezoneOffset();
        //console.log(n);
        var match_date= moment(matchTime).valueOf() - (n*60*1000);
        var now= moment().valueOf();
        
        if(match_date - 60 * 1000 * 30 > now ){
            return true;
        }else{
            return false;
        }
    }
    
    $scope.is_match_live = function(matchTime){
        var d = new Date()
        var n = d.getTimezoneOffset();
        //console.log(input);
        //console.log(timeUTC);
        var match_date= moment(matchTime).valueOf() - (n*60*1000);
        var now= moment().valueOf();
        if(match_date - 60 * 1000 * 30 < now  && match_date + 60 * 1000 * 60 * 2.4 > now){
            return true; //live
        }else{
            // var mydate="";
            //var date=new Date(input);
    //  		var secondPart= moment(input).format("H:mm - dddd D MMM gggg");
    // 		mydate+= secondPart;
            return false; // notlive
        }
        
    }
    
    
//     $scope.checkLatestMatch= function(){
// 	    var data=$scope.calendar;
// 	  //  console.log(data);
// 	    //console.log(year);
// 	    var todayYear= new Date().getFullYear();
// 	    //todayYear =todayYear -1;
//         var todayMonth= new Date().getMonth();
// 		var nextMatchDay='';
// 		var nextMatchMonth='';
// 		var nextMatchYear='';
// 		todayMonth++;
// 		var todayDay= new Date().getDate();
// 	    var matchesLive=[];
// 	    var upcomingMatches=[];
// 	    if(data.Calendar.championship != undefined && data.Calendar.championship.StageRound != undefined){
	       
// 		//console.log(data.team_logos);
// 		upcomingMatches=[];
// 		$.each(data.Calendar.championship.StageRound, function(j2,v2){ //going through each round of the championship
// 		// $.each(data.Calendar['knockout-no-brackets'].StageRound, function(j2,v2){ //going through each round of the knockout no brackets competition
// 			//if (debugThisDamnFunction) console.log('	Round: '+ (j2+1));							
			 
// 			// var parsed = JSON.stringify(v2.matches[0].Match.start_time);
// 		//	m = 0;
// 			if(v2.matches !== undefined && v2.matches.length > 0){	
			    
//     			$.each(v2.matches, function(j3,v3){ // the individual matches		
//                     var thisMatch={};							
//     				//m++; //match number in this round
//     				thisMatch= v3;
//     				//thisMatch.matchId = v3["Match"]['id'];
//     				var matchTimeUTC = v3['Match']['start_time_utc'];
//     				 //thisMatch.matchTimeUTC=v3['Match']['start_time_utc'];
//     				 //thisMatch.matchTime = v3['Match']['start_time'];
//     				 var venue=v3['Venue']['name'];
//     				 var matchYear= parseInt(matchTimeUTC.substr(0,4));
//     				 var matchMonth= parseInt(matchTimeUTC.substr(5,2));
//     				 var matchDay= parseInt(matchTimeUTC.substr(8,2));
    				 
//     				if(matchDay == todayDay && matchMonth == todayMonth && matchYear == todayYear){
//     				    $scope.matchesLive=true;
//                         matchesLive.push(thisMatch);
//     					//count++;
//                     }else if((matchDay > todayDay && matchMonth >= todayMonth && matchYear== todayYear) || (matchDay <= todayDay && matchMonth > todayMonth && matchYear== todayYear) || (todayYear < matchYear)){
//     				    $scope.upcomingMatches= true;
//                         if(nextMatchDay	== ''){
//                           nextMatchDay= matchDay;
//                           nextMatchMonth= matchMonth;
//                           nextMatchYear= matchYear;
//                         //   console.log(thisMatch);
//     					   upcomingMatches[0]=thisMatch;
//                         }else if((matchDay < nextMatchDay && matchMonth <= nextMatchMonth) || (matchDay >= nextMatchDay && matchMonth < nextMatchMonth) || (matchYear < nextMatchYear)){
//     					   // upcomingMatches=[];
//     					   // console.log(thisMatch);
//     					   // console.log(thisMatch.Match.start_time);
//     					   // console.log(upcomingMatches);
    					    
//     					    if(upcomingMatches.length!=0){
//         					    var a = moment(upcomingMatches[0].Match.start_time);
//                                 var b = moment(thisMatch.Match.start_time);
//                                 var t = a.diff(b, 'days') // 1
//         					   // console.log(t+" - "+upcomingMatches[0].Match.start_time+" - "+thisMatch.Match.start_time);
//                                 if(t>=0){
//         					        upcomingMatches[0]=thisMatch;
//                                 }
//     					    } else{
//     					        upcomingMatches[0]=thisMatch;
//     					    }
                            
//                         }else if(matchDay == nextMatchDay && matchMonth == nextMatchMonth && matchYear == nextMatchYear){
//     				// 	  console.log(thisMatch);
//                           upcomingMatches.push(thisMatch);
//                         }	
//                     }									
//                 });	
// 			}								
// 			});
// 			 //  console.log($scope.match_list);
// 	    }
// 	    if(data.Calendar['knockout-brackets'] != undefined && data.Calendar['knockout-brackets'].StageRound != undefined && matchesLive.length==0 && upcomingMatches.length == 0){
// 	        $.each(data.Calendar['knockout-brackets'].StageRound, function(j2,v2){ //going through each round of the championship
// 		    // $.each(data.Calendar['knockout-no-brackets'].StageRound, function(j2,v2){ //going through each round of the knockout no brackets competition
// 			//if (debugThisDamnFunction) console.log('	Round: '+ (j2+1));							
			 
// 			// var parsed = JSON.stringify(v2.matches[0].Match.start_time);
// 		    //	m = 0;
// 			if(v2.matches !== undefined && v2.matches.length > 0){							
// 			$.each(v2.matches, function(j3,v3){ // the individual matches		
//                 var thisMatch={};							
// 				//m++; //match number in this round
// 				thisMatch=v3;
// 				//thisMatch.matchId = v3["Match"]['id'];
// 				var matchTimeUTC = v3['Match']['start_time_utc'];
// 				 //thisMatch.matchTimeUTC=v3['Match']['start_time_utc'];
// 				 //thisMatch.matchTime = v3['Match']['start_time'];
// 				 var venue=v3['Venue']['name'];
// 				 var matchYear= parseInt(matchTimeUTC.substr(0,4));
// 				 var matchMonth= parseInt(matchTimeUTC.substr(5,2));
// 				 var matchDay= parseInt(matchTimeUTC.substr(8,2));
// 				 if(matchDay == todayDay && matchMonth == todayMonth && matchYear == todayYear){
// 				    $scope.matchesLive=true;
//                     matchesLive.push(thisMatch);
// 					//count++;
//                 }else if((matchDay > todayDay && matchMonth >= todayMonth && matchYear== todayYear) || (matchDay <= todayDay && matchMonth > todayMonth && matchYear== todayYear) || (todayYear < matchYear)){
// 				    $scope.upcomingMatches= true;
//                     if(nextMatchDay	== ''){
//                       nextMatchDay= matchDay;
//                       nextMatchMonth= matchMonth;
//                       nextMatchYear= matchYear;
//                     //   console.log(thisMatch);
// 					   upcomingMatches[0]=thisMatch;
//                     }else if((matchDay < nextMatchDay && matchMonth <= nextMatchMonth) || (matchDay >= nextMatchDay && matchMonth < nextMatchMonth) || (matchYear < nextMatchYear)){
					   
// 					   upcomingMatches=[];
// 					   //console.log(thisMatch);
// 					   upcomingMatches[0]=thisMatch;
//                     }else if(matchDay == nextMatchDay && matchMonth == nextMatchMonth && matchYear == nextMatchYear){
//                         // console.log(thisMatch);
//                       upcomingMatches.push(thisMatch);
//                     }	
//                  }									
//                 });	
// 				}								
// 			});
// 	    }
//       if(matchesLive.length == 0)
//           $scope.match_list=upcomingMatches;
//       else
//           $scope.match_list= matchesLive;
          
//         console.log($scope.match_list);
// 	  };
    
    
    $scope.getCurrentRound= function(){
        var data=$scope.calendar;
        var today = new Date();
		var yyyy = today.getFullYear();
		var MM = today.getMonth()+1;
		var dd = today.getDate();
		//var hh = today.getHours();
		//var mm = today.getMinutes();
		//var ss = today.getSeconds();
		var todaysDate = yyyy+'-'+MM+'-'+dd; //+' '+hh+'-'+mm+'-'+ss;
		//var currentRoundNum = '';
		//var matchInfoBoxNewsHTML = '';
		//var j =1;
		// today = new Date('February 25, 2015 11:13:00'); //used to fake today's date for testing.
		// console.log(today);
        var minWeek=-1;
		var totalMatches = 0;
		var currentRoundNum=0;		
	    var countStages=0;
	    var noMoreRounds=true;
	    if(data.Calendar['championship'] != undefined){
	       // var nextmatchdate= new Date();
	        var gotlivematch= false;
		$.each(data.Calendar['championship'].StageRound, function(stgIdx, stgVal) {
			var numberOfMatchesComing=0;
			totalMatches = stgVal.matches.length;
			// console.log("totalMatches: "+totalMatches);	
			$.each(stgVal.matches, function(mtchIdx, mtchVal) {
			        if(gotlivematch == false){
    					if ($rootScope.inAndroid) {
    						var startTime = new Date(mtchVal.Match.start_time); //.substring(0,11);
    					} else {
    						var startDate = mtchVal.Match.start_time.substr(0,11);
    						startDate = startDate.replace(/-/g,"/");
    						var startTime = new Date(startDate);
    					}
    					var sWeek = $scope.getWeekNumber(startTime);
    					var tWeek = $scope.getWeekNumber(today);
        //                   console.log("today: "+ tWeek);
    				// 	  console.log("next round: "+ sWeek);
    				// 	  console.log("minWeek: "+minWeek);
    					if (sWeek >= tWeek){
    					     numberOfMatchesComing++; 
    					}
    					
    					var a = moment(mtchVal.Match.start_time);
                        var b = moment();
                        var t = a.diff(b, 'days') //
                       // console.log(t);
    					if($scope.is_match_live(startTime) || t == 0){ // pass start_time_utc
    					    noMoreRounds = false;
    					  //  nextmatchdate = startTime;
    					    currentRoundNum = stgIdx;
    					    gotlivematch= true;
    					}
    					else if($scope.is_match_upcoming(startTime) && noMoreRounds == true){
    					   // console.log(nextmatchdate+" - "+startTime);
    					   // nextmatchdate = startTime;
    					    noMoreRounds = false;
    					    currentRoundNum = stgIdx;
    					   // console.log("currentRoundNum"+currentRoundNum);
    					} 					
    				// 	console.log("numberOfMatchesComing: "+numberOfMatchesComing);
    				// 	console.log("currentRoundNum: "+currentRoundNum);
    					if(numberOfMatchesComing == totalMatches && noMoreRounds == false){
    					   // noMoreRounds=false;
    						if(minWeek == -1){
    						   minWeek = sWeek;
    						   currentRoundNum = stgIdx;
    						  // console.log("currentRoundNum"+currentRoundNum);
    						 }
    						if(sWeek < minWeek){ 
    						    minWeek= sWeek;
    							currentRoundNum = stgIdx;
    				// 			console.log("currentRoundNum"+currentRoundNum);
    						 }
    					}
			        }
					// console.log("	startTime: "+startTime+'  todaysDate: '+todaysDate);
			});
			countStages++;
		});
		  //  console.log(noMoreRounds);
		  //     console.log("currentRoundNum"+currentRoundNum);
		    if(gotlivematch ==true){
		        currentRoundNum = currentRoundNum; 
		    } else if (currentRoundNum ==0 && noMoreRounds && data.Calendar['knockout-brackets'] == undefined) {
    		    if($scope.is_match_upcoming(data.Calendar['championship'].StageRound[0].matches[0].Match.start_time)){
                    currentRoundNum = 0;    		        
    		    }else{
    		        currentRoundNum= countStages -1;
    		    }
    		  //  console.log("currentRoundNum"+currentRoundNum);
    		} else if(currentRoundNum !=0){
		    currentRoundNum= currentRoundNum -1;
		    }
	    }
	    if(currentRoundNum == 0 && noMoreRounds && data.Calendar['knockout-brackets'] != undefined){
		    currentRoundNum=countStages -1 + data.Calendar['knockout-brackets'].StageRound.length;
		  //  console.log("currentRoundNum"+currentRoundNum);
		}
		//var delayedMatch = false // this bool is set to see if this round has a delayed match.
		//var matchWeek = ''; // number of the week of the match. Used to check if there's a delayed match.
		// $('.roundNum').html('Round #'+(currentRoundNum+1));	
    // 	console.log(currentRoundNum);
	    return currentRoundNum;
    }
    // if($rootScope.hasGroups == 0){
        $scope.currentRound= $scope.getCurrentRound();
        // $scope.checkLatestMatch();
        $timeout(function(){$ionicSlideBoxDelegate.$getByHandle("matchSlider").slide($scope.currentRound);},200);
    // }
    $scope.slider= $ionicSlideBoxDelegate.$getByHandle('matchSlider');
    //$scope.current_round=0;
    $ionicModal.fromTemplateUrl('matchRoundModel.html', {
        scope: $scope,
        animation: 'slide-in-down'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function() {
        $scope.modal.show();
    };
    $scope.closeModal = function() {
        $scope.modal.hide();
    };
    
    $scope.selectMatchSlide= function(index){
        //console.log("select slide");
        // $scope.blockSetMenuFunction= true;
        // $timeout(function(){
        //   $scope.blockSetMenuFunction= false;
        // }, 200);
        // $scope.current_round=index;
        $scope.modal.hide();
        $scope.slider.slide(index, 100);
    }
    $scope.selectMatchSlide2= function(index){
         index= index + $scope.StageRounds.length;
        //console.log("select slide");
        // $scope.blockSetMenuFunction= true;
        // $timeout(function(){
        //   $scope.blockSetMenuFunction= false;
        // }, 200);
        // $scope.current_round=index;
        $scope.modal.hide();
        $scope.slider.slide(index, 100);
    }
    
    $scope.nextMatchSlide = function() {
        $scope.slider.next();
    };
    $scope.prevMatchSlide = function() {
        $scope.slider.previous();
    };
    
    $scope.slideHasChanged=function($index){
        $scope.current_round=$index;
        console.log($index);
    };
    
    
    $scope.doRefresh = function() {
        LoadingService.getCompetitionCalendar($scope);
    };
    $scope.getMatchDetails=function(item){
        // alert(index);
           
        $(".matchLoader").css("display","block");
        $("#spinMatchLoad").show();
        
        $rootScope.match_selected= item.Match.id;
        $rootScope.Match=item;
        console.log($rootScope.Match);
        //console.log($scope.matchList[index].Match.start_time_utc);
        //console.log($scope.matchList[index].Match.start_time);
        
        var d = new Date()
        var n = d.getTimezoneOffset();
        //console.log(n);
        var match_date= moment(item.Match.start_time_utc).valueOf() - (n*60*1000);
        var now= moment().valueOf();
        
        if(match_date - 60 * 1000 * 30 < now  && match_date + 60 * 1000 * 60 * 2.4 > now ){
            $rootScope.match_selected_isLive= true;
            LoadingService.getCompetitionCalendar($scope);   // need to call this function to update the score in the header of match description
            LoadingService.getMatchDetails($rootScope.match_selected, $scope);
            LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
            
        }else{
            $rootScope.match_selected_isLive= false;
        }
        if(match_date - 60 * 1000 * 30 > now ){
            $rootScope.match_selected_isUpcoming=true;
        }else{
            $rootScope.match_selected_isUpcoming=false;
        }
        
        //console.log('loadded and navigate to commentries');
        //$("#spinMatchLoad").hide();
       
        if($rootScope.match_selected_isUpcoming == true){
            $(".matchLoader").css("display","none");
            $("#matchesView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
            $(".matchLoader").css("display","none");
        }else{
            if(!$rootScope.arrayMatchList_Details[$rootScope.match_selected] && !$rootScope.match_selected_isLive){
            // $rootScope.match_selected = 
              LoadingService.getMatchDetails($rootScope.match_selected, $scope);
              LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
            }else{
                $(".matchLoader").css("display","none");
                 
                $location.path("/app/match/commentaires/"+$rootScope.match_selected);
                /*if(!$rootScope.arrayMatchList_Statistics[$rootScope.match_selected]){
                    LoadingService.getMatchStatistics($rootScope.match_selected, $scope);
                }*/
           }
        }
    };
    
    $scope.$on('ConnectionError', function(){
         $(".matchLoader").css("display","none");
            $("#spinMatchLoad").hide();
         $("#matchesView #connectionError").fadeIn('fast').delay(3000).fadeOut('medium');
    });
    
    $scope.$on('CalendarLoaded', function(){
        if(window.localStorage[ls_calendar]){
            $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
        }
        if($scope.calendar['knockout-brackets'] != undefined)
            $scope.bracketsPosition= parseInt($scope.calendar['knockout-brackets'].Stage.position);
        // $scope.slider= $ionicSlideBoxDelegate.$getByHandle('matchSlider');
        $ionicSlideBoxDelegate.$getByHandle("matchSlider").update();
        //$scope.current_round=0;
        $scope.currentRound= $scope.getCurrentRound();
        console.log($scope.currentRound);
        $ionicModal.fromTemplateUrl('matchRoundModel.html', {
            scope: $scope,
            animation: 'slide-in-down'
        }).then(function(modal) {
            $scope.modal = modal;
        });
        $scope.$broadcast("scroll.refreshComplete");
    });
    
    
    
    
    $scope.$on('MatchDetailsLoaded', function(){
        console.log($rootScope.match_selected);
        $(".matchLoader").css("display","none");
        $("#spinMatchLoad").hide();        
        if($rootScope.match_selected!=""){
            if($rootScope.match_selected_isUpcoming == true|| !$rootScope.arrayMatchList_Details[$rootScope.match_selected]){
                 $(".matchLoader").css("display","none");
                //$("#spinMatchLoad").hide();
                $("#matchesView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
            } else{
                if($rootScope.match_selected_isLive){
                    $rootScope.MatchList_Details= $rootScope.MatchList_Details.reverse();
                }
                $(".matchLoader").css("display","none");
                $("#spinMatchLoad").hide();
                $location.path("/app/match/commentaires/"+$rootScope.match_selected);
            }
        }
    });
     
    $scope.$on('MatchDetailsError', function(){
         $(".matchLoader").css("display","none");
         //$("#spinMatchLoad").hide();
         $("#matchesView #matchNotCommented").fadeIn('fast').delay(3000).fadeOut('medium');
    });
})

.controller('matchCtrl', function($scope, $location, $sce, $http, LoadingService, $rootScope) {
    // LoadingService.getMatchDetails($scope);
    $scope.title = matchDetailTitle;
    var urlSplit= $location.url().split('/');
    $scope.matchId=urlSplit[urlSplit.length -1];  
    // console.log($scope.matchId);
    $scope.letters=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
    try{
      $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
    }catch(e){
      $scope.calendar={};
    }
    //$scope.back= matchTitle;
    //$rootScope.Match= [];
    var matchFound=false;
    $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
    for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
        for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
          if($scope.matches.Calendar.championship.StageRound[i].matches[j].Match.id == $scope.matchId){
             $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
             $rootScope.round_of_match= i+1;
             matchFound=true;
             break;
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
          }
        }
    }
    if(!matchFound){
        if($scope.matches.Calendar['knockout-brackets'] != undefined){
            for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                  if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                     $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                     matchFound=true;
                     break;
                     //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  }
                }
            }
        }
    }
    
    //$scope.Match=$rootScope.Match;
    console.log($scope.matches);
 
    $scope.home_name = $rootScope.Match.HomeTeam.name;
    $scope.away_name = $rootScope.Match.AwayTeam.name;
    
    $scope.homeTeamInitials= $rootScope.teamsList; //islTeams[$scope.Match.HomeTeam.id];
    $scope.awayTeamInitials= ""; //islTeams[$scope.Match.AwayTeam.id];
    
    if($rootScope.match_selected_isLive){
        $rootScope.status= "Live";
    }else{
        $rootScope.status= finishedWord;
    }
    console.log($rootScope.Match);
    $scope.getRound= function(competitionItem){
        console.log(competitionItem);
        if(competitionItem != undefined){
            var compId= competitionItem.id;
            var stageId= competitionItem.stage_id;
            var stage_roundId= competitionItem.stage_round_id;
            if($rootScope.competitions != undefined 
                && $rootScope.competitions[compId] != undefined 
                && $rootScope.competitions[compId].stages[stageId] != undefined
                && $rootScope.competitions[compId].stages[stageId].stage_rounds[stage_roundId] != undefined){
                
                if($rootScope.competitions[compId].stages[stageId].info.type == "championship"){
                    
                    return "Matchday "+$rootScope.competitions[compId].stages[stageId].stage_rounds[stage_roundId].info.position;
                }else if ($rootScope.competitions[compId].stages[stageId].info.type == "knockout-no-brackets" || $rootScope.competitions[compId].stages[stageId].info.type == "knockout-brackets"){
                    //console.log($rootScope.competitions[compId].stages[stageId].info);
                    return $rootScope.competitions[compId].info.name;
                }
            }
        }
        //return "hello";
    };
     if(! $rootScope.inAndroid){
        //$("#divTransparent").css("padding-top","22px");
        $(".test").css("top","23px");
    }else
       $(".test").css("top","1px");
  
 })

.controller('MatchDescCtrl', function($scope, $location, $sce, $http, LoadingService, $rootScope, $interval,$timeout, $ionicHistory,$ionicScrollDelegate) {
    
    $scope.title = matchDetailTitle;
    
    var urlSplit= $location.url().split('/');
    $scope.matchId=urlSplit[urlSplit.length -1];  
    $scope.back= matchTitle;
    var matchFound=false;
    $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
    for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
        for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
          if($scope.matches.Calendar.championship.StageRound[i].matches[j].Match.id == $scope.matchId){
             matchFound=true;
             $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
             break;
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
          }
        }
    }
    if(!matchFound){
        if($scope.matches.Calendar['knockout-brackets'] != undefined){
            for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                  if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                     $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                     matchFound=true;
                     break;
                     //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  }
                }
            }
        }
    }
     $scope.$on('$ionicView.afterEnter', function (event, viewData) {
        $ionicScrollDelegate.scrollTop();
    });
    $scope.headerSmall=false;
    $scope.animateHeader=function(){
        //console.log(event);
        var position=$ionicScrollDelegate.$getByHandle("matchDescContent").getScrollPosition().top;
       //$("#headerMatches").removeClass("headerBig");
       console.log(position);
       if(position <= 5){
           //alert("hello");
           $("#awayTeamHeader").css('text-align',"center");
            $("#homeTeamHeader").css("text-align","center");
           if(! $("#homeTeamHeader").hasClass("homeTeamHeader")){
               $("#homeTeamHeader").addClass("homeTeamHeader");
           }
           if(! $("#awayTeamHeader").hasClass("awayTeamHeader")){
               $("#awayTeamHeader").addClass("awayTeamHeader");
           }
           if(! $("#scoreHeader").hasClass("scoreFont")){
               $("#scoreHeader").addClass("scoreFont");
           }
           if(! $("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").addClass("competHeaderBig")
           }
           if(! $("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").addClass("headerMatchImage") 
           }
           if(! $("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").addClass("headerMatchImage") 
           }
           $("#headerMatches").css("height",'200px');
           $("#matchDescContent").css("margin-top",'150px');
           $scope.headerSmall=false;
       }else{
           
            if($("#homeTeamHeader").hasClass("homeTeamHeader")){
                $("#homeTeamHeader").removeClass("homeTeamHeader");
             }
             if($("#awayTeamHeader").hasClass("awayTeamHeader")){
                $("#awayTeamHeader").removeClass("awayTeamHeader");
             }
             if($("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").removeClass("scoreFont");
             }
             if($("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").removeClass("headerMatchImage") 
           }
           if($("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").removeClass("headerMatchImage") 
           }
             /*if(position < 30){
                 if(! $("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").addClass("scoreFont");
             }
             }*/
             
       }
       if(position > 107 && position <= 140){
           if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",(140 -position)+'px');
            $("#competHeader").css("opacity",  (140 - position)*3/100);
           
          
       }
       if(position >50 && position <= 83){
            if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
            $("#awayHeaderName").css("opacity",(83 - position)*3/100);
            $("#homeHeaderName").css("opacity",(83 - position)*3/100);
       }
       if(position<140 && position > 5){
         if($scope.headerSmall){
              $("#homeTeamHeader").css('text-align',"center");
              $("#awayTeamHeader").css("text-align","center");
              $("#awayTeamHeader").css('width',"40%");
         }
         $scope.headerSmall=false;
        
        $("#headerMatches").css("height",(200-(position*1.05))+'px');
        $("#matchDescContent").css("margin-top",(150 -(position*1.05))+'px');
        $("#awayImage").css("height",(75 - position/3)+'px');
        $("#homeImage").css("height",(75 - position/3)+'px');
        var marginTop= (position * (60/140))-58;
        var top =50- (position * 50/140);
        var fontSize= 31 -(position *12/140);
        var marginScore= (position * (40/140))-30;
        $(".headerMatchDiv").css("margin-top", marginTop+'px');
        $(".headerMatchDiv").css("top", top+'%');
        $("#scoreHeader").css("top", top+'%');
        $("#scoreHeader").css("font-size",fontSize+"px");
        $("#scoreHeader").css("margin-top", marginScore+"px");
       }else if(position > 140 && ! $scope.headerSmall){
           
           $scope.headerSmall=true;
            $("#headerMatches").css("height",'45px');
            $("#headerMatches").addClass("animateMatchUp");
            $("#awayTeamHeader").css('text-align',"left");
            $("#awayTeamHeader").css('width',"20%");
            $("#homeTeamHeader").css("text-align","right");
            $("#matchDescContent").css("margin-top",'1px');
            $("#homeImage").css("height",'29px');
            $("#awayImage").css("height",'29px');
            $(".headerMatchDiv").css("margin-top", '8px');
            $(".headerMatchDiv").css("top",0);
            $("#scoreHeader").css("top", 0);
            $("#scoreHeader").css("font-size","22px");
            $("#scoreHeader").css("margin-top", "13px");
             $("#competHeader").css("opacity", 0);
             if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",0);
           if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
           $("#homeHeaderName").css("opacity", 0);
           $("#awayHeaderName").css("opacity", 0);
       }
       /*if($scope.isBig){
        $("#headerMatches").addClass("animateMatchUp");
        $("#matchDescContent").addClass("reduceMargin");
       }else if(position==0){
         $("#headerMatches").addClass("animateMatchDown");  
         $("#matchDescContent").addClass("increaseMargin");
       }*/
       //console.log($ionicScrollDelegate.getScrollPosition());
    };
    //console.log($scope.Match);
    $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
      if($rootScope.match_selected_isLive){
          
        $rootScope.timeLeft=30;
        $(".finishedMatch").css("display","none");
        $(".refreshLive").css("display","block");
        $(".matchDescContent").addClass("live");
        $(".matchDescContent").removeClass("finished");
        if($rootScope.timeout)
         $timeout.cancel($rootScope.timeout);
         
         $rootScope.timeout=$timeout(function(){
              if($ionicHistory.currentStateName()=="app.match.matchDesc" || $ionicHistory.currentStateName()=="app.match.matchStats" || $ionicHistory.currentStateName()=="app.match.matchFanZone"){
                $("#matchStatus").hide();
                $("#spinRefresh").show();
                LoadingService.getCompetitionCalendar($scope);
                LoadingService.getMatchDetails($scope.matchId, $scope);
                LoadingService.getMatchStatistics($scope.matchId, $scope);
              }else
                $interval.cancel($rootScope.interval);
          }, 30000);
          if($rootScope.interval)
             $interval.cancel($rootScope.interval);
             
          $rootScope.interval=$interval(function(){
              //$("#refreshLive").html($scope.timeLeft);
              $rootScope.timeLeft =$rootScope.timeLeft -1 ;
          },1000);
          
      }else{
         $(".finishedMatch").css("display","block");
         $(".refreshLive").css("display","none");
         $(".matchDescContent").addClass("finished");
         $(".matchDescContent").removeClass("live");
      }
    });
    
    $scope.share_comment = function(icon, minute, ShareMSG, playerIMG, twitterMsg){
        console.log($scope.home_name+" vs "+ $scope.away_name+ " : "+minute+"' - "+ShareMSG);
        if(twitterMsg!="" && twitterMsg!=undefined){
            var msg=$scope.home_name+" vs "+ $scope.away_name+ " : "+minute+"' - "+twitterMsg;
            var ttl=minute+"' - "+twitterMsg;    
        } else{
            var msg=$scope.home_name+" vs "+ $scope.away_name+ " : "+minute+"' - "+ShareMSG;
            var ttl=minute+"' - "+ShareMSG;
        }
        if(playerIMG!="" && playerIMG != undefined){
            var player_image = $rootScope.players_img(playerIMG,200,200);
            window.plugins.socialsharing.share(msg, ttl, player_image ,null);
        } else{
            window.plugins.socialsharing.share(msg, ttl, null ,null);
        }
    }
    
    $rootScope.refreshDetails=function(){
        $("#matchStatus").hide();
        $("#spinRefresh").show();
        $timeout.cancel($scope.timeout);
        LoadingService.getCompetitionCalendar($scope);
        LoadingService.getMatchDetails($scope.matchId, $scope);
        LoadingService.getMatchStatistics($scope.matchId, $scope);
    };
    
    $scope.getEventVideo=function(url){
        if(videoSite.toLowerCase() == "youtube"){
             var splitted=url.split("=");
            $rootScope.videosFromMatch=true;
            // $location.path("/app/videos/"+splitted[splitted.length - 1]);
            var videoId = splitted[splitted.length - 1];
            if($rootScope.inAndroid){
                VideoPlayer.play("https://www.youtube.com/watch?v="+videoId);
                // VideoPlayer.play("file:///android_asset/www/movie.mp4");
              //  VideoPlayer.play("https://www.youtube.com/embed/"+videoId+'?showinfo=0&frameborder=0');
            } else{
                YoutubeVideoPlayer.openVideo(videoId);    
            }
           
       }
    }
    
    $scope.trustSrc=function(url){
        var splitted= url.split('=');
        var id= splitted[splitted.length - 1];
        var embed="https://www.youtube.com/embed/"+id+"?showinfo=0&frameborder=0" ;
        return $sce.trustAsResourceUrl(embed);
    };
    
    $scope.$on("MatchDetailsLoaded",function(){
        
        
        if($rootScope.match_selected_isLive){
            $timeout(function(){
                //alert("hiding");
              $("#spinRefresh").hide();
              $("#matchStatus").show();
            },500);
            $interval.cancel($rootScope.interval);
             $rootScope.timeLeft=30;
             if( $ionicHistory.currentStateName()=="app.match.matchDesc" || $ionicHistory.currentStateName()=="app.match.matchStats" || $ionicHistory.currentStateName()=="app.match.matchFanZone"){   // I have to use this workaround because leave page events are not firing with tabs
                $rootScope.interval=$interval(function(){
                      console.log($rootScope.timeLeft);
                      $rootScope.timeLeft =$rootScope.timeLeft -1 ;
                  },1000);
                 
                 $rootScope.timeout=$timeout(function(){
                    $("#matchStatus").hide();
                    $("#spinRefresh").show();
                    if($ionicHistory.currentStateName()=="app.match.matchDesc" || $ionicHistory.currentStateName()=="app.match.matchStats" || $ionicHistory.currentStateName()=="app.match.matchFanZone"){
                       LoadingService.getCompetitionCalendar($scope);
                       LoadingService.getMatchDetails($scope.matchId, $scope);
                       LoadingService.getMatchStatistics($scope.matchId, $scope);
                    }else 
                        $interval.cancel($rootScope.interval);
                  }, 30000);
             }
             console.log($rootScope.MatchList_Details);
             $scope.MatchDetail= $rootScope.MatchList_Details.commentaries.reverse();
            //  $scope.MatchDetail.reverse();
            //  $rootScope.MatchList_Details= $rootScope.MatchList_Details.reverse();
        }else{
            console.log($rootScope.MatchList_Details);
            $scope.MatchDetail= $rootScope.MatchList_Details; 
        }
    })
    
    /*$scope.$on("topMatchListLoaded", function(){
        $scope.matches= JSON.parse(window.localStorage[ls_topMatchlist]); 
        for(var i = 0; i < $scope.matches.length; i++) {
          if($scope.matches[i].Match.id === $scope.matchId){
             $rootScope.Match = $scope.matches[i];
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
          }
        }
    });*/
    
    $scope.$on("CalendarLoaded", function(){
        //alert("calendar loaded");
        $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
        matchFound=false;
        for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
            for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
                
              if($scope.matches.Calendar.championship.StageRound[i].matches[j].Match.id == $scope.matchId){
                 $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
                 console.log($rootScope.Match);
                 //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  break;
              }
            }
        }
        if(!matchFound){
            if($scope.matches.Calendar['knockout-brackets'] != undefined){
                for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                    for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                      if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                         $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                         matchFound=true;
                         break;
                         //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                      }
                    }
                }
            }
        }
    });
     //$rootScope.MatchList_Details;
    if($rootScope.arrayMatchList_Details[$scope.matchId]!=undefined){
        $scope.MatchDetail= $rootScope.arrayMatchList_Details[$scope.matchId];
        console.log($scope.MatchDetail);
        if($rootScope.match_selected_isLive){
            $scope.MatchDetail= $scope.MatchDetail.reverse();
        }
    } else{
        LoadingService.getCompetitionCalendar($scope);
       LoadingService.getMatchDetails($scope.matchId, $scope);
       LoadingService.getMatchStatistics($scope.matchId, $scope);
    }
    
    
    $scope.home_name = $rootScope.Match.HomeTeam.name;
    $scope.away_name = $rootScope.Match.AwayTeam.name;
    
    
 })

.controller('MatchStatsCtrl', function($scope, $location, $sce, $http, $rootScope, $timeout, LoadingService,$ionicScrollDelegate) {
//   console.log("stats");
    $scope.title= matchStatsTitle;
    $scope.stats_goals = stats_goals;
    $scope.stats_goal = stats_goal;
    $scope.stats_shots = stats_shots;
    
    $scope.stats_on_target = stats_on_target;
    $scope.stats_saved = stats_saved;
    $scope.stats_freekick = stats_freekick;
    $scope.stats_corner = stats_corner;
    $scope.stats_penaltykicks = stats_penaltykicks;
    $scope.stats_offside = stats_offside;
    $scope.stats_yellowcard = stats_yellowcard;
    $scope.stats_redcard = stats_redcard;
    $scope.stats_substitution = stats_substitution;
    $scope.stats_shooting_title = stats_shooting_title;
    $scope.stats_scoring_title = stats_scoring_title;
    $scope.stats_attendance = stats_attendance;
    
    $scope.stats_shots_wide_of =stats_shots_wide_of;
    $scope.stats_shot_wide_of =stats_shot_wide_of;
    $scope.stats_shots_on_target = stats_shots_on_target;
    $scope.stats_shot_on_target = stats_shot_on_target;
  
    $scope.unknownPlayerWord = unknownPlayerWord;
    
    var urlSplit= $location.url().split('/');
    $scope.matchId=urlSplit[urlSplit.length -1];  
    
    $scope.back= matchTitle;
    $scope.Match= [];
    //$scope.tid=tid;
    $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
    var matchFound=false;
    for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
        for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
          if($scope.matches.Calendar.championship.StageRound[i].matches[j].id == $scope.matchId){
              matchFound=true;
             $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
             break;
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
          }
        }
    }
     if(!matchFound){
        if($scope.matches.Calendar['knockout-brackets'] != undefined){
            for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                  if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                     $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                     matchFound=true;
                     break;
                     //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  }
                }
            }
        }
    }
    $scope.Match = $rootScope.Match;
    // $scope.homeTeamInitials='';// islTeams[$scope.Match.HomeTeam.id];
    // $scope.awayTeamInitials='';// islTeams[$scope.Match.AwayTeam.id];
    $scope.state_type = [];
    $scope.barWidth = (window.innerWidth/2)-17;
     
     
    $scope.home_name = $rootScope.Match.HomeTeam.name;
    $scope.away_name = $rootScope.Match.AwayTeam.name;
    
    // for(var i=0;i<$rootScope.teamsList.length;i++){
        
    //     //console.log($rootScope.teamsList[i].nicknames.initials[0]);
    //     if($rootScope.Match.HomeTeam.id == $rootScope.teamsList[i].id){
    //         $scope.home_media= $rootScope.teamsList[i].media_id;
    //         if($rootScope.teamsList[i].nicknames != undefined && $rootScope.teamsList[i].nicknames.initials != undefined)
    //           $scope.home_name= $rootScope.teamsList[i].nicknames.initials[0];
    //         continue;
    //     }
    //     if($rootScope.Match.AwayTeam.id == $rootScope.teamsList[i].id){
    //         $scope.away_media= $rootScope.teamsList[i].media_id;
    //         if($rootScope.teamsList[i].nicknames != undefined && $rootScope.teamsList[i].nicknames.initials != undefined)
    //           $scope.away_name= $rootScope.teamsList[i].nicknames.initials[0];
    //     }
    // }
    $scope.homeTeamInitials= $rootScope.teamsList; //islTeams[$scope.Match.HomeTeam.id];
    $scope.awayTeamInitials= ""; //islTeams[$scope.Match.AwayTeam.id];
       
    /*$scope.$on("MatchStatisticsLoaded",function(){
        var matchstats = $rootScope.arrayMatchList_Statistics[$scope.matchId];
        console.log(matchstats); // here you can see the structure of the data
        $scope.matchstats =matchstats;        
    });*/
    
    //k$scope.$watch('MatchList_Statistics', function(new, old),equality)
    if(!$rootScope.arrayMatchList_Statistics[$scope.matchId]){
        
         LoadingService.getMatchStatistics($scope.matchId, $scope);
         
    }/*else{
        var matchstats = $rootScope.arrayMatchList_Statistics[$scope.matchId];
        console.log(matchstats); // here you can see the structure of the data
        $scope.matchstats =matchstats;
    }*/
    console.log($rootScope.arrayMatchList_Statistics[$scope.matchId]);
        
    $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
        viewData.enableBack = true;
        $scope.showPosition1 = true;
        $scope.showZone1 = true;
        $scope.showGoals = true;
    });
     $scope.$on('$ionicView.afterEnter', function (event, viewData) {
        $ionicScrollDelegate.scrollTop();
    });
    $scope.headerSmall=false;
    $scope.animateHeader=function(){
        //console.log(event);
        var position=$ionicScrollDelegate.$getByHandle("matchStatsContent").getScrollPosition().top;
       //$("#headerMatches").removeClass("headerBig");
       console.log(position);
       if(position <= 5){
           //alert("hello");
           $("#awayTeamHeader").css('text-align',"center");
            $("#homeTeamHeader").css("text-align","center");
           if(! $("#homeTeamHeader").hasClass("homeTeamHeader")){
               $("#homeTeamHeader").addClass("homeTeamHeader");
           }
           if(! $("#awayTeamHeader").hasClass("awayTeamHeader")){
               $("#awayTeamHeader").addClass("awayTeamHeader");
           }
           if(! $("#scoreHeader").hasClass("scoreFont")){
               $("#scoreHeader").addClass("scoreFont");
           }
           if(! $("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").addClass("competHeaderBig")
           }
           if(! $("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").addClass("headerMatchImage") 
           }
           if(! $("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").addClass("headerMatchImage") 
           }
           $("#headerMatches").css("height",'200px');
           $("#matchStatsContent").css("margin-top",'150px');
           $scope.headerSmall=false;
       }else{
           
            if($("#homeTeamHeader").hasClass("homeTeamHeader")){
                $("#homeTeamHeader").removeClass("homeTeamHeader");
             }
             if($("#awayTeamHeader").hasClass("awayTeamHeader")){
                $("#awayTeamHeader").removeClass("awayTeamHeader");
             }
             if($("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").removeClass("scoreFont");
             }
             if($("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").removeClass("headerMatchImage") 
           }
           if($("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").removeClass("headerMatchImage") 
           }
             /*if(position < 30){
                 if(! $("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").addClass("scoreFont");
             }
             }*/
             
       }
       if(position > 107 && position <= 140){
           if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",(140 -position)+'px');
            $("#competHeader").css("opacity",  (140 - position)*3/100);
           
          
       }
       if(position >50 && position <= 83){
            if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
            $("#awayHeaderName").css("opacity",(83 - position)*3/100);
            $("#homeHeaderName").css("opacity",(83 - position)*3/100);
       }
       if(position<140 && position > 5){
          if($scope.headerSmall){
              $("#homeTeamHeader").css('text-align',"center");
              $("#awayTeamHeader").css("text-align","center");
              $("#awayTeamHeader").css("width","40%");
          }
         $scope.headerSmall=false;
         $("#homeTeamHeader").css('text-align',"center");
        $("#awayTeamHeader").css("text-align","center");
        $("#awayTeamHeader").css("width","40%");
        $("#headerMatches").css("height",(200-(position*1.05))+'px');
        $("#matchStatsContent").css("margin-top",(150 -(position*1.05))+'px');
        $("#awayImage").css("height",(75 - position/3)+'px');
        $("#homeImage").css("height",(75 - position/3)+'px');
        var marginTop= (position * (60/140))-58;
        var top =50- (position * 50/140);
        var fontSize= 31 -(position *12/140);
        var marginScore= (position * (40/140))-30;
        $(".headerMatchDiv").css("margin-top", marginTop+'px');
        $(".headerMatchDiv").css("top", top+'%');
        $("#scoreHeader").css("top", top+'%');
        $("#scoreHeader").css("font-size",fontSize+"px");
        $("#scoreHeader").css("margin-top", marginScore+"px");
       }else if(position > 140 && ! $scope.headerSmall){
           
           $scope.headerSmall=true;
            $("#headerMatches").css("height",'45px');
            
            $("#headerMatches").addClass("animateMatchUp");
            $("#awayTeamHeader").css('text-align',"left");
            $("#homeTeamHeader").css("text-align","right");
            $("#awayTeamHeader").css("width","20%");
            
            $("#matchStatsContent").css("margin-top",'1px');
            $("#homeImage").css("height",'29px');
            $("#awayImage").css("height",'29px');
            $(".headerMatchDiv").css("margin-top", '8px');
            $(".headerMatchDiv").css("top",0);
            
            $("#scoreHeader").css("top", 0);
            $("#scoreHeader").css("font-size","22px");
            $("#scoreHeader").css("margin-top", "13px");
             $("#competHeader").css("opacity", 0);
             if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",0);
           if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
           $("#homeHeaderName").css("opacity", 0);
           $("#awayHeaderName").css("opacity", 0);
       }
       /*if($scope.isBig){
        $("#headerMatches").addClass("animateMatchUp");
        $("#matchDescContent").addClass("reduceMargin");
       }else if(position==0){
         $("#headerMatches").addClass("animateMatchDown");  
         $("#matchDescContent").addClass("increaseMargin");
       }*/
       //console.log($ionicScrollDelegate.getScrollPosition());
    };
    
    $scope.toggleGroup = function(group) {
        if ($scope.isGroupShown(group)) {
          $scope.shownGroup = null;
        } else {
          $scope.shownGroup = group;
        }
      };
    $scope.isGroupShown = function(group) {
        return $scope.shownGroup === group;
      };
})

.controller('MatchFanzoneCtrl', function($scope, $rootScope, $http, socketConnect, $location,$ionicSideMenuDelegate, $ionicHistory,$ionicScrollDelegate) {
    $scope.title= matchFanZoneTitle;
    $scope.voteWord=voteWord;
    $scope.skipWord=skipWord;
    $scope.allVotedMsg=allVotedMsg;
    $scope.thanksRatingMsg=thanksRatingMsg;
    $scope.ViewRatingBtn=ViewRatingBtn;
    $scope.allVoted = false;
    $scope.BestPlayerSeasonMsg = BestPlayerSeasonMsg;
    $scope.noPlayersRatingSeasonMsg = noPlayersRatingSeasonMsg;
    $scope.ratePlayersWord = ratePlayersWord;
    $scope.loadpage=false;
    $scope.mostValuablePlayer = mostValuablePlayer;
    $scope.votesWord = votesWord;
    $scope.selectATeamToWord = selectATeamToWord;
    try{
        $scope.calendar= JSON.parse(window.localStorage[ls_calendar]);
    }catch(e){
        $scope.calendar={};
    }
   
    var urlSplit= $location.url().split('/');
    $scope.matchId=urlSplit[urlSplit.length -1];
    var team = "list";
    var match_id = $scope.matchId;
    
    
    $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
    console.log($scope.matches);
    var matchFound=false;
    for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
        for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
           if($scope.matches.Calendar.championship.StageRound[i].matches[j].Match.id == $scope.matchId){
              matchFound=true;
              $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
              break;
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
           }
        }
    }
    if(!matchFound){
        if($scope.matches.Calendar['knockout-brackets'] != undefined){
            for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                  if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                     $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                     matchFound=true;
                     break;
                     //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  }
                }
            }
        }
    }
    console.log($rootScope.Match);
    $scope.currentMatch = $rootScope.Match;
    var competition_id= cid; //$rootScope.Match.Competition.id;
    var homeTeam = $rootScope.Match.HomeTeam.id;
    var awayTeam = $rootScope.Match.AwayTeam.id;
    // DYNAMIC TEAM AND MATCH NOT WORKING
    // team_id= "4c616c6a-ac54-49b0-9f14-4033c1eee52b";//"4c616c6a-ac54-49b0-9f14-4033c1eee52b";
    // match_id = "53982b4e-3220-49de-a11e-0f13dfbdb49f"; //"53982b4e-3220-49de-a11e-0f13dfbdb49f";
    // // match_id="53ba65f0-b028-443b-8861-220b0a00bcba";
    //  competitio
    
     $scope.$on('$ionicView.beforeEnter', function(event, viewData){
        $scope.fanzoneMessage ="";
        viewData.enableBack = true;
        $rootScope.review_detail_msg = "";
        $scope.voting_completed = false;
        $rootScope.HometeamVoted = false;
        $rootScope.AwayteamVoted = false;
        $rootScope.alreadyStartedVoting = false;
     });
     $scope.$on('$ionicView.afterEnter', function (event, viewData) {
        $ionicScrollDelegate.scrollTop();
    });
     $scope.headerSmall=false;
    $scope.animateHeader=function(){
        //console.log(event);
        var position=$ionicScrollDelegate.$getByHandle("matchFanZoneContent").getScrollPosition().top;
       //$("#headerMatches").removeClass("headerBig");
       console.log(position);
       if(position <= 5){
           //alert("hello");
           $("#awayTeamHeader").css('text-align',"center");
            $("#homeTeamHeader").css("text-align","center");
           if(! $("#homeTeamHeader").hasClass("homeTeamHeader")){
               $("#homeTeamHeader").addClass("homeTeamHeader");
           }
           if(! $("#awayTeamHeader").hasClass("awayTeamHeader")){
               $("#awayTeamHeader").addClass("awayTeamHeader");
           }
           if(! $("#scoreHeader").hasClass("scoreFont")){
               $("#scoreHeader").addClass("scoreFont");
           }
           if(! $("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").addClass("competHeaderBig")
           }
           if(! $("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").addClass("headerMatchImage") 
           }
           if(! $("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").addClass("headerMatchImage") 
           }
           $("#headerMatches").css("height",'200px');
           $("#matchDescContent").css("margin-top",'150px');
           $scope.headerSmall=false;
       }else{
           
            if($("#homeTeamHeader").hasClass("homeTeamHeader")){
                $("#homeTeamHeader").removeClass("homeTeamHeader");
             }
             if($("#awayTeamHeader").hasClass("awayTeamHeader")){
                $("#awayTeamHeader").removeClass("awayTeamHeader");
             }
             if($("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").removeClass("scoreFont");
             }
             if($("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").removeClass("headerMatchImage") 
           }
           if($("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").removeClass("headerMatchImage") 
           }
             /*if(position < 30){
                 if(! $("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").addClass("scoreFont");
             }
             }*/
             
       }
       if(position > 107 && position <= 140){
           if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",(140 -position)+'px');
           $("#competHeader").css("opacity",  (140 - position)*3/100);
       }
       if(position >50 && position <= 83){
            if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
            $("#awayHeaderName").css("opacity",(83 - position)*3/100);
            $("#homeHeaderName").css("opacity",(83 - position)*3/100);
       }
       if(position<140 && position > 5){
           if($scope.headerSmall){
              $("#homeTeamHeader").css('text-align',"center");
              $("#awayTeamHeader").css("text-align","center");
              $("#awayTeamHeader").css('width',"40%");
         }
          $scope.headerSmall=false;
         
          $("#headerMatches").css("height",(200-(position*1.05))+'px');
          $("#matchFanZoneContent").css("margin-top",(150 -(position*1.05))+'px');
          $("#awayImage").css("height",(75 - position/3)+'px');
          $("#homeImage").css("height",(75 - position/3)+'px');
          var marginTop= (position * (60/140))-58;
          var top =50- (position * 50/140);
          var fontSize= 31 -(position *12/140);
          var marginScore= (position * (40/140))-30;
          $(".headerMatchDiv").css("margin-top", marginTop+'px');
          $(".headerMatchDiv").css("top", top+'%');
          $("#scoreHeader").css("top", top+'%');
          $("#scoreHeader").css("font-size",fontSize+"px");
          $("#scoreHeader").css("margin-top", marginScore+"px");
       }else if(position > 140 && ! $scope.headerSmall){
           
           $scope.headerSmall=true;
            $("#headerMatches").css("height",'45px');
            $("#headerMatches").addClass("animateMatchUp");
            $("#awayTeamHeader").css('text-align',"left");
            $("#homeTeamHeader").css("text-align","right");
            $("#awayTeamHeader").css('width',"40%");
            $("#matchDescContent").css("margin-top",'1px');
            $("#homeImage").css("height",'29px');
            $("#awayImage").css("height",'29px');
            $(".headerMatchDiv").css("margin-top", '8px');
            $(".headerMatchDiv").css("top",0);
            $("#scoreHeader").css("top", 0);
            $("#scoreHeader").css("font-size","22px");
            $("#scoreHeader").css("margin-top", "13px");
             $("#competHeader").css("opacity", 0);
             if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",0);
           if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
           $("#homeHeaderName").css("opacity", 0);
           $("#awayHeaderName").css("opacity", 0);
       }
       /*if($scope.isBig){
        $("#headerMatches").addClass("animateMatchUp");
        $("#matchDescContent").addClass("reduceMargin");
       }else if(position==0){
         $("#headerMatches").addClass("animateMatchDown");  
         $("#matchDescContent").addClass("increaseMargin");
       }*/
       //console.log($ionicScrollDelegate.getScrollPosition());
    };
   

    $scope.GetTeamVoteStatus = function() {
        $http({
            method : 'GET',
            url : serverURL + '/mvp/match/status?match_id=' + match_id
        }).then( function(results){
            console.log(results);
            if(results.status == 200 && results.data.data.length != 0){
                $http({
                    method : 'GET',
                    url : serverURL + '/mvp/players/user/'+$rootScope.Current_user+'/status/?match_id='+match_id,
                }).then( function(results){
                    console.log(results.data.data);
                    if(results.status == 200 && results.data.data.length != 0){
                        var team_info = results.data.data;
                        for(var i=0;i<team_info.length; i++){
                            console.log(homeTeam+" - "+team_info[i].team_id+" - "+awayTeam);
                            if(homeTeam == team_info[i].team_id && team_info[i].status == true){
                                $rootScope.HometeamVoted = true;
                            }
                            if(awayTeam == team_info[i].team_id && team_info[i].status == true){
                                $rootScope.AwayteamVoted = true;
                            }
                            if(team_info[i].voted_players_count>0){
                                $rootScope.alreadyStartedVoting = true;
                            }
                            
                        }
                        if($rootScope.AwayteamVoted == true || $rootScope.HometeamVoted == true){
                             $location.url("/app/match/reviewdetails/"+$scope.matchId);
                        } else{
                            $scope.loadpage = true;
                        }
                        
                    } 
                }).catch(function(response) {
                    // console.log(response);
                    if(response.status == 500 || response.status == 0){  //  message: user voted to requested team
                        $scope.fanzoneMessage=serverIssueMsg;
                        // $rootScope.review_detail_msg = NoPlayerDataMsg;
                        // $location.url("/app/match/reviewdetails/"+$scope.matchId);
                    }
                    return true;
                }).finally(function() {
                    console.log("finally finished gists");
                }); 
                
                $http.get(serverURL + '/mvp/players/season/league?competition_id=' + competition_id+'&match_id='+match_id+'&user_id='+$rootScope.Current_user).then(function (res) {
                    console.log(res);
                    if(res.data.data){
                            $scope.top_season_players = res.data.data;
                    } else{
                        $scope.top_season_players="";
                    }
                });
            } 
        }).catch(function(response) {
            console.log(response);
            if($rootScope.match_selected_isLive && response.status == 409){
                $scope.fanzoneMessage = livefanzoneMsg;
                // $rootScope.allVoted = false;
                // $rootScope.cardsLoaded = false;
            }
            else if(response.status == 500 || response.status == 0){ //message: "Server cannot process request at this time, try again later "
                $scope.fanzoneMessage=serverIssueMsg;
                // $rootScope.cardsLoaded = false;
            }
            else if(response.status == 406){ //  message: "Voting ended for this match"
                $scope.fanzoneMessage = votingEndMsg;
                $rootScope.AwayteamVoted = true;
                $rootScope.HometeamVoted = true;
                // $rootScope.review_detail_msg = votingEndMsg;
                // $rootScope.cardsLoaded = false;
                $scope.voting_completed = true;
                // $scope.allVoted = false;
                // $location.url("/app/match/reviewdetails/"+$scope.matchId);
            }
            else if(response.status == 409){  //  message: "Server do not have data for this match"
                $scope.fanzoneMessage = NoPlayerDataMsg;
                // $rootScope.cardsLoaded = false;
                $rootScope.review_detail_msg = NoPlayerDataMsg;
                // $location.url("/app/match/reviewdetails/"+$scope.matchId);
            }
            return true;
        }).finally(function() {
            console.log("finally finished gists");
        });
    }
    
    $scope.GetTeamVoteStatus(); 
   
    $scope.openteamRating = function(teamid){
         $location.url("/app/match/teamfanzone/"+$scope.matchId+"/"+teamid);
    }
    
    // socketConnect.forward('top_season_players', $scope);
    // $scope.$on('socket:top_season_players', function (ev, data) {
    //     $scope.top_season_players = data;
    // });
    
    
    
})

.controller('MatchFanzoneTeamCtrl', function($scope, $rootScope, $http, socketConnect, $location,$ionicSideMenuDelegate, $ionicHistory) {
    $scope.title= matchFanZoneTitle;
    $scope.voteWord=voteWord;
    $scope.skipWord=skipWord;
    $scope.allVotedMsg=allVotedMsg;
    $scope.thanksRatingMsg=thanksRatingMsg;
    $scope.ViewRatingBtn=ViewRatingBtn;
    
    $scope.playersWord=playersWord;
    $scope.ratingWord = ratingWord;
    
    // if($rootScope.match_selected_isLive){
    //     $scope.fanzoneMessage = livefanzoneMsg;
    //     $rootScope.status= "Live";
    // }else{
    //     $scope.fanzoneMessage = "";
    //     $rootScope.status= finishedWord;
    // }

    var urlSplit= $location.url().split('/');
    $scope.teamId=urlSplit[urlSplit.length -1];
    $scope.matchId=urlSplit[urlSplit.length -2];  
    console.log($scope.matchId+" --- "+ $scope.teamId);
    var team = "list";
    var match_id = $scope.matchId;
    var team_id = $scope.teamId;
    
    $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
    // console.log($scope.matches);
    var matchFound=false;
    for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
        for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
          if($scope.matches.Calendar.championship.StageRound[i].matches[j].Match.id == $scope.matchId){
              matchFound=true;
             $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
             break;
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
          }
        }
    }
    if(!matchFound){
        if($scope.matches.Calendar['knockout-brackets'] != undefined){
            for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                  if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                     $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                     matchFound=true;
                     break;
                     //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  }
                }
            }
        }
    }
    console.log($rootScope.Match);
    $scope.currentMatch = $rootScope.Match;
    var competition_id= cid; //$rootScope.Match.Competition.id;
    var homeTeam = $rootScope.Match.HomeTeam.id;
    var awayTeam = $rootScope.Match.AwayTeam.id;
    // DYNAMIC TEAM AND MATCH NOT WORKING
    // team_id= "4c616c6a-ac54-49b0-9f14-4033c1eee52b";//"4c616c6a-ac54-49b0-9f14-4033c1eee52b";
    // match_id = "53982b4e-3220-49de-a11e-0f13dfbdb49f"; //"53982b4e-3220-49de-a11e-0f13dfbdb49f";
    // // match_id="53ba65f0-b028-443b-8861-220b0a00bcba";
    //  competition_id = "4b1fb7dd-48f0-470a-8444-7326c1eee52b";//"4b1fb7dd-48f0-470a-8444-7326c1eee52b";
    // for(var i=0;i<$rootScope.teamsList.length;i++){
        
    //     //console.log($rootScope.teamsList[i].nicknames.initials[0]);
    //     if($rootScope.Match.HomeTeam.id == $rootScope.teamsList[i].id){
    //         $scope.home_media= $rootScope.teamsList[i].media_id;
    //         if($rootScope.teamsList[i].nicknames != undefined && $rootScope.teamsList[i].nicknames.initials != undefined)
    //           $scope.home_name= $rootScope.teamsList[i].nicknames.initials[0];
    //         continue;
    //     }
    //     if($rootScope.Match.AwayTeam.id == $rootScope.teamsList[i].id){
    //         $scope.away_media= $rootScope.teamsList[i].media_id;
    //         if($rootScope.teamsList[i].nicknames != undefined && $rootScope.teamsList[i].nicknames.initials != undefined)
    //           $scope.away_name= $rootScope.teamsList[i].nicknames.initials[0];
    //     }
    // }
    $scope.home_name = $rootScope.Match.HomeTeam.name;
    $scope.away_name = $rootScope.Match.AwayTeam.name;
    if(homeTeam == team_id){
        $scope.teamName = $scope.home_name;
    }
    if(awayTeam == team_id){
        $scope.teamName = $scope.away_name;
    }
     
    
    $scope.cards = [];
    
    $scope.counter = 0;
  
    $scope.$on('$ionicView.beforeEnter', function(event, viewData){
        $scope.cards = [];
        $scope.addCards();
        viewData.enableBack = true;
        $rootScope.review_detail_msg = "";
        $scope.voting_completed = false;
    });
    
    $scope.$on('$ionicView.enter', function() {
        //alert("fired");
      $ionicHistory.clearHistory();
      $ionicSideMenuDelegate.canDragContent(false);
    });
    $scope.$on('$ionicView.leave', function () {
      $rootScope.review_detail_msg = "";
    });
   
    $scope.addCard = function(image) {
        var newCard = image;
        newCard['image'] = $rootScope.players_img(image.media_id,200,200);
        // $scope.cards.unshift(angular.extend({}, newCard));
        $scope.cards.push(angular.extend({}, newCard));
    };
    
    var team = "list";
    $scope.addOnStack=function(no_players){
        var cards = $scope.allplayers;
        // $rootScope.total_player = cards.length > 3 ? 3 : cards.length;// results.data.data.length;
        var lastindex= $rootScope.total_player -1;
        // alert(lastindex + " " + $scope.addedPlayer);
        var displayUpTo= no_players+$scope.addedPlayer;
        if($scope.addedPlayer <= lastindex){
            for(i=$scope.addedPlayer;i<displayUpTo; i++){
                $scope.addCard(cards[i]);
                $rootScope.players.push(cards[i]);
                $scope.addedPlayer++;
            }
        }
    }
    
    $scope.addCards = function() {
        $scope.voting_completed = false;
        
        // console.log(serverURL + '/mvp/players/' + team + '?match_id=' + match_id+'&team_id='+team_id+'&user_id='+$rootScope.Current_user);
        $http({
            method : 'GET',
            url : serverURL + '/mvp/players/' + team + '?match_id=' + match_id+'&team_id='+team_id+'&user_id='+$rootScope.Current_user
        }).then( function(results){
            console.log(results);
            if(results.status == 200 && results.data.data.length != 0){
                $rootScope.players = [];
                $scope.cards=[];
                $rootScope.VotingDONE = false;
                $rootScope.cardsLoaded = true;
                $rootScope.allVoted = false;
                $scope.allplayers=results.data.data;
                $rootScope.total_player = $scope.allplayers.length;
                // var cards = results.data.data;
                // $rootScope.total_player = cards.length > 3 ? 3 : cards.length;// results.data.data.length;
                // $scope.cards=[];
                // for(var i=0;i<$rootScope.total_player; i++){
                //     $scope.addCard(cards[i]);
                //     $rootScope.players.push(cards[i]);
                // }
                // angular.forEach(results.data.data, function(card) {
                    // $scope.addCard(card);
                // });
                $scope.addedPlayer = 0;
                $scope.addOnStack(3);
                $scope.counter = 0;
                socketConnect.emit('team', {match_id: match_id, competition_id:competition_id, players_count:No_ofTopPlayers});
                $rootScope.match_selected_isLive =false;
            } 
        }).catch(function(response) {
            console.log(response);
            if($rootScope.match_selected_isLive && response.status == 409){
                $scope.fanzoneMessage = livefanzoneMsg;
                $rootScope.allVoted = false;
                $rootScope.cardsLoaded = false;
            }
            else if(response.status == 500 || response.status == 0){ //message: "Server cannot process request at this time, try again later "
                $scope.fanzoneMessage=serverIssueMsg;
                $rootScope.cardsLoaded = false;
            }
            else if(response.status == 406){ //  message: "Voting ended for this match"
                $scope.fanzoneMessage = votingEndMsg;
                $rootScope.review_detail_msg = votingEndMsg;
                $rootScope.cardsLoaded = false;
                $scope.voting_completed = true;
                $scope.allVoted = false;
                // $location.url("/app/match/reviewdetails/"+$scope.matchId);
            }
            else if(response.status == 400){  // message: "User had voted all the players of this match",
                // $scope.fanzoneMessage = alreadyVotedMsg;
                $rootScope.allVoted = true;
                $rootScope.cardsLoaded = false;
                if(homeTeam == team_id){
                    $rootScope.HometeamVoted = true;
                }
                if(awayTeam == team_id){
                    $rootScope.AwayteamVoted = true;
                }
            }
            else if(response.status == 409){  //  message: "Server do not have data for this match"
                $scope.fanzoneMessage = NoPlayerDataMsg;
                $rootScope.cardsLoaded = false;
                // $rootScope.review_detail_msg = NoPlayerDataMsg;
                // $location.url("/app/match/reviewdetails/"+$scope.matchId);
            }
            return true;
        }).finally(function() {
            console.log("finally finished gists");
        });
    };
  
    
    socketConnect.forward('voting_error', $scope);
    $scope.$on('socket:voting_error', function (ev, data) {
        // console.log(data);
        if(data.status == 500){
            $rootScope.review_detail_msg = serverIssueMsg;
            // $scope.fanzoneMessage=serverIssueMsg;
        }else if(data.status == 406){
            $rootScope.review_detail_msg = votingEndMsg;
        }
        $scope.voting_completed = true;
        // $location.url("/app/match/reviewdetails/"+$scope.matchId);
    });
    
    $scope.$on('socket:error', function (ev, data) {
        console.log('got an error opps ' + data)
    });
    
    $scope.move_right_class = [];
  
    var vote = function (vote_type, id) {
        var players= $rootScope.players;
        for(var p in players){
            var pl= players[p];
            
            if (pl.player_id == id) {
                console.log(pl);
                socketConnect.emit('update', {
                    player_id: pl.player_id,
                    // positive_votes: pl.positive_votes,
                    competition_id: pl.competition_id,
                    team_id: pl.team_id,
                    vote_type: vote_type,
                    match_id: match_id,
                    user_id: $rootScope.Current_user,
                    app_type: "league"
                });
                
                console.log('vode done');
                
            }
        }
    }
  
    $scope.cardLike = function(card, type, $index) {
        var current_index= $index;
        vote('up',card.player_id);
        if(type == 1){
            $('.td-card--index-'+current_index).addClass("magictime spaceOutRight");
        }
    };

    $scope.cardDislike = function(card,type,$index) {
        var current_index= $index;
        vote('down',card.player_id);
        if(type == 1){
            $('.td-card--index-'+current_index).addClass("magictime spaceOutLeft");
        }
    };
  
    $scope.cardSkip = function(card,type,$index) {
        var current_index= $index;
        vote('skip',card.player_id);
        if(type == 1){
            $('.td-card--index-'+current_index).addClass("magictime spaceOutUp");
        }
    };

    $scope.removeCard = function($index) {
        $scope.cards.splice($index, 1);
        $scope.counter++;
        if($scope.counter == $rootScope.total_player){
            $rootScope.VotingDONE = true;
            $rootScope.cardsLoaded = false;
            if(homeTeam == team_id){
                $rootScope.HometeamVoted = true;
            }
            if(awayTeam == team_id){
                $rootScope.AwayteamVoted = true;
            }
            $location.url("/app/match/reviewdetails/"+$scope.matchId);
        }
        $scope.addOnStack(1);
    };

    $scope.fadeCard = function($index) {
        this.swipeCard.el.style.opacity = 0;
        
    }
  
    socketConnect.forward('updated_players', $scope);
    $scope.$on('socket:updated_players', function (ev, data) {
        $.each($rootScope.players, function () {
            if (this.player_id == data.player_id) {
                this.positive_votes = data.positive_votes
            }
        })
    });
})

.controller('MatchReviewDetailCtrl', function($scope, $rootScope, $http, socketConnect, $location, $ionicScrollDelegate) {
    $scope.title= matchFanZoneTitle;
    $scope.missingPlayerMsg = missingPlayerMsg;
    $scope.rateRestSquadMsg = rateRestSquadMsg;
    $scope.topRatedMatchMsg = topRatedMatchMsg;
    $scope.BestPlayerSeasonMsg = BestPlayerSeasonMsg;

    $scope.ratePlayersWord = ratePlayersWord;
    $scope.topRatedForWord = topRatedForWord;
    $scope.noPlayersRatingMatchMsg = noPlayersRatingMatchMsg;
    $scope.noPlayersRatingSeasonMsg = noPlayersRatingSeasonMsg;
 
    var urlSplit= $location.url().split('/');
    $scope.matchId=urlSplit[urlSplit.length -1];  
    var team = "list";
    var match_id = $scope.matchId;
    // var team_id = tid;
    
    console.log($scope.matchId);
    $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
      viewData.enableBack = true;
    });
   
    $scope.animateHeader=function(){
        //console.log(event);
        var position=$ionicScrollDelegate.$getByHandle("matchRatingContent").getScrollPosition().top;
       //$("#headerMatches").removeClass("headerBig");
       console.log(position);
       if(position <= 5){
           //alert("hello");
           $("#awayTeamHeader").css('text-align',"center");
            $("#homeTeamHeader").css("text-align","center");
           if(! $("#homeTeamHeader").hasClass("homeTeamHeader")){
               $("#homeTeamHeader").addClass("homeTeamHeader");
           }
           if(! $("#awayTeamHeader").hasClass("awayTeamHeader")){
               $("#awayTeamHeader").addClass("awayTeamHeader");
           }
           if(! $("#scoreHeader").hasClass("scoreFont")){
               $("#scoreHeader").addClass("scoreFont");
           }
           if(! $("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").addClass("competHeaderBig")
           }
           if(! $("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").addClass("teamHeaderName");
           }
           if(! $("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").addClass("headerMatchImage") 
           }
           if(! $("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").addClass("headerMatchImage") 
           }
           $("#headerMatches").css("height",'200px');
           $("#matchDescContent").css("margin-top",'150px');
           $scope.headerSmall=false;
       }else{
           
            if($("#homeTeamHeader").hasClass("homeTeamHeader")){
                $("#homeTeamHeader").removeClass("homeTeamHeader");
             }
             if($("#awayTeamHeader").hasClass("awayTeamHeader")){
                $("#awayTeamHeader").removeClass("awayTeamHeader");
             }
             if($("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").removeClass("scoreFont");
             }
             if($("#homeImage").hasClass("headerMatchImage")){
              $("#homeImage").removeClass("headerMatchImage") 
           }
           if($("#awayImage").hasClass("headerMatchImage")){
              $("#awayImage").removeClass("headerMatchImage") 
           }
             /*if(position < 30){
                 if(! $("#scoreHeader").hasClass("scoreFont")){
                $("#scoreHeader").addClass("scoreFont");
             }
             }*/
             
       }
       if(position > 107 && position <= 140){
           if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",(140 -position)+'px');
           $("#competHeader").css("opacity",  (140 - position)*3/100);
       }
       if(position >50 && position <= 83){
            if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
            $("#awayHeaderName").css("opacity",(83 - position)*3/100);
            $("#homeHeaderName").css("opacity",(83 - position)*3/100);
       }
       if(position<140 && position > 5){
           if($scope.headerSmall){
              $("#homeTeamHeader").css('text-align',"center");
              $("#awayTeamHeader").css("text-align","center");
              $("#awayTeamHeader").css('width',"40%");
         }
          $scope.headerSmall=false;
         
          $("#headerMatches").css("height",(200-(position*1.05))+'px');
          $("#matchRatingContent").css("margin-top",(150 -(position*1.05))+'px');
          $("#awayImage").css("height",(75 - position/3)+'px');
          $("#homeImage").css("height",(75 - position/3)+'px');
          var marginTop= (position * (60/140))-58;
          var top =50- (position * 50/140);
          var fontSize= 31 -(position *12/140);
          var marginScore= (position * (40/140))-30;
          $(".headerMatchDiv").css("margin-top", marginTop+'px');
          $(".headerMatchDiv").css("top", top+'%');
          $("#scoreHeader").css("top", top+'%');
          $("#scoreHeader").css("font-size",fontSize+"px");
          $("#scoreHeader").css("margin-top", marginScore+"px");
       }else if(position > 140 && ! $scope.headerSmall){
           
           $scope.headerSmall=true;
            $("#headerMatches").css("height",'45px');
            $("#headerMatches").addClass("animateMatchUp");
            $("#awayTeamHeader").css('text-align',"left");
            $("#homeTeamHeader").css("text-align","right");
            $("#awayTeamHeader").css('width',"40%");
            $("#matchDescContent").css("margin-top",'1px');
            $("#homeImage").css("height",'29px');
            $("#awayImage").css("height",'29px');
            $(".headerMatchDiv").css("margin-top", '8px');
            $(".headerMatchDiv").css("top",0);
            $("#scoreHeader").css("top", 0);
            $("#scoreHeader").css("font-size","22px");
            $("#scoreHeader").css("margin-top", "13px");
             $("#competHeader").css("opacity", 0);
             if($("#competHeader").hasClass("competHeaderBig")){
               $("#competHeader").removeClass("competHeaderBig")
           }
           $("#competHeader").css("height",0);
           if($("#awayHeaderName").hasClass("teamHeaderName")){
               $("#awayHeaderName").removeClass("teamHeaderName");
           }
           if($("#homeHeaderName").hasClass("teamHeaderName")){
               $("#homeHeaderName").removeClass("teamHeaderName");
           }
           $("#homeHeaderName").css("opacity", 0);
           $("#awayHeaderName").css("opacity", 0);
       }
       /*if($scope.isBig){
        $("#headerMatches").addClass("animateMatchUp");
        $("#matchDescContent").addClass("reduceMargin");
       }else if(position==0){
         $("#headerMatches").addClass("animateMatchDown");  
         $("#matchDescContent").addClass("increaseMargin");
       }*/
       //console.log($ionicScrollDelegate.getScrollPosition());
    };
    $scope.matches= JSON.parse(window.localStorage[ls_calendar]); 
    // console.log($scope.matches);
    var matchFound=true;
    for (var i=0;i<$scope.matches.Calendar.championship.StageRound.length;i++){
        for(var j = 0; j < $scope.matches.Calendar.championship.StageRound[i].matches.length;j++) {
          if($scope.matches.Calendar.championship.StageRound[i].matches[j].id == $scope.matchId){
              matchFound=true;
             $rootScope.Match = $scope.matches.Calendar.championship.StageRound[i].matches[j];
             console.log($rootScope.Match);
             break;
             //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
          }
        }
    }
     if(!matchFound){
        if($scope.matches.Calendar['knockout-brackets'] != undefined){
            for (var i=0;i<$scope.matches.Calendar['knockout-brackets'].StageRound.length;i++){
                for(var j = 0; j < $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches.length;j++) {
                  if($scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j].Match.id == $scope.matchId){
                     $rootScope.Match = $scope.matches.Calendar['knockout-brackets'].StageRound[i].matches[j];
                     matchFound=true;
                     break;
                     //$rootScope.Match.Match.home_goals= Math.floor((Math.random() * 10) + 1);   //for testing
                  }
                }
            }
        }
    }
    console.log($rootScope.Match);
    $scope.currentMatch = $rootScope.Match;
   
    var competition_id= cid;
    var homeTeam = $scope.currentMatch.HomeTeam.id;
    var awayTeam = $scope.currentMatch.AwayTeam.id;
    // team_id= "4c616c6a-ac54-49b0-9f14-4033c1eee52b";// "4c616c6a-ac54-49b0-9f14-4033c1eee52b";
    // match_id = "53982b4e-3220-49de-a11e-0f13dfbdb49f";// "53982b4e-3220-49de-a11e-0f13dfbdb49f";
    // match_id="53ba65f0-b028-443b-8861-220b0a00bcba";
    // competition_id = "4b1fb7dd-48f0-470a-8444-7326c1eee52b";//"4b1fb7dd-48f0-470a-8444-7326c1eee52b";
    
    $scope.$on('$ionicView.afterLeave', function(){
        $rootScope.VotingDONE = false;
        $rootScope.review_detail_msg = "";
        $scope.Flasheffect ="";
    });
    
    $scope.GetTopRatedForMatch = function() {
        // console.log(serverURL + '/mvp/players/season?competition_id=' + competition_id+'&team_id='+homeTeam+'&match_id='+match_id+'&user_id='+$rootScope.Current_user);
        // var team_id= $rootScope.team_id;
        $http.get(serverURL + '/mvp/players/season/league?competition_id='+competition_id+'&match_id='+match_id+'&user_id='+$rootScope.Current_user+'&players_count='+No_ofTopPlayers).then(function (res) {
            console.log(res);
            if(res.data.data){
                $rootScope.top_season_players = res.data.data;
                // $scope.first_player_image = $rootScope.players_img($rootScope.top_season_players[0].media_id,50,50);
            } else{
                $rootScope.top_season_players="";
            }
            
            // console.log(res.data.data);
        })
        // console.log(serverURL + '/mvp/players/match?match_id=' + match_id+'&team_id='+homeTeam+'&user_id='+$rootScope.Current_user);
        // var match_id= $rootScope.match_id;
        $http.get(serverURL + '/mvp/players/match?match_id=' + match_id+'&team_id='+homeTeam+'&user_id='+$rootScope.Current_user+'&players_count='+No_ofTopPlayers).then(function (res) {
            console.log(res);
            if(res.data.data){
                $rootScope.top_home_match_players = res.data.data;
            } else{
                $rootScope.top_home_match_players="";
            }
        })
        
        // console.log(serverURL + '/mvp/players/match?match_id=' + match_id+'&team_id='+awayTeam+'&user_id='+$rootScope.Current_user);
        // var match_id= $rootScope.match_id;
        $http.get(serverURL + '/mvp/players/match?match_id=' + match_id+'&team_id='+awayTeam+'&user_id='+$rootScope.Current_user).then(function (res) {
        console.log(res);
        if(res.data.data){
            $rootScope.top_away_match_players = res.data.data;
        } else{
            $rootScope.top_away_match_players="";
        }
            // socketConnect.emit('team', {match_id: match_id, competition_id:competition_id});
            socketConnect.emit('team', {
              players_count: No_ofTopPlayers, 
              match_id: match_id,
              competition_id: competition_id,
              away_team_id: awayTeam, 
              home_team_id: homeTeam, 
              app_type: "league"
            });
        })
    };
    $scope.GetTopRatedForMatch();
  
  
    $scope.openteamRating = function(teamid){
         $location.url("/app/match/teamfanzone/"+$scope.matchId+"/"+teamid);
    }
    
    
    if($rootScope.VotingDONE == true){
        $scope.Flashmessage = "Thank You!"
        $scope.Flasheffect = "magictime spaceInUp";
        $scope.Flasheffect = "";
        setTimeout(function(){
            $scope.$apply(function(){
                $scope.Flasheffect = "magictime spaceOutUp";
                
                console.log('testing');
                setTimeout(function(){
                $rootScope.VotingDONE = false;
                // $scope.Flasheffect ="";
                },1000);
            });
        },3000);
    }
    
    if($rootScope.review_detail_msg != ""){
        $scope.Flasheffect = "magictime spaceInUp";
        $scope.Flasheffect = "";
        setTimeout(function(){
            $scope.$apply(function(){
                $scope.Flasheffect = "magictime spaceOutUp";
                console.log('testing');
                setTimeout(function(){
                    $rootScope.review_detail_msg = '';
                    // $scope.Flasheffect ="";
                },1000);
            });
        },3000);
    }
    
    $scope.voteMissingPlayers = function() {
         $location.url("/app/match/fanzone/"+$scope.matchId);
    }
    
    socketConnect.forward('top_team_players', $scope);
    $scope.$on('socket:top_team_players', function (ev, data) {
        // now socket data you will get it as follows - 
        // { 
        //  team_id: <team_id>,
        //  players: <players array as previous>
        // }
        
        console.log('got the team id '  + data.team_id )
        if(data.team_id === homeTeam){
            $rootScope.top_home_match_players = data.players;
        }else{
            $rootScope.top_away_match_players = data.players;
        }
    });
  
    
    // $scope.$on('socket:top_team_players', function (ev, data) {
    //     $rootScope.top_match_players = data;
    // });

    // socketConnect.forward('top_season_players', $scope);
    // $scope.$on('socket:top_season_players', function (ev, data) {
    //     $rootScope.top_season_players = data;
    // });
})

.controller('islRankingCtrl', function($scope, $location, LoadingService,$rootScope){
    $scope.title= islRankingTitle;
    $scope.ISL_team = ISL_team;
    $scope.ISL_matches_played = ISL_matches_played;
    $scope.ISL_matches_won = ISL_matches_won;
    $scope.ISL_matches_drawn = ISL_matches_drawn;
    $scope.ISL_matches_lost = ISL_matches_lost;
    $scope.ISL_goals_for_team = ISL_goals_for_team;
    $scope.ISL_goals_against_team = ISL_goals_against_team;
    $scope.ISL_goal_difference = ISL_goal_difference;
    $scope.ISL_points = ISL_points;
    $scope.champ_title = cname;
    var newScore = [
            {
            	Team: {
            		id: "563a2c81-629c-4dd8-8063-5e220a00bcdd",
            		home_venue_id: "563a31ab-fd44-4229-b36c-5e1f0a00bcdd",
            		headquarters_id: "563a3575-ed8c-4f36-a265-64b90a00bcdd",
            		training_id: "",
            		country: "ind",
            		name: "Neroca FC",
            		verified_user_id: null,
            		inauguration_date: "1967-01-01",
            		description: null,
            		logo: null,
            		created: "2015-11-04 17:42:29",
            		modified: "2015-11-04 17:42:29",
            		media_id: "563a3208-7010-4d6d-bd6e-5e1f0a00bcdd",
            		coverphoto_home: null,
            		rating: "0.0",
            		favorite_count: "1",
            		is_national: "0",
            		disbanded_year: null,
            		season_start_day: "1",
            		season_start_month: "7",
            		season_date_type: "seasonal",
            		info_enabled: "1",
            		news_enabled: "1",
            		news_unlocked: "1",
            		video_enabled: "1",
            		image_enabled: "1",
            		transfers_enabled: "1",
            		same_name_player_enabled: "0",
            		statistics_enabled: "1",
            		wiki_enabled: "1",
            		wiki_unlocked: "1",
            		news_comments_enabled: "1",
            		slug: "neroca-fc",
            		website: "",
            		tickets: "Phone number or website",
            		status: "0",
            		admin_action: null,
            		admin_user_id: "",
            		admin_action_date: null,
            		gender: "m",
            		website_rss_feed: "",
            		facebook_page: "",
            		twitter_page: "",
            		video_channel: ""
            	},
            	TeamStageStatCache: {
            		team_id: "563a2c81-629c-4dd8-8063-5e220a00bcdd",
            		stage_id: "56b1b2ae-5a48-4b55-b9c2-55260a00bcbb",
            		stage_round_id: "56b1b2ae-5e1c-4feb-9e69-55260a00bcbb",
            		is_home: "1",
            		matches_played: "2",
            		matches_won: "1",
            		matches_drawn: "1",
            		matches_lost: "0",
            		goals_for_team: "2",
            		goals_against_team: "0",
            		goal_difference: "2",
            		points: "4",
            		hh_goals_for_team: 0,
            		hh_goals_against_team: 0,
            		hh_goal_difference: 0,
            		hh_points: 1
            	}
            },{
            	Team: {
            		id: "563a5393-5cbc-43d1-9e12-66520a00bc97",
            		home_venue_id: "563a5476-6c68-43f6-b930-66550a00bc97",
            		headquarters_id: "563a54c1-a218-4aca-91ba-66560a00bc97",
            		training_id: "",
            		country: "ind",
            		name: "Minerva Academy FC",
            		verified_user_id: null,
            		inauguration_date: "2015-01-01",
            		description: null,
            		logo: null,
            		created: "2015-11-04 19:56:01",
            		modified: "2015-12-26 19:08:29",
            		media_id: "567ed773-0d90-4d1f-b77a-6f970a00bcbf",
            		coverphoto_home: null,
            		rating: "0.0",
            		favorite_count: "1",
            		is_national: "0",
            		disbanded_year: "0000-00-00",
            		season_start_day: "1",
            		season_start_month: "7",
            		season_date_type: "seasonal",
            		info_enabled: "1",
            		news_enabled: "1",
            		news_unlocked: "1",
            		video_enabled: "1",
            		image_enabled: "1",
            		transfers_enabled: "1",
            		same_name_player_enabled: "0",
            		statistics_enabled: "1",
            		wiki_enabled: "1",
            		wiki_unlocked: "1",
            		news_comments_enabled: "1",
            		slug: "minerva-academy-fc",
            		website: "",
            		tickets: "Phone number or website",
            		status: "0",
            		admin_action: null,
            		admin_user_id: "",
            		admin_action_date: null,
            		gender: "m",
            		website_rss_feed: "",
            		facebook_page: "",
            		twitter_page: "",
            		video_channel: ""
            	},
            	TeamStageStatCache: {
            		team_id: "563a5393-5cbc-43d1-9e12-66520a00bc97",
            		stage_id: "56b1b2ae-5a48-4b55-b9c2-55260a00bcbb",
            		stage_round_id: "56b1b2ae-5e1c-4feb-9e69-55260a00bcbb",
            		is_home: "0",
            		matches_played: "2",
            		matches_won: "1",
            		matches_drawn: "1",
            		matches_lost: "0",
            		goals_for_team: "2",
            		goals_against_team: "1",
            		goal_difference: "1",
            		points: "4",
            		hh_goals_for_team: 0,
            		hh_goals_against_team: 0,
            		hh_goal_difference: 0,
            		hh_points: 1
            	}
            },{
            	Team: {
            		id: "52e21d4d-7f88-4525-a7c8-13c5dfbdb49f",
            		home_venue_id: "545145f9-a248-46d1-9a9f-1fd00a00bcbf",
            		headquarters_id: "52e22313-2158-4871-80d2-13c5dfbdb49f",
            		training_id: "",
            		country: "ind",
            		name: "Dempo Sports Club",
            		verified_user_id: null,
            		inauguration_date: "1967-01-01",
            		description: null,
            		logo: null,
            		created: "2014-01-24 09:23:47",
            		modified: "2016-03-25 18:59:48",
            		media_id: "530df9b7-29c4-46a1-a7a0-4f23dfbdb49f",
            		coverphoto_home: "56f57c75-c24c-4c31-be21-55c80a00bcba",
            		rating: "0.0",
            		favorite_count: "3",
            		is_national: "0",
            		disbanded_year: null,
            		season_start_day: "1",
            		season_start_month: "7",
            		season_date_type: "seasonal",
            		info_enabled: "1",
            		news_enabled: "1",
            		news_unlocked: "1",
            		video_enabled: "1",
            		image_enabled: "1",
            		transfers_enabled: "1",
            		same_name_player_enabled: "0",
            		statistics_enabled: "1",
            		wiki_enabled: "1",
            		wiki_unlocked: "1",
            		news_comments_enabled: "1",
            		slug: "dempo-sports-club",
            		website: "http://demposportsclub.com/",
            		tickets: "Phone number or website",
            		status: "0",
            		admin_action: null,
            		admin_user_id: "",
            		admin_action_date: null,
            		gender: "m",
            		website_rss_feed: "",
            		facebook_page: "",
            		twitter_page: "",
            		video_channel: ""
            	},
            	TeamStageStatCache: {
            		team_id: "52e21d4d-7f88-4525-a7c8-13c5dfbdb49f",
            		stage_id: "56b1b2ae-5a48-4b55-b9c2-55260a00bcbb",
            		stage_round_id: "56b1b2ae-5e1c-4feb-9e69-55260a00bcbb",
            		is_home: "0",
            		matches_played: "2",
            		matches_won: "1",
            		matches_drawn: "0",
            		matches_lost: "1",
            		goals_for_team: "1",
            		goals_against_team: "2",
            		goal_difference: "-1",
            		points: "3",
            		hh_goals_for_team: 0,
            		hh_goals_against_team: 0,
            		hh_goal_difference: 0,
            		hh_points: 0
            	}
            },{
            	Team: {
            		id: "54f57f16-219c-4636-a91e-6b230a00bc97",
            		home_venue_id: "563a4c76-bdc4-4d6d-a92c-6f610a00bcdd",
            		headquarters_id: "54f57fe5-bb04-4725-9ea4-6b230a00bc97",
            		training_id: "",
            		country: "ind",
            		name: "LoneStar Kashmir FC",
            		verified_user_id: null,
            		inauguration_date: "2013-01-01",
            		description: null,
            		logo: null,
            		created: "2015-03-03 10:33:25",
            		modified: "2015-12-26 19:08:28",
            		media_id: "567ed766-f764-4c81-b906-6f970a00bcbf",
            		coverphoto_home: null,
            		rating: "0.0",
            		favorite_count: "1",
            		is_national: "0",
            		disbanded_year: "0000-00-00",
            		season_start_day: "1",
            		season_start_month: "7",
            		season_date_type: "seasonal",
            		info_enabled: "1",
            		news_enabled: "1",
            		news_unlocked: "1",
            		video_enabled: "1",
            		image_enabled: "1",
            		transfers_enabled: "1",
            		same_name_player_enabled: "0",
            		statistics_enabled: "1",
            		wiki_enabled: "1",
            		wiki_unlocked: "1",
            		news_comments_enabled: "1",
            		slug: "lonestar-kashmir-fc",
            		website: "",
            		tickets: "Phone number or website",
            		status: "0",
            		admin_action: null,
            		admin_user_id: "",
            		admin_action_date: null,
            		gender: "m",
            		website_rss_feed: "",
            		facebook_page: "",
            		twitter_page: "",
            		video_channel: ""
            	},
            	TeamStageStatCache: {
            		team_id: "54f57f16-219c-4636-a91e-6b230a00bc97",
            		stage_id: "56b1b2ae-5a48-4b55-b9c2-55260a00bcbb",
            		stage_round_id: "56b1b2ae-5e1c-4feb-9e69-55260a00bcbb",
            		is_home: "1",
            		matches_played: "2",
            		matches_won: "0",
            		matches_drawn: "1",
            		matches_lost: "1",
            		goals_for_team: "1",
            		goals_against_team: "2",
            		goal_difference: "-1",
            		points: "1",
            		hh_goals_for_team: 1,
            		hh_goals_against_team: 1,
            		hh_goal_difference: 0,
            		hh_points: 0
            	}
            
            },{
            	Team: {
            		id: "563a4295-dbb8-452f-8f4c-68fd0a00bcdd",
            		home_venue_id: "563a42db-0918-449b-8925-69000a00bcdd",
            		headquarters_id: "563a437e-086c-4549-a0a6-69020a00bcdd",
            		training_id: "",
            		country: "ind",
            		name: "Gangtok Himalayan SC",
            		verified_user_id: null,
            		inauguration_date: "2015-01-01",
            		description: null,
            		logo: null,
            		created: "2015-11-04 18:42:22",
            		modified: "2015-11-04 18:42:22",
            		media_id: "563a433a-603c-4f15-ae38-68fb0a00bcdd",
            		coverphoto_home: null,
            		rating: "0.0",
            		favorite_count: "1",
            		is_national: "0",
            		disbanded_year: null,
            		season_start_day: "1",
            		season_start_month: "7",
            		season_date_type: "seasonal",
            		info_enabled: "1",
            		news_enabled: "1",
            		news_unlocked: "1",
            		video_enabled: "1",
            		image_enabled: "1",
            		transfers_enabled: "1",
            		same_name_player_enabled: "0",
            		statistics_enabled: "1",
            		wiki_enabled: "1",
            		wiki_unlocked: "1",
            		news_comments_enabled: "1",
            		slug: "gangtok-himalayan-sc",
            		website: "",
            		tickets: "Phone number or website",
            		status: "0",
            		admin_action: null,
            		admin_user_id: "",
            		admin_action_date: null,
            		gender: "m",
            		website_rss_feed: "",
            		facebook_page: "",
            		twitter_page: "",
            		video_channel: ""
            	},
            	TeamStageStatCache: {
            		team_id: "563a4295-dbb8-452f-8f4c-68fd0a00bcdd",
            		stage_id: "56b1b2ae-5a48-4b55-b9c2-55260a00bcbb",
            		stage_round_id: "56b1b2ae-5e1c-4feb-9e69-55260a00bcbb",
            		is_home: "0",
            		matches_played: "2",
            		matches_won: "0",
            		matches_drawn: "1",
            		matches_lost: "1",
            		goals_for_team: "1",
            		goals_against_team: "2",
            		goal_difference: "-1",
            		points: "1",
            		hh_goals_for_team: 1,
            		hh_goals_against_team: 1,
            		hh_goal_difference: 0,
            		hh_points: 0
            	}
            
            },{
            	Team: {
            		id: "54f57a6a-9c48-43b0-8a24-6b350a00bc97",
            		home_venue_id: "55150c96-8b9c-4629-94f5-372d0a00bc97",
            		headquarters_id: "54f57bae-45a0-4fa7-a23c-67220a00bc97",
            		training_id: "",
            		country: "ind",
            		name: "Mohammedan Sporting",
            		verified_user_id: null,
            		inauguration_date: "1891-01-01",
            		description: null,
            		logo: null,
            		created: "2015-03-03 10:15:26",
            		modified: "2015-11-04 17:00:53",
            		media_id: "563a2b86-e724-4787-993b-5e1b0a00bcdd",
            		coverphoto_home: null,
            		rating: "0.0",
            		favorite_count: "1",
            		is_national: "0",
            		disbanded_year: null,
            		season_start_day: "1",
            		season_start_month: "7",
            		season_date_type: "seasonal",
            		info_enabled: "1",
            		news_enabled: "1",
            		news_unlocked: "1",
            		video_enabled: "1",
            		image_enabled: "1",
            		transfers_enabled: "1",
            		same_name_player_enabled: "0",
            		statistics_enabled: "1",
            		wiki_enabled: "1",
            		wiki_unlocked: "1",
            		news_comments_enabled: "1",
            		slug: "mohammedan-sporting",
            		website: "",
            		tickets: "Phone number or website",
            		status: "0",
            		admin_action: null,
            		admin_user_id: "",
            		admin_action_date: null,
            		gender: "m",
            		website_rss_feed: "",
            		facebook_page: "",
            		twitter_page: "",
            		video_channel: ""
            	},
            	TeamStageStatCache: {
            		team_id: "54f57a6a-9c48-43b0-8a24-6b350a00bc97",
            		stage_id: "56b1b2ae-5a48-4b55-b9c2-55260a00bcbb",
            		stage_round_id: "56b1b2ae-5e1c-4feb-9e69-55260a00bcbb",
            		is_home: "1",
            		matches_played: "2",
            		matches_won: "1",
            		matches_drawn: "0",
            		matches_lost: "1",
            		goals_for_team: "2",
            		goals_against_team: "2",
            		goal_difference: "0",
            		points: "0",
            		hh_goals_for_team: 0,
            		hh_goals_against_team: 0,
            		hh_goal_difference: 0,
            		hh_points: 0
            	}
            }];
    //$scope.Competitions={};
    //console.log($scope.title);
    if(Object.keys($rootScope.compRanking).length){
        
        $scope.Stagerounds=$rootScope.rounds;
        if(CurrentCom==3){
            $scope.Competitions= $rootScope.compRanking;
            $scope.Competitions[0] = newScore;
        }else{
            $scope.Competitions= $rootScope.compRanking;
        }
        
    } else{
        LoadingService.getIslRanking($scope);
    }
    
    $scope.letters=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
    
    $scope.doRefresh = function() {
        LoadingService.getIslRanking($scope);
    };

    $scope.$on('IslRankingLoaded', function(){
        // console.log($rootScope.rounds);
        console.log($rootScope.rounds);
        console.log($scope.Competitions);
        
        $scope.Stagerounds=$rootScope.rounds;
        if(CurrentCom==3){
            $scope.Competitions= $rootScope.compRanking;
            $scope.Competitions[0] = newScore;
        }else{
            $scope.Competitions= $rootScope.compRanking;
        }
        $scope.$broadcast("scroll.refreshComplete");
    });
    //console.log($scope.Competitions);
})

.controller('islScorersCtrl', function($scope, $location, $http, LoadingService,$rootScope){
    $scope.title= islScorersTitle;
    $scope.ISL_team = ISL_team;
    $scope.ISL_name = ISL_name;
    $scope.load_scorer = function(){
        try{
          var Scorer= JSON.parse(window.localStorage[ls_IslScorer]);
          //galert(Scorer);
          var PlayerDetails = JSON.parse(window.localStorage[ls_IslPlayerDetails]);
        }catch(e){
            var Scorer={};
            var PlayerDetails={}
        }
        for(var i=0;i<Scorer.length; i++){
            Scorer[i]['detail'] = PlayerDetails[Scorer[i]['id']];
        }
        $scope.Scorer = Scorer;
       
    }
    if(window.localStorage[ls_IslScorer]){
        $scope.load_scorer();
    } else{
        LoadingService.getIslScorer_Assist($scope);
    }
    $scope.doRefresh = function() {
        LoadingService.getIslScorer_Assist($scope);
    };
    
    $scope.$on('IslScorer_AssistLoaded', function(){
        $scope.load_scorer();
        $scope.$broadcast("scroll.refreshComplete");
       /* $scope.$apply(function(){
            // $scope.load_scorer();
        });*/
    });
    // $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    //   viewData.enableBack = true;
    // });
})

.controller('islAssistsCtrl', function($scope, $location, $http, LoadingService,$rootScope){
    $scope.title= islAssistsTitle;
    $scope.ISL_team = ISL_team;
    $scope.ISL_name = ISL_name;
    $scope.load_assist = function(){
        try{
          var Assist= JSON.parse(window.localStorage[ls_IslAssist]);
          var PlayerDetails = JSON.parse(window.localStorage[ls_IslPlayerDetails]);
        }catch(e){
             var Assist={};
             var PlayerDetails ={};
        }
        for(var i=0;i<Assist.length; i++){
            Assist[i]['detail'] = PlayerDetails[Assist[i]['id']];
        }
        $scope.Assist = Assist;
    }
    if(window.localStorage[ls_IslAssist]){
        $scope.load_assist();
    } else{
        LoadingService.getIslScorer_Assist($scope);
    }
    
    $scope.doRefresh = function() {
        LoadingService.getIslScorer_Assist($scope);
    };
    
    $scope.$on('IslScorer_AssistLoaded', function(){
        $scope.load_assist();
        $scope.$broadcast("scroll.refreshComplete");
        /*$scope.$apply(function(){
            // console.log($scope.Scorer);
        });*/
    });
    // $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    //   viewData.enableBack = true;
    // });
})

.controller('islStandingCtrl',function($scope){
    $scope.rankingWord =rankingWord;
    $scope.topScorersWord =topScorersWord;
    $scope.topAssistsWord =topAssistsWord;
    $scope.title= islRankingTitle;
})

.controller('Notifi_SettingsCtrl', function($scope,$rootScope,$ionicScrollDelegate){
    $scope.title=notifiSetting_title;
    $scope.NotifiMsg=NotifiMsg;
    $scope.topNewsMsg = topNewsMsg;
    $scope.matchesWord= matchesWord;
    $scope.highlightsWord =highlightsWord;
    $scope.goalsOnlyWord = goalsOnlyWord;
    $scope.noneWord=noneWord;
    $scope.videosWord = videosWord;
    $scope.mvpWord = mvpWord;
    
    if(window.localStorage[ls_matchesPreferences] != undefined){
        $scope.matchesPreferences= window.localStorage[ls_matchesPreferences];
    }else{
        $scope.matchesPreferences="notSelected";
    }
    $scope.$on("$ionicView.enter",function(){
        $(".teams-notif").hide();
            $scope.teamsShown=false;
    });
     //$scope.teamsShown=false;
    $scope.toggleTeams=function(){
        console.log($(".teams-notif"));
        if($scope.teamsShown){
            $(".teams-notif").hide();
            $ionicScrollDelegate.resize();
            $scope.teamsShown=false;
        }else{
            $(".teams-notif").show();
            $ionicScrollDelegate.resize();
            $scope.teamsShown=true;
        }
        
    };
    $scope.isTeamsShown=function(){
        return $scope.teamsShown;
    }
    document.getElementById("goalsInput").onclick= function(event){$scope.matchesPreferences= "goals";};
    document.getElementById("noneInput").onclick= function(event){$scope.matchesPreferences= "none"};
    document.getElementById("highlightsInput").onclick= function(event){$scope.matchesPreferences= "highlights"};
})

.controller('SponsorsCtrl', function($scope,$rootScope){
    $scope.title= sponsorsTitle;
   
})

.controller('ContactCtrl', function($scope,$rootScope){
    $scope.title= contactTitle;
   
});
